/* --- Elevator example --- */

mtype = { press_0, isPressed_0, reset_0, open_0, close_0, arriveAt_0, press_1, isPressed_1, reset_1, open_1, close_1, arriveAt_1, goUp, arriveAtNext, goDown, arriveAtPrev, stop };
chan button_0_in = [0] of { mtype };
chan button_0_out = [0] of { mtype };
chan button_1_in = [0] of { mtype };
chan button_1_out = [0] of { mtype };
chan door_0_in = [0] of { mtype };
chan door_0_out = [0] of { mtype };
chan door_1_in = [0] of { mtype };
chan door_1_out = [0] of { mtype };
chan elevator_in = [0] of { mtype };
chan elevator_out = [0] of { mtype };
chan floors = [0] of { mtype };

active proctype button_0()
{
	s0: if
			:: button_0_out!press_0;  goto s1;
		fi;
	s1: if
			:: button_0_out!isPressed_0;  goto s1;
			:: button_0_in?reset_0;  goto s0;
		fi;
}

active proctype door_0()
{
	s0: if
			:: door_0_in?open_0;  goto s1;
		fi;
	s1: if
			:: door_0_out!close_0;  goto s0;
		fi;
}

active proctype button_1()
{
	s0: if
			:: button_1_out!press_1;  goto s1;
		fi;
	s1: if
			:: button_1_out!isPressed_1;  goto s1;
			:: button_1_in?reset_1;  goto s0;
		fi;
}

active proctype door_1()
{
	s0: if
			:: door_1_in?open_1;  goto s1;
		fi;
	s1: if
			:: door_1_out!close_1;  goto s0;
		fi;
}

active proctype elevator()
{
	s0: if
			:: elevator_in?goUp;  goto s1;
			:: elevator_in?goDown;  goto s2;
		fi;
	s1: if
			:: elevator_in?stop;  goto s0;
			:: elevator_out!arriveAtNext;  goto s1;
		fi;
	s2: if
			:: elevator_in?stop;  goto s0;
			:: elevator_out!arriveAtPrev;  goto s2;
		fi;
}

active proctype env()
{
	s0: if
			:: button_0_out?press_0;  goto s0;
			:: button_1_out?press_1;  goto s0;
		fi;
}

active proctype floor_0()
{
	s0: if
			:: button_0_out?isPressed_0;  goto s3;
			:: button_1_out?isPressed_1;  goto s7;
		fi;
	s1: if
			:: floors?arriveAt_0;  goto s2;
		fi;
	s2: if
			:: button_0_out?isPressed_0;  goto s6;
		fi;
	s3: if
			:: door_0_in!open_0;  goto s4;
		fi;
	s4: if
			:: button_0_in!reset_0;  goto s5;
		fi;
	s5: if
			:: door_0_out?close_0;  goto s0;
		fi;
	s6: if
			:: elevator_in!stop;  goto s3;
		fi;
	s7: if
			:: elevator_in!goUp;  goto s8;
		fi;
	s8: if
			:: elevator_out?arriveAtNext;  goto s9;
		fi;
	s9: if
			:: floors!arriveAt_1;  goto s1;
		fi;
}

active proctype floor_1()
{
	s0: if
			:: floors?arriveAt_1;  goto s2;
		fi;
	s1: if
			:: button_1_out?isPressed_1;  goto s3;
			:: button_0_out?isPressed_0;  goto s7;
		fi;
	s2: if
			:: button_1_out?isPressed_1;  goto s6;
		fi;
	s3: if
			:: door_1_in!open_1;  goto s4;
		fi;
	s4: if
			:: button_1_in!reset_1;  goto s5;
		fi;
	s5: if
			:: door_1_out?close_1;  goto s1;
		fi;
	s6: if
			:: elevator_in!stop;  goto s3;
		fi;
	s7: if
			:: elevator_in!goDown;  goto s8;
		fi;
	s8: if
			:: elevator_out?arriveAtPrev;  goto s9;
		fi;
	s9: if
			:: floors!arriveAt_0;  goto s0;
		fi;
}

trace
{
	s0: if
			:: button_0_out?press_0;  goto s0;
			:: button_0_out?isPressed_0;  goto s0;
			:: button_0_in?reset_0;  goto s0;
			:: door_0_in?open_0;  goto s1;
			:: door_0_out?close_0;  goto s0;
			:: floors?arriveAt_0;  goto s0;
			:: button_1_out?press_1;  goto s0;
			:: button_1_out?isPressed_1;  goto s0;
			:: button_1_in?reset_1;  goto s0;
			:: door_1_out?close_1;  goto s0;
			:: floors?arriveAt_1;  goto s0;
			:: elevator_in?goUp;  goto s3;
			:: elevator_out?arriveAtNext;  goto s0;
			:: elevator_in?goDown;  goto s3;
			:: elevator_out?arriveAtPrev;  goto s0;
			:: elevator_in?stop;  goto s0;
		fi;
	s1: if
			:: button_0_out?press_0;  goto s1;
			:: button_0_out?isPressed_0;  goto s1;
			:: button_0_in?reset_0;  goto s1;
			:: door_0_in?open_0;  goto s1;
			:: door_0_out?close_0;  goto s0;
			:: floors?arriveAt_0;  goto s1;
			:: button_1_out?press_1;  goto s1;
			:: button_1_out?isPressed_1;  goto s1;
			:: button_1_in?reset_1;  goto s1;
			:: door_1_out?close_1;  goto s0;
			:: floors?arriveAt_1;  goto s1;
			:: elevator_in?stop;  goto s1;
		fi;
	s3: if
			:: button_0_out?press_0;  goto s3;
			:: button_0_out?isPressed_0;  goto s3;
			:: button_0_in?reset_0;  goto s3;
			:: door_0_out?close_0;  goto s3;
			:: floors?arriveAt_0;  goto s0;
			:: button_1_out?press_1;  goto s3;
			:: button_1_out?isPressed_1;  goto s3;
			:: button_1_in?reset_1;  goto s3;
			:: door_1_out?close_1;  goto s3;
			:: floors?arriveAt_1;  goto s4;
			:: elevator_in?goUp;  goto s3;
			:: elevator_out?arriveAtNext;  goto s3;
			:: elevator_in?goDown;  goto s3;
			:: elevator_out?arriveAtPrev;  goto s3;
			:: elevator_in?stop;  goto s3;
		fi;
	s4: if
			:: button_0_out?press_0;  goto s4;
			:: button_0_out?isPressed_0;  goto s4;
			:: button_0_in?reset_0;  goto s4;
			:: door_0_out?close_0;  goto s4;
			:: floors?arriveAt_0;  goto s4;
			:: button_1_out?press_1;  goto s4;
			:: button_1_out?isPressed_1;  goto s4;
			:: button_1_in?reset_1;  goto s4;
			:: door_1_in?open_1;  goto s5;
			:: door_1_out?close_1;  goto s4;
			:: floors?arriveAt_1;  goto s4;
			:: elevator_in?goUp;  goto s3;
			:: elevator_out?arriveAtNext;  goto s4;
			:: elevator_in?goDown;  goto s3;
			:: elevator_out?arriveAtPrev;  goto s4;
			:: elevator_in?stop;  goto s4;
		fi;
	s5: if
			:: button_0_out?press_0;  goto s5;
			:: button_0_out?isPressed_0;  goto s5;
			:: button_0_in?reset_0;  goto s5;
			:: door_0_out?close_0;  goto s4;
			:: floors?arriveAt_0;  goto s5;
			:: button_1_out?press_1;  goto s5;
			:: button_1_out?isPressed_1;  goto s5;
			:: button_1_in?reset_1;  goto s5;
			:: door_1_in?open_1;  goto s5;
			:: door_1_out?close_1;  goto s4;
			:: floors?arriveAt_1;  goto s5;
			:: elevator_in?stop;  goto s5;
		fi;
}
