/* --- Production cell example --- */

mtype = { g_bl_a, r_bl_a, g_st_a, r_st_a, g_bl_b, r_bl_b, g_st_b, r_st_b, notify_g_st_a, notify_r_bl_a, notify_g_st_b, notify_r_bl_b };
chan commandsA = [0] of { mtype };
chan commandsB = [0] of { mtype };
chan notifies = [0] of { mtype };
chan responsesA = [0] of { mtype };
chan responsesB = [0] of { mtype };

active proctype programA()
{
	s0: if
			:: notifies!notify_g_st_a;  goto s1;
			:: notifies?notify_g_st_b;  goto s2;
		fi;
	s1: if
			:: commandsA!g_st_a;  goto s3;
			:: notifies?notify_g_st_b;  goto s4;
		fi;
	s2: if
			:: notifies?notify_r_bl_b;  goto s0;
		fi;
	s3: if
			:: responsesA?r_st_a;  goto s5;
			:: notifies?notify_g_st_b;  goto s6;
		fi;
	s4: if
			:: commandsA!g_st_a;  goto s6;
			:: notifies?notify_r_bl_b;  goto s1;
		fi;
	s5: if
			:: commandsA!g_bl_a;  goto s7;
			:: notifies?notify_g_st_b;  goto s8;
		fi;
	s6: if
			:: responsesA?r_st_a;  goto s8;
			:: notifies?notify_r_bl_b;  goto s3;
		fi;
	s7: if
			:: responsesA?r_bl_a;  goto s9;
			:: notifies?notify_g_st_b;  goto s10;
		fi;
	s8: if
			:: commandsA!g_bl_a;  goto s10;
			:: notifies?notify_r_bl_b;  goto s5;
		fi;
	s9: if
			:: notifies!notify_r_bl_a;  goto s0;
			:: notifies?notify_g_st_b;  goto s11;
		fi;
	s10: if
			:: responsesA?r_bl_a;  goto s11;
			:: notifies?notify_r_bl_b;  goto s7;
		fi;
	s11: if
			:: notifies!notify_r_bl_a;  goto s2;
			:: notifies?notify_r_bl_b;  goto s9;
		fi;
}

active proctype robot_a()
{
	s0: if
			:: commandsA?g_st_a;  goto s2;
		fi;
	s1: if
			:: commandsA?g_bl_a;  goto s3;
		fi;
	s2: if
			:: responsesA!r_st_a;  goto s1;
		fi;
	s3: if
			:: responsesA!r_bl_a;  goto s0;
		fi;
}

active proctype programB()
{
	s0: if
			:: notifies?notify_g_st_a;  goto s1;
			:: notifies!notify_g_st_b;  goto s2;
		fi;
	s1: if
			:: notifies?notify_r_bl_a;  goto s0;
		fi;
	s2: if
			:: commandsB!g_st_b;  goto s4;
			:: notifies?notify_g_st_a;  goto s3;
		fi;
	s3: if
			:: commandsB!g_st_b;  goto s5;
			:: notifies?notify_r_bl_a;  goto s2;
		fi;
	s4: if
			:: responsesB?r_st_b;  goto s6;
			:: notifies?notify_g_st_a;  goto s5;
		fi;
	s5: if
			:: responsesB?r_st_b;  goto s7;
			:: notifies?notify_r_bl_a;  goto s4;
		fi;
	s6: if
			:: commandsB!g_bl_b;  goto s8;
			:: notifies?notify_g_st_a;  goto s7;
		fi;
	s7: if
			:: commandsB!g_bl_b;  goto s9;
			:: notifies?notify_r_bl_a;  goto s6;
		fi;
	s8: if
			:: responsesB?r_bl_b;  goto s10;
			:: notifies?notify_g_st_a;  goto s9;
		fi;
	s9: if
			:: responsesB?r_bl_b;  goto s11;
			:: notifies?notify_r_bl_a;  goto s8;
		fi;
	s10: if
			:: notifies?notify_g_st_a;  goto s11;
			:: notifies!notify_r_bl_b;  goto s0;
		fi;
	s11: if
			:: notifies?notify_r_bl_a;  goto s10;
			:: notifies!notify_r_bl_b;  goto s1;
		fi;
}

active proctype robot_b()
{
	s0: if
			:: commandsB?g_st_b;  goto s2;
		fi;
	s1: if
			:: commandsB?g_bl_b;  goto s3;
		fi;
	s2: if
			:: responsesB!r_st_b;  goto s1;
		fi;
	s3: if
			:: responsesB!r_bl_b;  goto s0;
		fi;
}

trace
{
	s0: if
			:: commandsA?g_bl_a;  goto s0;
			:: responsesA?r_bl_a;  goto s0;
			:: commandsA?g_st_a;  goto s1;
			:: responsesA?r_st_a;  goto s0;
			:: commandsB?g_bl_b;  goto s0;
			:: responsesB?r_bl_b;  goto s0;
			:: commandsB?g_st_b;  goto s2;
			:: responsesB?r_st_b;  goto s0;
			:: notifies?notify_g_st_a;  goto s0;
			:: notifies?notify_r_bl_a;  goto s0;
			:: notifies?notify_g_st_b;  goto s0;
			:: notifies?notify_r_bl_b;  goto s0;
		fi;
	s1: if
			:: commandsA?g_bl_a;  goto s1;
			:: responsesA?r_bl_a;  goto s0;
			:: commandsA?g_st_a;  goto s1;
			:: responsesA?r_st_a;  goto s1;
			:: commandsB?g_bl_b;  goto s1;
			:: responsesB?r_bl_b;  goto s1;
			:: responsesB?r_st_b;  goto s1;
			:: notifies?notify_g_st_a;  goto s1;
			:: notifies?notify_r_bl_a;  goto s1;
			:: notifies?notify_g_st_b;  goto s1;
			:: notifies?notify_r_bl_b;  goto s1;
		fi;
	s2: if
			:: commandsA?g_bl_a;  goto s2;
			:: responsesA?r_bl_a;  goto s2;
			:: responsesA?r_st_a;  goto s2;
			:: commandsB?g_bl_b;  goto s2;
			:: responsesB?r_bl_b;  goto s0;
			:: commandsB?g_st_b;  goto s2;
			:: responsesB?r_st_b;  goto s2;
			:: notifies?notify_g_st_a;  goto s2;
			:: notifies?notify_r_bl_a;  goto s2;
			:: notifies?notify_g_st_b;  goto s2;
			:: notifies?notify_r_bl_b;  goto s2;
		fi;
}
