/* --- Sliding window protocol --- */
/* Buffersize: 2 | Windowsize: 1 */

mtype = { msg0R, msg0W, msg0B, msg1R, msg1W, msg1B, ack0, ack1, inR, inW, inB, outR, outW, outB };
chan acks = [0] of { mtype };
chan in = [0] of { mtype };
chan msgs = [0] of { mtype };
chan out = [0] of { mtype };

active proctype sender()
{
	s1_0_0_00: if
			:: in?inR;  goto s1_0_1_R0;
			:: in?inW;  goto s1_0_1_W0;
			:: in?inB;  goto s1_0_1_B0;
		fi;
	s1_0_1_R0: if
			:: in?inR;  goto s1_0_0_RR;
			:: in?inW;  goto s1_0_0_RW;
			:: in?inB;  goto s1_0_0_RB;
			:: msgs!msg0R;  goto s1_0_1_R0;
			:: acks?ack0;  goto s1_1_1_00;
			:: acks?ack0;  goto s1_0_1_R0;
		fi;
	s1_0_1_W0: if
			:: in?inR;  goto s1_0_0_WR;
			:: in?inW;  goto s1_0_0_WW;
			:: in?inB;  goto s1_0_0_WB;
			:: msgs!msg0W;  goto s1_0_1_W0;
			:: acks?ack0;  goto s1_1_1_00;
			:: acks?ack0;  goto s1_0_1_W0;
		fi;
	s1_0_1_B0: if
			:: in?inR;  goto s1_0_0_BR;
			:: in?inW;  goto s1_0_0_BW;
			:: in?inB;  goto s1_0_0_BB;
			:: msgs!msg0B;  goto s1_0_1_B0;
			:: acks?ack0;  goto s1_1_1_00;
			:: acks?ack0;  goto s1_0_1_B0;
		fi;
	s1_0_0_RR: if
			:: msgs!msg0R;  goto s1_0_0_RR;
			:: acks?ack0;  goto s1_1_0_0R;
			:: acks?ack0;  goto s1_0_0_RR;
		fi;
	s1_0_0_RW: if
			:: msgs!msg0R;  goto s1_0_0_RW;
			:: acks?ack0;  goto s1_1_0_0W;
			:: acks?ack0;  goto s1_0_0_RW;
		fi;
	s1_0_0_RB: if
			:: msgs!msg0R;  goto s1_0_0_RB;
			:: acks?ack0;  goto s1_1_0_0B;
			:: acks?ack0;  goto s1_0_0_RB;
		fi;
	s1_1_1_00: if
			:: in?inR;  goto s1_1_0_0R;
			:: in?inW;  goto s1_1_0_0W;
			:: in?inB;  goto s1_1_0_0B;
		fi;
	s1_0_0_WR: if
			:: msgs!msg0W;  goto s1_0_0_WR;
			:: acks?ack0;  goto s1_1_0_0R;
			:: acks?ack0;  goto s1_0_0_WR;
		fi;
	s1_0_0_WW: if
			:: msgs!msg0W;  goto s1_0_0_WW;
			:: acks?ack0;  goto s1_1_0_0W;
			:: acks?ack0;  goto s1_0_0_WW;
		fi;
	s1_0_0_WB: if
			:: msgs!msg0W;  goto s1_0_0_WB;
			:: acks?ack0;  goto s1_1_0_0B;
			:: acks?ack0;  goto s1_0_0_WB;
		fi;
	s1_0_0_BR: if
			:: msgs!msg0B;  goto s1_0_0_BR;
			:: acks?ack0;  goto s1_1_0_0R;
			:: acks?ack0;  goto s1_0_0_BR;
		fi;
	s1_0_0_BW: if
			:: msgs!msg0B;  goto s1_0_0_BW;
			:: acks?ack0;  goto s1_1_0_0W;
			:: acks?ack0;  goto s1_0_0_BW;
		fi;
	s1_0_0_BB: if
			:: msgs!msg0B;  goto s1_0_0_BB;
			:: acks?ack0;  goto s1_1_0_0B;
			:: acks?ack0;  goto s1_0_0_BB;
		fi;
	s1_1_0_0R: if
			:: in?inR;  goto s1_1_1_RR;
			:: in?inW;  goto s1_1_1_WR;
			:: in?inB;  goto s1_1_1_BR;
			:: msgs!msg1R;  goto s1_1_0_0R;
			:: acks?ack1;  goto s1_0_0_00;
			:: acks?ack1;  goto s1_1_0_0R;
		fi;
	s1_1_0_0W: if
			:: in?inR;  goto s1_1_1_RW;
			:: in?inW;  goto s1_1_1_WW;
			:: in?inB;  goto s1_1_1_BW;
			:: msgs!msg1W;  goto s1_1_0_0W;
			:: acks?ack1;  goto s1_0_0_00;
			:: acks?ack1;  goto s1_1_0_0W;
		fi;
	s1_1_0_0B: if
			:: in?inR;  goto s1_1_1_RB;
			:: in?inW;  goto s1_1_1_WB;
			:: in?inB;  goto s1_1_1_BB;
			:: msgs!msg1B;  goto s1_1_0_0B;
			:: acks?ack1;  goto s1_0_0_00;
			:: acks?ack1;  goto s1_1_0_0B;
		fi;
	s1_1_1_RR: if
			:: msgs!msg1R;  goto s1_1_1_RR;
			:: acks?ack1;  goto s1_0_1_R0;
			:: acks?ack1;  goto s1_1_1_RR;
		fi;
	s1_1_1_WR: if
			:: msgs!msg1R;  goto s1_1_1_WR;
			:: acks?ack1;  goto s1_0_1_W0;
			:: acks?ack1;  goto s1_1_1_WR;
		fi;
	s1_1_1_BR: if
			:: msgs!msg1R;  goto s1_1_1_BR;
			:: acks?ack1;  goto s1_0_1_B0;
			:: acks?ack1;  goto s1_1_1_BR;
		fi;
	s1_1_1_RW: if
			:: msgs!msg1W;  goto s1_1_1_RW;
			:: acks?ack1;  goto s1_0_1_R0;
			:: acks?ack1;  goto s1_1_1_RW;
		fi;
	s1_1_1_WW: if
			:: msgs!msg1W;  goto s1_1_1_WW;
			:: acks?ack1;  goto s1_0_1_W0;
			:: acks?ack1;  goto s1_1_1_WW;
		fi;
	s1_1_1_BW: if
			:: msgs!msg1W;  goto s1_1_1_BW;
			:: acks?ack1;  goto s1_0_1_B0;
			:: acks?ack1;  goto s1_1_1_BW;
		fi;
	s1_1_1_RB: if
			:: msgs!msg1B;  goto s1_1_1_RB;
			:: acks?ack1;  goto s1_0_1_R0;
			:: acks?ack1;  goto s1_1_1_RB;
		fi;
	s1_1_1_WB: if
			:: msgs!msg1B;  goto s1_1_1_WB;
			:: acks?ack1;  goto s1_0_1_W0;
			:: acks?ack1;  goto s1_1_1_WB;
		fi;
	s1_1_1_BB: if
			:: msgs!msg1B;  goto s1_1_1_BB;
			:: acks?ack1;  goto s1_0_1_B0;
			:: acks?ack1;  goto s1_1_1_BB;
		fi;
}

active proctype receiver()
{
	s0_0_0_00: if
			:: msgs?msg0R;  goto s0_0_0_R0;
			:: msgs?msg0R;  goto s0_0_0_00;
			:: msgs?msg0W;  goto s0_0_0_W0;
			:: msgs?msg0W;  goto s0_0_0_00;
			:: msgs?msg0B;  goto s0_0_0_B0;
			:: msgs?msg0B;  goto s0_0_0_00;
			:: msgs?msg1R;  goto s0_0_0_0R;
			:: msgs?msg1R;  goto s0_0_0_00;
			:: msgs?msg1W;  goto s0_0_0_0W;
			:: msgs?msg1W;  goto s0_0_0_00;
			:: msgs?msg1B;  goto s0_0_0_0B;
			:: msgs?msg1B;  goto s0_0_0_00;
		fi;
	s0_0_0_R0: if
			:: out!outR;  goto s1_1_1_00;
			:: msgs?msg0R;  goto s0_0_0_R0;
			:: msgs?msg0W;  goto s0_0_0_W0;
			:: msgs?msg0W;  goto s0_0_0_R0;
			:: msgs?msg0B;  goto s0_0_0_B0;
			:: msgs?msg0B;  goto s0_0_0_R0;
			:: msgs?msg1R;  goto s0_0_0_RR;
			:: msgs?msg1R;  goto s0_0_0_R0;
			:: msgs?msg1W;  goto s0_0_0_RW;
			:: msgs?msg1W;  goto s0_0_0_R0;
			:: msgs?msg1B;  goto s0_0_0_RB;
			:: msgs?msg1B;  goto s0_0_0_R0;
		fi;
	s0_0_0_W0: if
			:: out!outW;  goto s1_1_1_00;
			:: msgs?msg0R;  goto s0_0_0_R0;
			:: msgs?msg0R;  goto s0_0_0_W0;
			:: msgs?msg0W;  goto s0_0_0_W0;
			:: msgs?msg0B;  goto s0_0_0_B0;
			:: msgs?msg0B;  goto s0_0_0_W0;
			:: msgs?msg1R;  goto s0_0_0_WR;
			:: msgs?msg1R;  goto s0_0_0_W0;
			:: msgs?msg1W;  goto s0_0_0_WW;
			:: msgs?msg1W;  goto s0_0_0_W0;
			:: msgs?msg1B;  goto s0_0_0_WB;
			:: msgs?msg1B;  goto s0_0_0_W0;
		fi;
	s0_0_0_B0: if
			:: out!outB;  goto s1_1_1_00;
			:: msgs?msg0R;  goto s0_0_0_R0;
			:: msgs?msg0R;  goto s0_0_0_B0;
			:: msgs?msg0W;  goto s0_0_0_W0;
			:: msgs?msg0W;  goto s0_0_0_B0;
			:: msgs?msg0B;  goto s0_0_0_B0;
			:: msgs?msg1R;  goto s0_0_0_BR;
			:: msgs?msg1R;  goto s0_0_0_B0;
			:: msgs?msg1W;  goto s0_0_0_BW;
			:: msgs?msg1W;  goto s0_0_0_B0;
			:: msgs?msg1B;  goto s0_0_0_BB;
			:: msgs?msg1B;  goto s0_0_0_B0;
		fi;
	s0_0_0_0R: if
			:: msgs?msg0R;  goto s0_0_0_RR;
			:: msgs?msg0R;  goto s0_0_0_0R;
			:: msgs?msg0W;  goto s0_0_0_WR;
			:: msgs?msg0W;  goto s0_0_0_0R;
			:: msgs?msg0B;  goto s0_0_0_BR;
			:: msgs?msg0B;  goto s0_0_0_0R;
			:: msgs?msg1R;  goto s0_0_0_0R;
			:: msgs?msg1W;  goto s0_0_0_0W;
			:: msgs?msg1W;  goto s0_0_0_0R;
			:: msgs?msg1B;  goto s0_0_0_0B;
			:: msgs?msg1B;  goto s0_0_0_0R;
		fi;
	s0_0_0_0W: if
			:: msgs?msg0R;  goto s0_0_0_RW;
			:: msgs?msg0R;  goto s0_0_0_0W;
			:: msgs?msg0W;  goto s0_0_0_WW;
			:: msgs?msg0W;  goto s0_0_0_0W;
			:: msgs?msg0B;  goto s0_0_0_BW;
			:: msgs?msg0B;  goto s0_0_0_0W;
			:: msgs?msg1R;  goto s0_0_0_0R;
			:: msgs?msg1R;  goto s0_0_0_0W;
			:: msgs?msg1W;  goto s0_0_0_0W;
			:: msgs?msg1B;  goto s0_0_0_0B;
			:: msgs?msg1B;  goto s0_0_0_0W;
		fi;
	s0_0_0_0B: if
			:: msgs?msg0R;  goto s0_0_0_RB;
			:: msgs?msg0R;  goto s0_0_0_0B;
			:: msgs?msg0W;  goto s0_0_0_WB;
			:: msgs?msg0W;  goto s0_0_0_0B;
			:: msgs?msg0B;  goto s0_0_0_BB;
			:: msgs?msg0B;  goto s0_0_0_0B;
			:: msgs?msg1R;  goto s0_0_0_0R;
			:: msgs?msg1R;  goto s0_0_0_0B;
			:: msgs?msg1W;  goto s0_0_0_0W;
			:: msgs?msg1W;  goto s0_0_0_0B;
			:: msgs?msg1B;  goto s0_0_0_0B;
		fi;
	s1_1_1_00: if
			:: acks!ack0;  goto s1_1_1_00;
			:: msgs?msg0R;  goto s1_1_1_R0;
			:: msgs?msg0R;  goto s1_1_1_00;
			:: msgs?msg0W;  goto s1_1_1_W0;
			:: msgs?msg0W;  goto s1_1_1_00;
			:: msgs?msg0B;  goto s1_1_1_B0;
			:: msgs?msg0B;  goto s1_1_1_00;
			:: msgs?msg1R;  goto s1_1_1_0R;
			:: msgs?msg1R;  goto s1_1_1_00;
			:: msgs?msg1W;  goto s1_1_1_0W;
			:: msgs?msg1W;  goto s1_1_1_00;
			:: msgs?msg1B;  goto s1_1_1_0B;
			:: msgs?msg1B;  goto s1_1_1_00;
		fi;
	s0_0_0_RR: if
			:: out!outR;  goto s1_1_1_0R;
			:: msgs?msg0R;  goto s0_0_0_RR;
			:: msgs?msg0W;  goto s0_0_0_WR;
			:: msgs?msg0W;  goto s0_0_0_RR;
			:: msgs?msg0B;  goto s0_0_0_BR;
			:: msgs?msg0B;  goto s0_0_0_RR;
			:: msgs?msg1R;  goto s0_0_0_RR;
			:: msgs?msg1W;  goto s0_0_0_RW;
			:: msgs?msg1W;  goto s0_0_0_RR;
			:: msgs?msg1B;  goto s0_0_0_RB;
			:: msgs?msg1B;  goto s0_0_0_RR;
		fi;
	s0_0_0_RW: if
			:: out!outR;  goto s1_1_1_0W;
			:: msgs?msg0R;  goto s0_0_0_RW;
			:: msgs?msg0W;  goto s0_0_0_WW;
			:: msgs?msg0W;  goto s0_0_0_RW;
			:: msgs?msg0B;  goto s0_0_0_BW;
			:: msgs?msg0B;  goto s0_0_0_RW;
			:: msgs?msg1R;  goto s0_0_0_RR;
			:: msgs?msg1R;  goto s0_0_0_RW;
			:: msgs?msg1W;  goto s0_0_0_RW;
			:: msgs?msg1B;  goto s0_0_0_RB;
			:: msgs?msg1B;  goto s0_0_0_RW;
		fi;
	s0_0_0_RB: if
			:: out!outR;  goto s1_1_1_0B;
			:: msgs?msg0R;  goto s0_0_0_RB;
			:: msgs?msg0W;  goto s0_0_0_WB;
			:: msgs?msg0W;  goto s0_0_0_RB;
			:: msgs?msg0B;  goto s0_0_0_BB;
			:: msgs?msg0B;  goto s0_0_0_RB;
			:: msgs?msg1R;  goto s0_0_0_RR;
			:: msgs?msg1R;  goto s0_0_0_RB;
			:: msgs?msg1W;  goto s0_0_0_RW;
			:: msgs?msg1W;  goto s0_0_0_RB;
			:: msgs?msg1B;  goto s0_0_0_RB;
		fi;
	s0_0_0_WR: if
			:: out!outW;  goto s1_1_1_0R;
			:: msgs?msg0R;  goto s0_0_0_RR;
			:: msgs?msg0R;  goto s0_0_0_WR;
			:: msgs?msg0W;  goto s0_0_0_WR;
			:: msgs?msg0B;  goto s0_0_0_BR;
			:: msgs?msg0B;  goto s0_0_0_WR;
			:: msgs?msg1R;  goto s0_0_0_WR;
			:: msgs?msg1W;  goto s0_0_0_WW;
			:: msgs?msg1W;  goto s0_0_0_WR;
			:: msgs?msg1B;  goto s0_0_0_WB;
			:: msgs?msg1B;  goto s0_0_0_WR;
		fi;
	s0_0_0_WW: if
			:: out!outW;  goto s1_1_1_0W;
			:: msgs?msg0R;  goto s0_0_0_RW;
			:: msgs?msg0R;  goto s0_0_0_WW;
			:: msgs?msg0W;  goto s0_0_0_WW;
			:: msgs?msg0B;  goto s0_0_0_BW;
			:: msgs?msg0B;  goto s0_0_0_WW;
			:: msgs?msg1R;  goto s0_0_0_WR;
			:: msgs?msg1R;  goto s0_0_0_WW;
			:: msgs?msg1W;  goto s0_0_0_WW;
			:: msgs?msg1B;  goto s0_0_0_WB;
			:: msgs?msg1B;  goto s0_0_0_WW;
		fi;
	s0_0_0_WB: if
			:: out!outW;  goto s1_1_1_0B;
			:: msgs?msg0R;  goto s0_0_0_RB;
			:: msgs?msg0R;  goto s0_0_0_WB;
			:: msgs?msg0W;  goto s0_0_0_WB;
			:: msgs?msg0B;  goto s0_0_0_BB;
			:: msgs?msg0B;  goto s0_0_0_WB;
			:: msgs?msg1R;  goto s0_0_0_WR;
			:: msgs?msg1R;  goto s0_0_0_WB;
			:: msgs?msg1W;  goto s0_0_0_WW;
			:: msgs?msg1W;  goto s0_0_0_WB;
			:: msgs?msg1B;  goto s0_0_0_WB;
		fi;
	s0_0_0_BR: if
			:: out!outB;  goto s1_1_1_0R;
			:: msgs?msg0R;  goto s0_0_0_RR;
			:: msgs?msg0R;  goto s0_0_0_BR;
			:: msgs?msg0W;  goto s0_0_0_WR;
			:: msgs?msg0W;  goto s0_0_0_BR;
			:: msgs?msg0B;  goto s0_0_0_BR;
			:: msgs?msg1R;  goto s0_0_0_BR;
			:: msgs?msg1W;  goto s0_0_0_BW;
			:: msgs?msg1W;  goto s0_0_0_BR;
			:: msgs?msg1B;  goto s0_0_0_BB;
			:: msgs?msg1B;  goto s0_0_0_BR;
		fi;
	s0_0_0_BW: if
			:: out!outB;  goto s1_1_1_0W;
			:: msgs?msg0R;  goto s0_0_0_RW;
			:: msgs?msg0R;  goto s0_0_0_BW;
			:: msgs?msg0W;  goto s0_0_0_WW;
			:: msgs?msg0W;  goto s0_0_0_BW;
			:: msgs?msg0B;  goto s0_0_0_BW;
			:: msgs?msg1R;  goto s0_0_0_BR;
			:: msgs?msg1R;  goto s0_0_0_BW;
			:: msgs?msg1W;  goto s0_0_0_BW;
			:: msgs?msg1B;  goto s0_0_0_BB;
			:: msgs?msg1B;  goto s0_0_0_BW;
		fi;
	s0_0_0_BB: if
			:: out!outB;  goto s1_1_1_0B;
			:: msgs?msg0R;  goto s0_0_0_RB;
			:: msgs?msg0R;  goto s0_0_0_BB;
			:: msgs?msg0W;  goto s0_0_0_WB;
			:: msgs?msg0W;  goto s0_0_0_BB;
			:: msgs?msg0B;  goto s0_0_0_BB;
			:: msgs?msg1R;  goto s0_0_0_BR;
			:: msgs?msg1R;  goto s0_0_0_BB;
			:: msgs?msg1W;  goto s0_0_0_BW;
			:: msgs?msg1W;  goto s0_0_0_BB;
			:: msgs?msg1B;  goto s0_0_0_BB;
		fi;
	s1_1_1_R0: if
			:: acks!ack0;  goto s1_1_1_R0;
			:: msgs?msg0R;  goto s1_1_1_R0;
			:: msgs?msg0W;  goto s1_1_1_W0;
			:: msgs?msg0W;  goto s1_1_1_R0;
			:: msgs?msg0B;  goto s1_1_1_B0;
			:: msgs?msg0B;  goto s1_1_1_R0;
			:: msgs?msg1R;  goto s1_1_1_RR;
			:: msgs?msg1R;  goto s1_1_1_R0;
			:: msgs?msg1W;  goto s1_1_1_RW;
			:: msgs?msg1W;  goto s1_1_1_R0;
			:: msgs?msg1B;  goto s1_1_1_RB;
			:: msgs?msg1B;  goto s1_1_1_R0;
		fi;
	s1_1_1_W0: if
			:: acks!ack0;  goto s1_1_1_W0;
			:: msgs?msg0R;  goto s1_1_1_R0;
			:: msgs?msg0R;  goto s1_1_1_W0;
			:: msgs?msg0W;  goto s1_1_1_W0;
			:: msgs?msg0B;  goto s1_1_1_B0;
			:: msgs?msg0B;  goto s1_1_1_W0;
			:: msgs?msg1R;  goto s1_1_1_WR;
			:: msgs?msg1R;  goto s1_1_1_W0;
			:: msgs?msg1W;  goto s1_1_1_WW;
			:: msgs?msg1W;  goto s1_1_1_W0;
			:: msgs?msg1B;  goto s1_1_1_WB;
			:: msgs?msg1B;  goto s1_1_1_W0;
		fi;
	s1_1_1_B0: if
			:: acks!ack0;  goto s1_1_1_B0;
			:: msgs?msg0R;  goto s1_1_1_R0;
			:: msgs?msg0R;  goto s1_1_1_B0;
			:: msgs?msg0W;  goto s1_1_1_W0;
			:: msgs?msg0W;  goto s1_1_1_B0;
			:: msgs?msg0B;  goto s1_1_1_B0;
			:: msgs?msg1R;  goto s1_1_1_BR;
			:: msgs?msg1R;  goto s1_1_1_B0;
			:: msgs?msg1W;  goto s1_1_1_BW;
			:: msgs?msg1W;  goto s1_1_1_B0;
			:: msgs?msg1B;  goto s1_1_1_BB;
			:: msgs?msg1B;  goto s1_1_1_B0;
		fi;
	s1_1_1_0R: if
			:: out!outR;  goto s1_0_0_00;
			:: msgs?msg0R;  goto s1_1_1_RR;
			:: msgs?msg0R;  goto s1_1_1_0R;
			:: msgs?msg0W;  goto s1_1_1_WR;
			:: msgs?msg0W;  goto s1_1_1_0R;
			:: msgs?msg0B;  goto s1_1_1_BR;
			:: msgs?msg0B;  goto s1_1_1_0R;
			:: msgs?msg1R;  goto s1_1_1_0R;
			:: msgs?msg1W;  goto s1_1_1_0W;
			:: msgs?msg1W;  goto s1_1_1_0R;
			:: msgs?msg1B;  goto s1_1_1_0B;
			:: msgs?msg1B;  goto s1_1_1_0R;
		fi;
	s1_1_1_0W: if
			:: out!outW;  goto s1_0_0_00;
			:: msgs?msg0R;  goto s1_1_1_RW;
			:: msgs?msg0R;  goto s1_1_1_0W;
			:: msgs?msg0W;  goto s1_1_1_WW;
			:: msgs?msg0W;  goto s1_1_1_0W;
			:: msgs?msg0B;  goto s1_1_1_BW;
			:: msgs?msg0B;  goto s1_1_1_0W;
			:: msgs?msg1R;  goto s1_1_1_0R;
			:: msgs?msg1R;  goto s1_1_1_0W;
			:: msgs?msg1W;  goto s1_1_1_0W;
			:: msgs?msg1B;  goto s1_1_1_0B;
			:: msgs?msg1B;  goto s1_1_1_0W;
		fi;
	s1_1_1_0B: if
			:: out!outB;  goto s1_0_0_00;
			:: msgs?msg0R;  goto s1_1_1_RB;
			:: msgs?msg0R;  goto s1_1_1_0B;
			:: msgs?msg0W;  goto s1_1_1_WB;
			:: msgs?msg0W;  goto s1_1_1_0B;
			:: msgs?msg0B;  goto s1_1_1_BB;
			:: msgs?msg0B;  goto s1_1_1_0B;
			:: msgs?msg1R;  goto s1_1_1_0R;
			:: msgs?msg1R;  goto s1_1_1_0B;
			:: msgs?msg1W;  goto s1_1_1_0W;
			:: msgs?msg1W;  goto s1_1_1_0B;
			:: msgs?msg1B;  goto s1_1_1_0B;
		fi;
	s1_1_1_RR: if
			:: out!outR;  goto s1_0_0_R0;
			:: msgs?msg0R;  goto s1_1_1_RR;
			:: msgs?msg0W;  goto s1_1_1_WR;
			:: msgs?msg0W;  goto s1_1_1_RR;
			:: msgs?msg0B;  goto s1_1_1_BR;
			:: msgs?msg0B;  goto s1_1_1_RR;
			:: msgs?msg1R;  goto s1_1_1_RR;
			:: msgs?msg1W;  goto s1_1_1_RW;
			:: msgs?msg1W;  goto s1_1_1_RR;
			:: msgs?msg1B;  goto s1_1_1_RB;
			:: msgs?msg1B;  goto s1_1_1_RR;
		fi;
	s1_1_1_RW: if
			:: out!outW;  goto s1_0_0_R0;
			:: msgs?msg0R;  goto s1_1_1_RW;
			:: msgs?msg0W;  goto s1_1_1_WW;
			:: msgs?msg0W;  goto s1_1_1_RW;
			:: msgs?msg0B;  goto s1_1_1_BW;
			:: msgs?msg0B;  goto s1_1_1_RW;
			:: msgs?msg1R;  goto s1_1_1_RR;
			:: msgs?msg1R;  goto s1_1_1_RW;
			:: msgs?msg1W;  goto s1_1_1_RW;
			:: msgs?msg1B;  goto s1_1_1_RB;
			:: msgs?msg1B;  goto s1_1_1_RW;
		fi;
	s1_1_1_RB: if
			:: out!outB;  goto s1_0_0_R0;
			:: msgs?msg0R;  goto s1_1_1_RB;
			:: msgs?msg0W;  goto s1_1_1_WB;
			:: msgs?msg0W;  goto s1_1_1_RB;
			:: msgs?msg0B;  goto s1_1_1_BB;
			:: msgs?msg0B;  goto s1_1_1_RB;
			:: msgs?msg1R;  goto s1_1_1_RR;
			:: msgs?msg1R;  goto s1_1_1_RB;
			:: msgs?msg1W;  goto s1_1_1_RW;
			:: msgs?msg1W;  goto s1_1_1_RB;
			:: msgs?msg1B;  goto s1_1_1_RB;
		fi;
	s1_1_1_WR: if
			:: out!outR;  goto s1_0_0_W0;
			:: msgs?msg0R;  goto s1_1_1_RR;
			:: msgs?msg0R;  goto s1_1_1_WR;
			:: msgs?msg0W;  goto s1_1_1_WR;
			:: msgs?msg0B;  goto s1_1_1_BR;
			:: msgs?msg0B;  goto s1_1_1_WR;
			:: msgs?msg1R;  goto s1_1_1_WR;
			:: msgs?msg1W;  goto s1_1_1_WW;
			:: msgs?msg1W;  goto s1_1_1_WR;
			:: msgs?msg1B;  goto s1_1_1_WB;
			:: msgs?msg1B;  goto s1_1_1_WR;
		fi;
	s1_1_1_WW: if
			:: out!outW;  goto s1_0_0_W0;
			:: msgs?msg0R;  goto s1_1_1_RW;
			:: msgs?msg0R;  goto s1_1_1_WW;
			:: msgs?msg0W;  goto s1_1_1_WW;
			:: msgs?msg0B;  goto s1_1_1_BW;
			:: msgs?msg0B;  goto s1_1_1_WW;
			:: msgs?msg1R;  goto s1_1_1_WR;
			:: msgs?msg1R;  goto s1_1_1_WW;
			:: msgs?msg1W;  goto s1_1_1_WW;
			:: msgs?msg1B;  goto s1_1_1_WB;
			:: msgs?msg1B;  goto s1_1_1_WW;
		fi;
	s1_1_1_WB: if
			:: out!outB;  goto s1_0_0_W0;
			:: msgs?msg0R;  goto s1_1_1_RB;
			:: msgs?msg0R;  goto s1_1_1_WB;
			:: msgs?msg0W;  goto s1_1_1_WB;
			:: msgs?msg0B;  goto s1_1_1_BB;
			:: msgs?msg0B;  goto s1_1_1_WB;
			:: msgs?msg1R;  goto s1_1_1_WR;
			:: msgs?msg1R;  goto s1_1_1_WB;
			:: msgs?msg1W;  goto s1_1_1_WW;
			:: msgs?msg1W;  goto s1_1_1_WB;
			:: msgs?msg1B;  goto s1_1_1_WB;
		fi;
	s1_1_1_BR: if
			:: out!outR;  goto s1_0_0_B0;
			:: msgs?msg0R;  goto s1_1_1_RR;
			:: msgs?msg0R;  goto s1_1_1_BR;
			:: msgs?msg0W;  goto s1_1_1_WR;
			:: msgs?msg0W;  goto s1_1_1_BR;
			:: msgs?msg0B;  goto s1_1_1_BR;
			:: msgs?msg1R;  goto s1_1_1_BR;
			:: msgs?msg1W;  goto s1_1_1_BW;
			:: msgs?msg1W;  goto s1_1_1_BR;
			:: msgs?msg1B;  goto s1_1_1_BB;
			:: msgs?msg1B;  goto s1_1_1_BR;
		fi;
	s1_1_1_BW: if
			:: out!outW;  goto s1_0_0_B0;
			:: msgs?msg0R;  goto s1_1_1_RW;
			:: msgs?msg0R;  goto s1_1_1_BW;
			:: msgs?msg0W;  goto s1_1_1_WW;
			:: msgs?msg0W;  goto s1_1_1_BW;
			:: msgs?msg0B;  goto s1_1_1_BW;
			:: msgs?msg1R;  goto s1_1_1_BR;
			:: msgs?msg1R;  goto s1_1_1_BW;
			:: msgs?msg1W;  goto s1_1_1_BW;
			:: msgs?msg1B;  goto s1_1_1_BB;
			:: msgs?msg1B;  goto s1_1_1_BW;
		fi;
	s1_1_1_BB: if
			:: out!outB;  goto s1_0_0_B0;
			:: msgs?msg0R;  goto s1_1_1_RB;
			:: msgs?msg0R;  goto s1_1_1_BB;
			:: msgs?msg0W;  goto s1_1_1_WB;
			:: msgs?msg0W;  goto s1_1_1_BB;
			:: msgs?msg0B;  goto s1_1_1_BB;
			:: msgs?msg1R;  goto s1_1_1_BR;
			:: msgs?msg1R;  goto s1_1_1_BB;
			:: msgs?msg1W;  goto s1_1_1_BW;
			:: msgs?msg1W;  goto s1_1_1_BB;
			:: msgs?msg1B;  goto s1_1_1_BB;
		fi;
	s1_0_0_00: if
			:: acks!ack1;  goto s1_0_0_00;
			:: msgs?msg0R;  goto s1_0_0_R0;
			:: msgs?msg0R;  goto s1_0_0_00;
			:: msgs?msg0W;  goto s1_0_0_W0;
			:: msgs?msg0W;  goto s1_0_0_00;
			:: msgs?msg0B;  goto s1_0_0_B0;
			:: msgs?msg0B;  goto s1_0_0_00;
			:: msgs?msg1R;  goto s1_0_0_0R;
			:: msgs?msg1R;  goto s1_0_0_00;
			:: msgs?msg1W;  goto s1_0_0_0W;
			:: msgs?msg1W;  goto s1_0_0_00;
			:: msgs?msg1B;  goto s1_0_0_0B;
			:: msgs?msg1B;  goto s1_0_0_00;
		fi;
	s1_0_0_R0: if
			:: out!outR;  goto s1_1_1_00;
			:: msgs?msg0R;  goto s1_0_0_R0;
			:: msgs?msg0W;  goto s1_0_0_W0;
			:: msgs?msg0W;  goto s1_0_0_R0;
			:: msgs?msg0B;  goto s1_0_0_B0;
			:: msgs?msg0B;  goto s1_0_0_R0;
			:: msgs?msg1R;  goto s1_0_0_RR;
			:: msgs?msg1R;  goto s1_0_0_R0;
			:: msgs?msg1W;  goto s1_0_0_RW;
			:: msgs?msg1W;  goto s1_0_0_R0;
			:: msgs?msg1B;  goto s1_0_0_RB;
			:: msgs?msg1B;  goto s1_0_0_R0;
		fi;
	s1_0_0_W0: if
			:: out!outW;  goto s1_1_1_00;
			:: msgs?msg0R;  goto s1_0_0_R0;
			:: msgs?msg0R;  goto s1_0_0_W0;
			:: msgs?msg0W;  goto s1_0_0_W0;
			:: msgs?msg0B;  goto s1_0_0_B0;
			:: msgs?msg0B;  goto s1_0_0_W0;
			:: msgs?msg1R;  goto s1_0_0_WR;
			:: msgs?msg1R;  goto s1_0_0_W0;
			:: msgs?msg1W;  goto s1_0_0_WW;
			:: msgs?msg1W;  goto s1_0_0_W0;
			:: msgs?msg1B;  goto s1_0_0_WB;
			:: msgs?msg1B;  goto s1_0_0_W0;
		fi;
	s1_0_0_B0: if
			:: out!outB;  goto s1_1_1_00;
			:: msgs?msg0R;  goto s1_0_0_R0;
			:: msgs?msg0R;  goto s1_0_0_B0;
			:: msgs?msg0W;  goto s1_0_0_W0;
			:: msgs?msg0W;  goto s1_0_0_B0;
			:: msgs?msg0B;  goto s1_0_0_B0;
			:: msgs?msg1R;  goto s1_0_0_BR;
			:: msgs?msg1R;  goto s1_0_0_B0;
			:: msgs?msg1W;  goto s1_0_0_BW;
			:: msgs?msg1W;  goto s1_0_0_B0;
			:: msgs?msg1B;  goto s1_0_0_BB;
			:: msgs?msg1B;  goto s1_0_0_B0;
		fi;
	s1_0_0_0R: if
			:: acks!ack1;  goto s1_0_0_0R;
			:: msgs?msg0R;  goto s1_0_0_RR;
			:: msgs?msg0R;  goto s1_0_0_0R;
			:: msgs?msg0W;  goto s1_0_0_WR;
			:: msgs?msg0W;  goto s1_0_0_0R;
			:: msgs?msg0B;  goto s1_0_0_BR;
			:: msgs?msg0B;  goto s1_0_0_0R;
			:: msgs?msg1R;  goto s1_0_0_0R;
			:: msgs?msg1W;  goto s1_0_0_0W;
			:: msgs?msg1W;  goto s1_0_0_0R;
			:: msgs?msg1B;  goto s1_0_0_0B;
			:: msgs?msg1B;  goto s1_0_0_0R;
		fi;
	s1_0_0_0W: if
			:: acks!ack1;  goto s1_0_0_0W;
			:: msgs?msg0R;  goto s1_0_0_RW;
			:: msgs?msg0R;  goto s1_0_0_0W;
			:: msgs?msg0W;  goto s1_0_0_WW;
			:: msgs?msg0W;  goto s1_0_0_0W;
			:: msgs?msg0B;  goto s1_0_0_BW;
			:: msgs?msg0B;  goto s1_0_0_0W;
			:: msgs?msg1R;  goto s1_0_0_0R;
			:: msgs?msg1R;  goto s1_0_0_0W;
			:: msgs?msg1W;  goto s1_0_0_0W;
			:: msgs?msg1B;  goto s1_0_0_0B;
			:: msgs?msg1B;  goto s1_0_0_0W;
		fi;
	s1_0_0_0B: if
			:: acks!ack1;  goto s1_0_0_0B;
			:: msgs?msg0R;  goto s1_0_0_RB;
			:: msgs?msg0R;  goto s1_0_0_0B;
			:: msgs?msg0W;  goto s1_0_0_WB;
			:: msgs?msg0W;  goto s1_0_0_0B;
			:: msgs?msg0B;  goto s1_0_0_BB;
			:: msgs?msg0B;  goto s1_0_0_0B;
			:: msgs?msg1R;  goto s1_0_0_0R;
			:: msgs?msg1R;  goto s1_0_0_0B;
			:: msgs?msg1W;  goto s1_0_0_0W;
			:: msgs?msg1W;  goto s1_0_0_0B;
			:: msgs?msg1B;  goto s1_0_0_0B;
		fi;
	s1_0_0_RR: if
			:: out!outR;  goto s1_1_1_0R;
			:: msgs?msg0R;  goto s1_0_0_RR;
			:: msgs?msg0W;  goto s1_0_0_WR;
			:: msgs?msg0W;  goto s1_0_0_RR;
			:: msgs?msg0B;  goto s1_0_0_BR;
			:: msgs?msg0B;  goto s1_0_0_RR;
			:: msgs?msg1R;  goto s1_0_0_RR;
			:: msgs?msg1W;  goto s1_0_0_RW;
			:: msgs?msg1W;  goto s1_0_0_RR;
			:: msgs?msg1B;  goto s1_0_0_RB;
			:: msgs?msg1B;  goto s1_0_0_RR;
		fi;
	s1_0_0_RW: if
			:: out!outR;  goto s1_1_1_0W;
			:: msgs?msg0R;  goto s1_0_0_RW;
			:: msgs?msg0W;  goto s1_0_0_WW;
			:: msgs?msg0W;  goto s1_0_0_RW;
			:: msgs?msg0B;  goto s1_0_0_BW;
			:: msgs?msg0B;  goto s1_0_0_RW;
			:: msgs?msg1R;  goto s1_0_0_RR;
			:: msgs?msg1R;  goto s1_0_0_RW;
			:: msgs?msg1W;  goto s1_0_0_RW;
			:: msgs?msg1B;  goto s1_0_0_RB;
			:: msgs?msg1B;  goto s1_0_0_RW;
		fi;
	s1_0_0_RB: if
			:: out!outR;  goto s1_1_1_0B;
			:: msgs?msg0R;  goto s1_0_0_RB;
			:: msgs?msg0W;  goto s1_0_0_WB;
			:: msgs?msg0W;  goto s1_0_0_RB;
			:: msgs?msg0B;  goto s1_0_0_BB;
			:: msgs?msg0B;  goto s1_0_0_RB;
			:: msgs?msg1R;  goto s1_0_0_RR;
			:: msgs?msg1R;  goto s1_0_0_RB;
			:: msgs?msg1W;  goto s1_0_0_RW;
			:: msgs?msg1W;  goto s1_0_0_RB;
			:: msgs?msg1B;  goto s1_0_0_RB;
		fi;
	s1_0_0_WR: if
			:: out!outW;  goto s1_1_1_0R;
			:: msgs?msg0R;  goto s1_0_0_RR;
			:: msgs?msg0R;  goto s1_0_0_WR;
			:: msgs?msg0W;  goto s1_0_0_WR;
			:: msgs?msg0B;  goto s1_0_0_BR;
			:: msgs?msg0B;  goto s1_0_0_WR;
			:: msgs?msg1R;  goto s1_0_0_WR;
			:: msgs?msg1W;  goto s1_0_0_WW;
			:: msgs?msg1W;  goto s1_0_0_WR;
			:: msgs?msg1B;  goto s1_0_0_WB;
			:: msgs?msg1B;  goto s1_0_0_WR;
		fi;
	s1_0_0_WW: if
			:: out!outW;  goto s1_1_1_0W;
			:: msgs?msg0R;  goto s1_0_0_RW;
			:: msgs?msg0R;  goto s1_0_0_WW;
			:: msgs?msg0W;  goto s1_0_0_WW;
			:: msgs?msg0B;  goto s1_0_0_BW;
			:: msgs?msg0B;  goto s1_0_0_WW;
			:: msgs?msg1R;  goto s1_0_0_WR;
			:: msgs?msg1R;  goto s1_0_0_WW;
			:: msgs?msg1W;  goto s1_0_0_WW;
			:: msgs?msg1B;  goto s1_0_0_WB;
			:: msgs?msg1B;  goto s1_0_0_WW;
		fi;
	s1_0_0_WB: if
			:: out!outW;  goto s1_1_1_0B;
			:: msgs?msg0R;  goto s1_0_0_RB;
			:: msgs?msg0R;  goto s1_0_0_WB;
			:: msgs?msg0W;  goto s1_0_0_WB;
			:: msgs?msg0B;  goto s1_0_0_BB;
			:: msgs?msg0B;  goto s1_0_0_WB;
			:: msgs?msg1R;  goto s1_0_0_WR;
			:: msgs?msg1R;  goto s1_0_0_WB;
			:: msgs?msg1W;  goto s1_0_0_WW;
			:: msgs?msg1W;  goto s1_0_0_WB;
			:: msgs?msg1B;  goto s1_0_0_WB;
		fi;
	s1_0_0_BR: if
			:: out!outB;  goto s1_1_1_0R;
			:: msgs?msg0R;  goto s1_0_0_RR;
			:: msgs?msg0R;  goto s1_0_0_BR;
			:: msgs?msg0W;  goto s1_0_0_WR;
			:: msgs?msg0W;  goto s1_0_0_BR;
			:: msgs?msg0B;  goto s1_0_0_BR;
			:: msgs?msg1R;  goto s1_0_0_BR;
			:: msgs?msg1W;  goto s1_0_0_BW;
			:: msgs?msg1W;  goto s1_0_0_BR;
			:: msgs?msg1B;  goto s1_0_0_BB;
			:: msgs?msg1B;  goto s1_0_0_BR;
		fi;
	s1_0_0_BW: if
			:: out!outB;  goto s1_1_1_0W;
			:: msgs?msg0R;  goto s1_0_0_RW;
			:: msgs?msg0R;  goto s1_0_0_BW;
			:: msgs?msg0W;  goto s1_0_0_WW;
			:: msgs?msg0W;  goto s1_0_0_BW;
			:: msgs?msg0B;  goto s1_0_0_BW;
			:: msgs?msg1R;  goto s1_0_0_BR;
			:: msgs?msg1R;  goto s1_0_0_BW;
			:: msgs?msg1W;  goto s1_0_0_BW;
			:: msgs?msg1B;  goto s1_0_0_BB;
			:: msgs?msg1B;  goto s1_0_0_BW;
		fi;
	s1_0_0_BB: if
			:: out!outB;  goto s1_1_1_0B;
			:: msgs?msg0R;  goto s1_0_0_RB;
			:: msgs?msg0R;  goto s1_0_0_BB;
			:: msgs?msg0W;  goto s1_0_0_WB;
			:: msgs?msg0W;  goto s1_0_0_BB;
			:: msgs?msg0B;  goto s1_0_0_BB;
			:: msgs?msg1R;  goto s1_0_0_BR;
			:: msgs?msg1R;  goto s1_0_0_BB;
			:: msgs?msg1W;  goto s1_0_0_BW;
			:: msgs?msg1W;  goto s1_0_0_BB;
			:: msgs?msg1B;  goto s1_0_0_BB;
		fi;
}

active proctype env()
{
	s0: if
			:: in!inR;  goto s0;
			:: in!inW;  goto s0;
			:: in!inB;  goto s0;
			:: out?outR;  goto s0;
			:: out?outW;  goto s0;
			:: out?outB;  goto s0;
		fi;
}

trace
{
	s0: if
			:: msgs?msg0R;  goto s0;
			:: msgs?msg0W;  goto s0;
			:: msgs?msg0B;  goto s0;
			:: msgs?msg1R;  goto s0;
			:: msgs?msg1W;  goto s0;
			:: msgs?msg1B;  goto s0;
			:: acks?ack0;  goto s0;
			:: acks?ack1;  goto s0;
			:: in?inR;  goto s0;
			:: in?inW;  goto s0;
			:: in?inB;  goto s0;
			:: out?outW;  goto s0;
			:: out?outB;  goto s0;
		fi;
}
