/* --- Workflow example --- */

mtype = { informP0, doThisP0b, doThatP0b, doThisP0s, doThatP0s, finishedP0, informP1, doThisP1b, doThatP1b, doThisP1s, doThatP1s, finishedP1, initWorkflow, dispatch, rollout, supplement, informController, finishedController };
chan externalCom = [0] of { mtype };
chan workflowCom = [0] of { mtype };

active proctype participant_0()
{
	s0: if
			:: workflowCom?informP0;  goto s1;
			:: externalCom!doThisP0s;  goto s2;
		fi;
	s1: if
			:: externalCom!doThisP0b;  goto s3;
			:: externalCom!doThisP0s;  goto s4;
		fi;
	s2: if
			:: workflowCom?informP0;  goto s4;
			:: externalCom!doThatP0s;  goto s0;
		fi;
	s3: if
			:: externalCom!doThatP0b;  goto s5;
			:: externalCom!doThisP0s;  goto s6;
		fi;
	s4: if
			:: externalCom!doThisP0b;  goto s6;
			:: externalCom!doThatP0s;  goto s1;
		fi;
	s5: if
			:: externalCom!doThisP0s;  goto s7;
			:: workflowCom!finishedP0;  goto s0;
		fi;
	s6: if
			:: externalCom!doThatP0b;  goto s7;
			:: externalCom!doThatP0s;  goto s3;
		fi;
	s7: if
			:: externalCom!doThatP0s;  goto s5;
			:: workflowCom!finishedP0;  goto s2;
		fi;
}

active proctype participant_1()
{
	s0: if
			:: workflowCom?informP1;  goto s1;
			:: externalCom!doThisP1s;  goto s2;
		fi;
	s1: if
			:: externalCom!doThisP1b;  goto s3;
			:: externalCom!doThisP1s;  goto s4;
		fi;
	s2: if
			:: workflowCom?informP1;  goto s4;
			:: externalCom!doThatP1s;  goto s0;
		fi;
	s3: if
			:: externalCom!doThatP1b;  goto s5;
			:: externalCom!doThisP1s;  goto s6;
		fi;
	s4: if
			:: externalCom!doThisP1b;  goto s6;
			:: externalCom!doThatP1s;  goto s1;
		fi;
	s5: if
			:: externalCom!doThisP1s;  goto s7;
			:: workflowCom!finishedP1;  goto s0;
		fi;
	s6: if
			:: externalCom!doThatP1b;  goto s7;
			:: externalCom!doThatP1s;  goto s3;
		fi;
	s7: if
			:: externalCom!doThatP1s;  goto s5;
			:: workflowCom!finishedP1;  goto s2;
		fi;
}

active proctype workflow()
{
	s0: if
			:: externalCom!initWorkflow;  goto s1;
		fi;
	s1: if
			:: externalCom!dispatch;  goto s2;
		fi;
	s2: if
			:: workflowCom!informP0;  goto s3;
		fi;
	s3: if
			:: workflowCom!informP1;  goto s4;
		fi;
	s4: if
			:: workflowCom?finishedP0;  goto s5;
			:: workflowCom?finishedP1;  goto s6;
		fi;
	s5: if
			:: workflowCom?finishedP1;  goto s7;
		fi;
	s6: if
			:: workflowCom?finishedP0;  goto s7;
		fi;
	s7: if
			:: externalCom!informController;  goto s8;
		fi;
	s8: if
			:: externalCom?finishedController;  goto s9;
		fi;
	s9: if
			:: externalCom!rollout;  goto s10;
		fi;
	s10: if
			:: externalCom!supplement;  goto s2;
		fi;
}

active proctype env()
{
	s0: if
			:: externalCom!supplement;  goto s0;
			:: externalCom!finishedController;  goto s0;
			:: externalCom?doThisP0b;  goto s0;
			:: externalCom?doThatP0b;  goto s0;
			:: externalCom?doThisP0s;  goto s0;
			:: externalCom?doThatP0s;  goto s0;
			:: externalCom?doThisP1b;  goto s0;
			:: externalCom?doThatP1b;  goto s0;
			:: externalCom?doThisP1s;  goto s0;
			:: externalCom?doThatP1s;  goto s0;
			:: externalCom?initWorkflow;  goto s0;
			:: externalCom?dispatch;  goto s0;
			:: externalCom?rollout;  goto s0;
			:: externalCom?informController;  goto s0;
		fi;
}

trace
{
	s0: if
			:: workflowCom?informP0;  goto s0;
			:: externalCom?doThisP0b;  goto s0;
			:: externalCom?doThatP0b;  goto s0;
			:: externalCom?doThisP0s;  goto s0;
			:: externalCom?doThatP0s;  goto s0;
			:: workflowCom?finishedP0;  goto s0;
			:: workflowCom?informP1;  goto s0;
			:: externalCom?doThisP1b;  goto s0;
			:: externalCom?doThatP1b;  goto s0;
			:: externalCom?doThisP1s;  goto s0;
			:: externalCom?doThatP1s;  goto s0;
			:: workflowCom?finishedP1;  goto s0;
			:: externalCom?initWorkflow;  goto s0;
			:: externalCom?dispatch;  goto s1;
			:: externalCom?rollout;  goto s0;
			:: externalCom?supplement;  goto s0;
			:: externalCom?informController;  goto s0;
			:: externalCom?finishedController;  goto s0;
		fi;
	s1: if
			:: workflowCom?informP0;  goto s1;
			:: externalCom?doThisP0b;  goto s1;
			:: externalCom?doThatP0b;  goto s1;
			:: externalCom?doThisP0s;  goto s1;
			:: externalCom?doThatP0s;  goto s1;
			:: workflowCom?finishedP0;  goto s1;
			:: workflowCom?informP1;  goto s1;
			:: externalCom?doThisP1b;  goto s1;
			:: externalCom?doThatP1b;  goto s1;
			:: externalCom?doThisP1s;  goto s1;
			:: externalCom?doThatP1s;  goto s1;
			:: workflowCom?finishedP1;  goto s1;
			:: externalCom?initWorkflow;  goto s1;
			:: externalCom?dispatch;  goto s1;
			:: externalCom?supplement;  goto s1;
			:: externalCom?informController;  goto s1;
			:: externalCom?finishedController;  goto s0;
		fi;
}
