/* --- Sliding window protocol --- */
/* Buffersize: 3 | Windowsize: 1 */

mtype = { msg0R, msg0W, msg0B, msg1R, msg1W, msg1B, msg2R, msg2W, msg2B, ack0, ack1, ack2, inR, inW, inB, outR, outW, outB };
chan acks = [0] of { mtype };
chan in = [0] of { mtype };
chan msgs = [0] of { mtype };
chan out = [0] of { mtype };

active proctype sender()
{
	s1_0_0_000: if
			:: in?inR;  goto s1_0_1_R00;
			:: in?inW;  goto s1_0_1_W00;
			:: in?inB;  goto s1_0_1_B00;
		fi;
	s1_0_1_R00: if
			:: in?inR;  goto s1_0_2_RR0;
			:: in?inW;  goto s1_0_2_RW0;
			:: in?inB;  goto s1_0_2_RB0;
			:: msgs!msg0R;  goto s1_0_1_R00;
			:: acks?ack0;  goto s1_1_1_000;
			:: acks?ack0;  goto s1_0_1_R00;
		fi;
	s1_0_1_W00: if
			:: in?inR;  goto s1_0_2_WR0;
			:: in?inW;  goto s1_0_2_WW0;
			:: in?inB;  goto s1_0_2_WB0;
			:: msgs!msg0W;  goto s1_0_1_W00;
			:: acks?ack0;  goto s1_1_1_000;
			:: acks?ack0;  goto s1_0_1_W00;
		fi;
	s1_0_1_B00: if
			:: in?inR;  goto s1_0_2_BR0;
			:: in?inW;  goto s1_0_2_BW0;
			:: in?inB;  goto s1_0_2_BB0;
			:: msgs!msg0B;  goto s1_0_1_B00;
			:: acks?ack0;  goto s1_1_1_000;
			:: acks?ack0;  goto s1_0_1_B00;
		fi;
	s1_0_2_RR0: if
			:: in?inR;  goto s1_0_0_RRR;
			:: in?inW;  goto s1_0_0_RRW;
			:: in?inB;  goto s1_0_0_RRB;
			:: msgs!msg0R;  goto s1_0_2_RR0;
			:: acks?ack0;  goto s1_1_2_0R0;
			:: acks?ack0;  goto s1_0_2_RR0;
		fi;
	s1_0_2_RW0: if
			:: in?inR;  goto s1_0_0_RWR;
			:: in?inW;  goto s1_0_0_RWW;
			:: in?inB;  goto s1_0_0_RWB;
			:: msgs!msg0R;  goto s1_0_2_RW0;
			:: acks?ack0;  goto s1_1_2_0W0;
			:: acks?ack0;  goto s1_0_2_RW0;
		fi;
	s1_0_2_RB0: if
			:: in?inR;  goto s1_0_0_RBR;
			:: in?inW;  goto s1_0_0_RBW;
			:: in?inB;  goto s1_0_0_RBB;
			:: msgs!msg0R;  goto s1_0_2_RB0;
			:: acks?ack0;  goto s1_1_2_0B0;
			:: acks?ack0;  goto s1_0_2_RB0;
		fi;
	s1_1_1_000: if
			:: in?inR;  goto s1_1_2_0R0;
			:: in?inW;  goto s1_1_2_0W0;
			:: in?inB;  goto s1_1_2_0B0;
		fi;
	s1_0_2_WR0: if
			:: in?inR;  goto s1_0_0_WRR;
			:: in?inW;  goto s1_0_0_WRW;
			:: in?inB;  goto s1_0_0_WRB;
			:: msgs!msg0W;  goto s1_0_2_WR0;
			:: acks?ack0;  goto s1_1_2_0R0;
			:: acks?ack0;  goto s1_0_2_WR0;
		fi;
	s1_0_2_WW0: if
			:: in?inR;  goto s1_0_0_WWR;
			:: in?inW;  goto s1_0_0_WWW;
			:: in?inB;  goto s1_0_0_WWB;
			:: msgs!msg0W;  goto s1_0_2_WW0;
			:: acks?ack0;  goto s1_1_2_0W0;
			:: acks?ack0;  goto s1_0_2_WW0;
		fi;
	s1_0_2_WB0: if
			:: in?inR;  goto s1_0_0_WBR;
			:: in?inW;  goto s1_0_0_WBW;
			:: in?inB;  goto s1_0_0_WBB;
			:: msgs!msg0W;  goto s1_0_2_WB0;
			:: acks?ack0;  goto s1_1_2_0B0;
			:: acks?ack0;  goto s1_0_2_WB0;
		fi;
	s1_0_2_BR0: if
			:: in?inR;  goto s1_0_0_BRR;
			:: in?inW;  goto s1_0_0_BRW;
			:: in?inB;  goto s1_0_0_BRB;
			:: msgs!msg0B;  goto s1_0_2_BR0;
			:: acks?ack0;  goto s1_1_2_0R0;
			:: acks?ack0;  goto s1_0_2_BR0;
		fi;
	s1_0_2_BW0: if
			:: in?inR;  goto s1_0_0_BWR;
			:: in?inW;  goto s1_0_0_BWW;
			:: in?inB;  goto s1_0_0_BWB;
			:: msgs!msg0B;  goto s1_0_2_BW0;
			:: acks?ack0;  goto s1_1_2_0W0;
			:: acks?ack0;  goto s1_0_2_BW0;
		fi;
	s1_0_2_BB0: if
			:: in?inR;  goto s1_0_0_BBR;
			:: in?inW;  goto s1_0_0_BBW;
			:: in?inB;  goto s1_0_0_BBB;
			:: msgs!msg0B;  goto s1_0_2_BB0;
			:: acks?ack0;  goto s1_1_2_0B0;
			:: acks?ack0;  goto s1_0_2_BB0;
		fi;
	s1_0_0_RRR: if
			:: msgs!msg0R;  goto s1_0_0_RRR;
			:: acks?ack0;  goto s1_1_0_0RR;
			:: acks?ack0;  goto s1_0_0_RRR;
		fi;
	s1_0_0_RRW: if
			:: msgs!msg0R;  goto s1_0_0_RRW;
			:: acks?ack0;  goto s1_1_0_0RW;
			:: acks?ack0;  goto s1_0_0_RRW;
		fi;
	s1_0_0_RRB: if
			:: msgs!msg0R;  goto s1_0_0_RRB;
			:: acks?ack0;  goto s1_1_0_0RB;
			:: acks?ack0;  goto s1_0_0_RRB;
		fi;
	s1_1_2_0R0: if
			:: in?inR;  goto s1_1_0_0RR;
			:: in?inW;  goto s1_1_0_0RW;
			:: in?inB;  goto s1_1_0_0RB;
			:: msgs!msg1R;  goto s1_1_2_0R0;
			:: acks?ack1;  goto s1_2_2_000;
			:: acks?ack1;  goto s1_1_2_0R0;
		fi;
	s1_0_0_RWR: if
			:: msgs!msg0R;  goto s1_0_0_RWR;
			:: acks?ack0;  goto s1_1_0_0WR;
			:: acks?ack0;  goto s1_0_0_RWR;
		fi;
	s1_0_0_RWW: if
			:: msgs!msg0R;  goto s1_0_0_RWW;
			:: acks?ack0;  goto s1_1_0_0WW;
			:: acks?ack0;  goto s1_0_0_RWW;
		fi;
	s1_0_0_RWB: if
			:: msgs!msg0R;  goto s1_0_0_RWB;
			:: acks?ack0;  goto s1_1_0_0WB;
			:: acks?ack0;  goto s1_0_0_RWB;
		fi;
	s1_1_2_0W0: if
			:: in?inR;  goto s1_1_0_0WR;
			:: in?inW;  goto s1_1_0_0WW;
			:: in?inB;  goto s1_1_0_0WB;
			:: msgs!msg1W;  goto s1_1_2_0W0;
			:: acks?ack1;  goto s1_2_2_000;
			:: acks?ack1;  goto s1_1_2_0W0;
		fi;
	s1_0_0_RBR: if
			:: msgs!msg0R;  goto s1_0_0_RBR;
			:: acks?ack0;  goto s1_1_0_0BR;
			:: acks?ack0;  goto s1_0_0_RBR;
		fi;
	s1_0_0_RBW: if
			:: msgs!msg0R;  goto s1_0_0_RBW;
			:: acks?ack0;  goto s1_1_0_0BW;
			:: acks?ack0;  goto s1_0_0_RBW;
		fi;
	s1_0_0_RBB: if
			:: msgs!msg0R;  goto s1_0_0_RBB;
			:: acks?ack0;  goto s1_1_0_0BB;
			:: acks?ack0;  goto s1_0_0_RBB;
		fi;
	s1_1_2_0B0: if
			:: in?inR;  goto s1_1_0_0BR;
			:: in?inW;  goto s1_1_0_0BW;
			:: in?inB;  goto s1_1_0_0BB;
			:: msgs!msg1B;  goto s1_1_2_0B0;
			:: acks?ack1;  goto s1_2_2_000;
			:: acks?ack1;  goto s1_1_2_0B0;
		fi;
	s1_0_0_WRR: if
			:: msgs!msg0W;  goto s1_0_0_WRR;
			:: acks?ack0;  goto s1_1_0_0RR;
			:: acks?ack0;  goto s1_0_0_WRR;
		fi;
	s1_0_0_WRW: if
			:: msgs!msg0W;  goto s1_0_0_WRW;
			:: acks?ack0;  goto s1_1_0_0RW;
			:: acks?ack0;  goto s1_0_0_WRW;
		fi;
	s1_0_0_WRB: if
			:: msgs!msg0W;  goto s1_0_0_WRB;
			:: acks?ack0;  goto s1_1_0_0RB;
			:: acks?ack0;  goto s1_0_0_WRB;
		fi;
	s1_0_0_WWR: if
			:: msgs!msg0W;  goto s1_0_0_WWR;
			:: acks?ack0;  goto s1_1_0_0WR;
			:: acks?ack0;  goto s1_0_0_WWR;
		fi;
	s1_0_0_WWW: if
			:: msgs!msg0W;  goto s1_0_0_WWW;
			:: acks?ack0;  goto s1_1_0_0WW;
			:: acks?ack0;  goto s1_0_0_WWW;
		fi;
	s1_0_0_WWB: if
			:: msgs!msg0W;  goto s1_0_0_WWB;
			:: acks?ack0;  goto s1_1_0_0WB;
			:: acks?ack0;  goto s1_0_0_WWB;
		fi;
	s1_0_0_WBR: if
			:: msgs!msg0W;  goto s1_0_0_WBR;
			:: acks?ack0;  goto s1_1_0_0BR;
			:: acks?ack0;  goto s1_0_0_WBR;
		fi;
	s1_0_0_WBW: if
			:: msgs!msg0W;  goto s1_0_0_WBW;
			:: acks?ack0;  goto s1_1_0_0BW;
			:: acks?ack0;  goto s1_0_0_WBW;
		fi;
	s1_0_0_WBB: if
			:: msgs!msg0W;  goto s1_0_0_WBB;
			:: acks?ack0;  goto s1_1_0_0BB;
			:: acks?ack0;  goto s1_0_0_WBB;
		fi;
	s1_0_0_BRR: if
			:: msgs!msg0B;  goto s1_0_0_BRR;
			:: acks?ack0;  goto s1_1_0_0RR;
			:: acks?ack0;  goto s1_0_0_BRR;
		fi;
	s1_0_0_BRW: if
			:: msgs!msg0B;  goto s1_0_0_BRW;
			:: acks?ack0;  goto s1_1_0_0RW;
			:: acks?ack0;  goto s1_0_0_BRW;
		fi;
	s1_0_0_BRB: if
			:: msgs!msg0B;  goto s1_0_0_BRB;
			:: acks?ack0;  goto s1_1_0_0RB;
			:: acks?ack0;  goto s1_0_0_BRB;
		fi;
	s1_0_0_BWR: if
			:: msgs!msg0B;  goto s1_0_0_BWR;
			:: acks?ack0;  goto s1_1_0_0WR;
			:: acks?ack0;  goto s1_0_0_BWR;
		fi;
	s1_0_0_BWW: if
			:: msgs!msg0B;  goto s1_0_0_BWW;
			:: acks?ack0;  goto s1_1_0_0WW;
			:: acks?ack0;  goto s1_0_0_BWW;
		fi;
	s1_0_0_BWB: if
			:: msgs!msg0B;  goto s1_0_0_BWB;
			:: acks?ack0;  goto s1_1_0_0WB;
			:: acks?ack0;  goto s1_0_0_BWB;
		fi;
	s1_0_0_BBR: if
			:: msgs!msg0B;  goto s1_0_0_BBR;
			:: acks?ack0;  goto s1_1_0_0BR;
			:: acks?ack0;  goto s1_0_0_BBR;
		fi;
	s1_0_0_BBW: if
			:: msgs!msg0B;  goto s1_0_0_BBW;
			:: acks?ack0;  goto s1_1_0_0BW;
			:: acks?ack0;  goto s1_0_0_BBW;
		fi;
	s1_0_0_BBB: if
			:: msgs!msg0B;  goto s1_0_0_BBB;
			:: acks?ack0;  goto s1_1_0_0BB;
			:: acks?ack0;  goto s1_0_0_BBB;
		fi;
	s1_1_0_0RR: if
			:: in?inR;  goto s1_1_1_RRR;
			:: in?inW;  goto s1_1_1_WRR;
			:: in?inB;  goto s1_1_1_BRR;
			:: msgs!msg1R;  goto s1_1_0_0RR;
			:: acks?ack1;  goto s1_2_0_00R;
			:: acks?ack1;  goto s1_1_0_0RR;
		fi;
	s1_1_0_0RW: if
			:: in?inR;  goto s1_1_1_RRW;
			:: in?inW;  goto s1_1_1_WRW;
			:: in?inB;  goto s1_1_1_BRW;
			:: msgs!msg1R;  goto s1_1_0_0RW;
			:: acks?ack1;  goto s1_2_0_00W;
			:: acks?ack1;  goto s1_1_0_0RW;
		fi;
	s1_1_0_0RB: if
			:: in?inR;  goto s1_1_1_RRB;
			:: in?inW;  goto s1_1_1_WRB;
			:: in?inB;  goto s1_1_1_BRB;
			:: msgs!msg1R;  goto s1_1_0_0RB;
			:: acks?ack1;  goto s1_2_0_00B;
			:: acks?ack1;  goto s1_1_0_0RB;
		fi;
	s1_2_2_000: if
			:: in?inR;  goto s1_2_0_00R;
			:: in?inW;  goto s1_2_0_00W;
			:: in?inB;  goto s1_2_0_00B;
		fi;
	s1_1_0_0WR: if
			:: in?inR;  goto s1_1_1_RWR;
			:: in?inW;  goto s1_1_1_WWR;
			:: in?inB;  goto s1_1_1_BWR;
			:: msgs!msg1W;  goto s1_1_0_0WR;
			:: acks?ack1;  goto s1_2_0_00R;
			:: acks?ack1;  goto s1_1_0_0WR;
		fi;
	s1_1_0_0WW: if
			:: in?inR;  goto s1_1_1_RWW;
			:: in?inW;  goto s1_1_1_WWW;
			:: in?inB;  goto s1_1_1_BWW;
			:: msgs!msg1W;  goto s1_1_0_0WW;
			:: acks?ack1;  goto s1_2_0_00W;
			:: acks?ack1;  goto s1_1_0_0WW;
		fi;
	s1_1_0_0WB: if
			:: in?inR;  goto s1_1_1_RWB;
			:: in?inW;  goto s1_1_1_WWB;
			:: in?inB;  goto s1_1_1_BWB;
			:: msgs!msg1W;  goto s1_1_0_0WB;
			:: acks?ack1;  goto s1_2_0_00B;
			:: acks?ack1;  goto s1_1_0_0WB;
		fi;
	s1_1_0_0BR: if
			:: in?inR;  goto s1_1_1_RBR;
			:: in?inW;  goto s1_1_1_WBR;
			:: in?inB;  goto s1_1_1_BBR;
			:: msgs!msg1B;  goto s1_1_0_0BR;
			:: acks?ack1;  goto s1_2_0_00R;
			:: acks?ack1;  goto s1_1_0_0BR;
		fi;
	s1_1_0_0BW: if
			:: in?inR;  goto s1_1_1_RBW;
			:: in?inW;  goto s1_1_1_WBW;
			:: in?inB;  goto s1_1_1_BBW;
			:: msgs!msg1B;  goto s1_1_0_0BW;
			:: acks?ack1;  goto s1_2_0_00W;
			:: acks?ack1;  goto s1_1_0_0BW;
		fi;
	s1_1_0_0BB: if
			:: in?inR;  goto s1_1_1_RBB;
			:: in?inW;  goto s1_1_1_WBB;
			:: in?inB;  goto s1_1_1_BBB;
			:: msgs!msg1B;  goto s1_1_0_0BB;
			:: acks?ack1;  goto s1_2_0_00B;
			:: acks?ack1;  goto s1_1_0_0BB;
		fi;
	s1_1_1_RRR: if
			:: msgs!msg1R;  goto s1_1_1_RRR;
			:: acks?ack1;  goto s1_2_1_R0R;
			:: acks?ack1;  goto s1_1_1_RRR;
		fi;
	s1_1_1_WRR: if
			:: msgs!msg1R;  goto s1_1_1_WRR;
			:: acks?ack1;  goto s1_2_1_W0R;
			:: acks?ack1;  goto s1_1_1_WRR;
		fi;
	s1_1_1_BRR: if
			:: msgs!msg1R;  goto s1_1_1_BRR;
			:: acks?ack1;  goto s1_2_1_B0R;
			:: acks?ack1;  goto s1_1_1_BRR;
		fi;
	s1_2_0_00R: if
			:: in?inR;  goto s1_2_1_R0R;
			:: in?inW;  goto s1_2_1_W0R;
			:: in?inB;  goto s1_2_1_B0R;
			:: msgs!msg2R;  goto s1_2_0_00R;
			:: acks?ack2;  goto s1_0_0_000;
			:: acks?ack2;  goto s1_2_0_00R;
		fi;
	s1_1_1_RRW: if
			:: msgs!msg1R;  goto s1_1_1_RRW;
			:: acks?ack1;  goto s1_2_1_R0W;
			:: acks?ack1;  goto s1_1_1_RRW;
		fi;
	s1_1_1_WRW: if
			:: msgs!msg1R;  goto s1_1_1_WRW;
			:: acks?ack1;  goto s1_2_1_W0W;
			:: acks?ack1;  goto s1_1_1_WRW;
		fi;
	s1_1_1_BRW: if
			:: msgs!msg1R;  goto s1_1_1_BRW;
			:: acks?ack1;  goto s1_2_1_B0W;
			:: acks?ack1;  goto s1_1_1_BRW;
		fi;
	s1_2_0_00W: if
			:: in?inR;  goto s1_2_1_R0W;
			:: in?inW;  goto s1_2_1_W0W;
			:: in?inB;  goto s1_2_1_B0W;
			:: msgs!msg2W;  goto s1_2_0_00W;
			:: acks?ack2;  goto s1_0_0_000;
			:: acks?ack2;  goto s1_2_0_00W;
		fi;
	s1_1_1_RRB: if
			:: msgs!msg1R;  goto s1_1_1_RRB;
			:: acks?ack1;  goto s1_2_1_R0B;
			:: acks?ack1;  goto s1_1_1_RRB;
		fi;
	s1_1_1_WRB: if
			:: msgs!msg1R;  goto s1_1_1_WRB;
			:: acks?ack1;  goto s1_2_1_W0B;
			:: acks?ack1;  goto s1_1_1_WRB;
		fi;
	s1_1_1_BRB: if
			:: msgs!msg1R;  goto s1_1_1_BRB;
			:: acks?ack1;  goto s1_2_1_B0B;
			:: acks?ack1;  goto s1_1_1_BRB;
		fi;
	s1_2_0_00B: if
			:: in?inR;  goto s1_2_1_R0B;
			:: in?inW;  goto s1_2_1_W0B;
			:: in?inB;  goto s1_2_1_B0B;
			:: msgs!msg2B;  goto s1_2_0_00B;
			:: acks?ack2;  goto s1_0_0_000;
			:: acks?ack2;  goto s1_2_0_00B;
		fi;
	s1_1_1_RWR: if
			:: msgs!msg1W;  goto s1_1_1_RWR;
			:: acks?ack1;  goto s1_2_1_R0R;
			:: acks?ack1;  goto s1_1_1_RWR;
		fi;
	s1_1_1_WWR: if
			:: msgs!msg1W;  goto s1_1_1_WWR;
			:: acks?ack1;  goto s1_2_1_W0R;
			:: acks?ack1;  goto s1_1_1_WWR;
		fi;
	s1_1_1_BWR: if
			:: msgs!msg1W;  goto s1_1_1_BWR;
			:: acks?ack1;  goto s1_2_1_B0R;
			:: acks?ack1;  goto s1_1_1_BWR;
		fi;
	s1_1_1_RWW: if
			:: msgs!msg1W;  goto s1_1_1_RWW;
			:: acks?ack1;  goto s1_2_1_R0W;
			:: acks?ack1;  goto s1_1_1_RWW;
		fi;
	s1_1_1_WWW: if
			:: msgs!msg1W;  goto s1_1_1_WWW;
			:: acks?ack1;  goto s1_2_1_W0W;
			:: acks?ack1;  goto s1_1_1_WWW;
		fi;
	s1_1_1_BWW: if
			:: msgs!msg1W;  goto s1_1_1_BWW;
			:: acks?ack1;  goto s1_2_1_B0W;
			:: acks?ack1;  goto s1_1_1_BWW;
		fi;
	s1_1_1_RWB: if
			:: msgs!msg1W;  goto s1_1_1_RWB;
			:: acks?ack1;  goto s1_2_1_R0B;
			:: acks?ack1;  goto s1_1_1_RWB;
		fi;
	s1_1_1_WWB: if
			:: msgs!msg1W;  goto s1_1_1_WWB;
			:: acks?ack1;  goto s1_2_1_W0B;
			:: acks?ack1;  goto s1_1_1_WWB;
		fi;
	s1_1_1_BWB: if
			:: msgs!msg1W;  goto s1_1_1_BWB;
			:: acks?ack1;  goto s1_2_1_B0B;
			:: acks?ack1;  goto s1_1_1_BWB;
		fi;
	s1_1_1_RBR: if
			:: msgs!msg1B;  goto s1_1_1_RBR;
			:: acks?ack1;  goto s1_2_1_R0R;
			:: acks?ack1;  goto s1_1_1_RBR;
		fi;
	s1_1_1_WBR: if
			:: msgs!msg1B;  goto s1_1_1_WBR;
			:: acks?ack1;  goto s1_2_1_W0R;
			:: acks?ack1;  goto s1_1_1_WBR;
		fi;
	s1_1_1_BBR: if
			:: msgs!msg1B;  goto s1_1_1_BBR;
			:: acks?ack1;  goto s1_2_1_B0R;
			:: acks?ack1;  goto s1_1_1_BBR;
		fi;
	s1_1_1_RBW: if
			:: msgs!msg1B;  goto s1_1_1_RBW;
			:: acks?ack1;  goto s1_2_1_R0W;
			:: acks?ack1;  goto s1_1_1_RBW;
		fi;
	s1_1_1_WBW: if
			:: msgs!msg1B;  goto s1_1_1_WBW;
			:: acks?ack1;  goto s1_2_1_W0W;
			:: acks?ack1;  goto s1_1_1_WBW;
		fi;
	s1_1_1_BBW: if
			:: msgs!msg1B;  goto s1_1_1_BBW;
			:: acks?ack1;  goto s1_2_1_B0W;
			:: acks?ack1;  goto s1_1_1_BBW;
		fi;
	s1_1_1_RBB: if
			:: msgs!msg1B;  goto s1_1_1_RBB;
			:: acks?ack1;  goto s1_2_1_R0B;
			:: acks?ack1;  goto s1_1_1_RBB;
		fi;
	s1_1_1_WBB: if
			:: msgs!msg1B;  goto s1_1_1_WBB;
			:: acks?ack1;  goto s1_2_1_W0B;
			:: acks?ack1;  goto s1_1_1_WBB;
		fi;
	s1_1_1_BBB: if
			:: msgs!msg1B;  goto s1_1_1_BBB;
			:: acks?ack1;  goto s1_2_1_B0B;
			:: acks?ack1;  goto s1_1_1_BBB;
		fi;
	s1_2_1_R0R: if
			:: in?inR;  goto s1_2_2_RRR;
			:: in?inW;  goto s1_2_2_RWR;
			:: in?inB;  goto s1_2_2_RBR;
			:: msgs!msg2R;  goto s1_2_1_R0R;
			:: acks?ack2;  goto s1_0_1_R00;
			:: acks?ack2;  goto s1_2_1_R0R;
		fi;
	s1_2_1_W0R: if
			:: in?inR;  goto s1_2_2_WRR;
			:: in?inW;  goto s1_2_2_WWR;
			:: in?inB;  goto s1_2_2_WBR;
			:: msgs!msg2R;  goto s1_2_1_W0R;
			:: acks?ack2;  goto s1_0_1_W00;
			:: acks?ack2;  goto s1_2_1_W0R;
		fi;
	s1_2_1_B0R: if
			:: in?inR;  goto s1_2_2_BRR;
			:: in?inW;  goto s1_2_2_BWR;
			:: in?inB;  goto s1_2_2_BBR;
			:: msgs!msg2R;  goto s1_2_1_B0R;
			:: acks?ack2;  goto s1_0_1_B00;
			:: acks?ack2;  goto s1_2_1_B0R;
		fi;
	s1_2_1_R0W: if
			:: in?inR;  goto s1_2_2_RRW;
			:: in?inW;  goto s1_2_2_RWW;
			:: in?inB;  goto s1_2_2_RBW;
			:: msgs!msg2W;  goto s1_2_1_R0W;
			:: acks?ack2;  goto s1_0_1_R00;
			:: acks?ack2;  goto s1_2_1_R0W;
		fi;
	s1_2_1_W0W: if
			:: in?inR;  goto s1_2_2_WRW;
			:: in?inW;  goto s1_2_2_WWW;
			:: in?inB;  goto s1_2_2_WBW;
			:: msgs!msg2W;  goto s1_2_1_W0W;
			:: acks?ack2;  goto s1_0_1_W00;
			:: acks?ack2;  goto s1_2_1_W0W;
		fi;
	s1_2_1_B0W: if
			:: in?inR;  goto s1_2_2_BRW;
			:: in?inW;  goto s1_2_2_BWW;
			:: in?inB;  goto s1_2_2_BBW;
			:: msgs!msg2W;  goto s1_2_1_B0W;
			:: acks?ack2;  goto s1_0_1_B00;
			:: acks?ack2;  goto s1_2_1_B0W;
		fi;
	s1_2_1_R0B: if
			:: in?inR;  goto s1_2_2_RRB;
			:: in?inW;  goto s1_2_2_RWB;
			:: in?inB;  goto s1_2_2_RBB;
			:: msgs!msg2B;  goto s1_2_1_R0B;
			:: acks?ack2;  goto s1_0_1_R00;
			:: acks?ack2;  goto s1_2_1_R0B;
		fi;
	s1_2_1_W0B: if
			:: in?inR;  goto s1_2_2_WRB;
			:: in?inW;  goto s1_2_2_WWB;
			:: in?inB;  goto s1_2_2_WBB;
			:: msgs!msg2B;  goto s1_2_1_W0B;
			:: acks?ack2;  goto s1_0_1_W00;
			:: acks?ack2;  goto s1_2_1_W0B;
		fi;
	s1_2_1_B0B: if
			:: in?inR;  goto s1_2_2_BRB;
			:: in?inW;  goto s1_2_2_BWB;
			:: in?inB;  goto s1_2_2_BBB;
			:: msgs!msg2B;  goto s1_2_1_B0B;
			:: acks?ack2;  goto s1_0_1_B00;
			:: acks?ack2;  goto s1_2_1_B0B;
		fi;
	s1_2_2_RRR: if
			:: msgs!msg2R;  goto s1_2_2_RRR;
			:: acks?ack2;  goto s1_0_2_RR0;
			:: acks?ack2;  goto s1_2_2_RRR;
		fi;
	s1_2_2_RWR: if
			:: msgs!msg2R;  goto s1_2_2_RWR;
			:: acks?ack2;  goto s1_0_2_RW0;
			:: acks?ack2;  goto s1_2_2_RWR;
		fi;
	s1_2_2_RBR: if
			:: msgs!msg2R;  goto s1_2_2_RBR;
			:: acks?ack2;  goto s1_0_2_RB0;
			:: acks?ack2;  goto s1_2_2_RBR;
		fi;
	s1_2_2_WRR: if
			:: msgs!msg2R;  goto s1_2_2_WRR;
			:: acks?ack2;  goto s1_0_2_WR0;
			:: acks?ack2;  goto s1_2_2_WRR;
		fi;
	s1_2_2_WWR: if
			:: msgs!msg2R;  goto s1_2_2_WWR;
			:: acks?ack2;  goto s1_0_2_WW0;
			:: acks?ack2;  goto s1_2_2_WWR;
		fi;
	s1_2_2_WBR: if
			:: msgs!msg2R;  goto s1_2_2_WBR;
			:: acks?ack2;  goto s1_0_2_WB0;
			:: acks?ack2;  goto s1_2_2_WBR;
		fi;
	s1_2_2_BRR: if
			:: msgs!msg2R;  goto s1_2_2_BRR;
			:: acks?ack2;  goto s1_0_2_BR0;
			:: acks?ack2;  goto s1_2_2_BRR;
		fi;
	s1_2_2_BWR: if
			:: msgs!msg2R;  goto s1_2_2_BWR;
			:: acks?ack2;  goto s1_0_2_BW0;
			:: acks?ack2;  goto s1_2_2_BWR;
		fi;
	s1_2_2_BBR: if
			:: msgs!msg2R;  goto s1_2_2_BBR;
			:: acks?ack2;  goto s1_0_2_BB0;
			:: acks?ack2;  goto s1_2_2_BBR;
		fi;
	s1_2_2_RRW: if
			:: msgs!msg2W;  goto s1_2_2_RRW;
			:: acks?ack2;  goto s1_0_2_RR0;
			:: acks?ack2;  goto s1_2_2_RRW;
		fi;
	s1_2_2_RWW: if
			:: msgs!msg2W;  goto s1_2_2_RWW;
			:: acks?ack2;  goto s1_0_2_RW0;
			:: acks?ack2;  goto s1_2_2_RWW;
		fi;
	s1_2_2_RBW: if
			:: msgs!msg2W;  goto s1_2_2_RBW;
			:: acks?ack2;  goto s1_0_2_RB0;
			:: acks?ack2;  goto s1_2_2_RBW;
		fi;
	s1_2_2_WRW: if
			:: msgs!msg2W;  goto s1_2_2_WRW;
			:: acks?ack2;  goto s1_0_2_WR0;
			:: acks?ack2;  goto s1_2_2_WRW;
		fi;
	s1_2_2_WWW: if
			:: msgs!msg2W;  goto s1_2_2_WWW;
			:: acks?ack2;  goto s1_0_2_WW0;
			:: acks?ack2;  goto s1_2_2_WWW;
		fi;
	s1_2_2_WBW: if
			:: msgs!msg2W;  goto s1_2_2_WBW;
			:: acks?ack2;  goto s1_0_2_WB0;
			:: acks?ack2;  goto s1_2_2_WBW;
		fi;
	s1_2_2_BRW: if
			:: msgs!msg2W;  goto s1_2_2_BRW;
			:: acks?ack2;  goto s1_0_2_BR0;
			:: acks?ack2;  goto s1_2_2_BRW;
		fi;
	s1_2_2_BWW: if
			:: msgs!msg2W;  goto s1_2_2_BWW;
			:: acks?ack2;  goto s1_0_2_BW0;
			:: acks?ack2;  goto s1_2_2_BWW;
		fi;
	s1_2_2_BBW: if
			:: msgs!msg2W;  goto s1_2_2_BBW;
			:: acks?ack2;  goto s1_0_2_BB0;
			:: acks?ack2;  goto s1_2_2_BBW;
		fi;
	s1_2_2_RRB: if
			:: msgs!msg2B;  goto s1_2_2_RRB;
			:: acks?ack2;  goto s1_0_2_RR0;
			:: acks?ack2;  goto s1_2_2_RRB;
		fi;
	s1_2_2_RWB: if
			:: msgs!msg2B;  goto s1_2_2_RWB;
			:: acks?ack2;  goto s1_0_2_RW0;
			:: acks?ack2;  goto s1_2_2_RWB;
		fi;
	s1_2_2_RBB: if
			:: msgs!msg2B;  goto s1_2_2_RBB;
			:: acks?ack2;  goto s1_0_2_RB0;
			:: acks?ack2;  goto s1_2_2_RBB;
		fi;
	s1_2_2_WRB: if
			:: msgs!msg2B;  goto s1_2_2_WRB;
			:: acks?ack2;  goto s1_0_2_WR0;
			:: acks?ack2;  goto s1_2_2_WRB;
		fi;
	s1_2_2_WWB: if
			:: msgs!msg2B;  goto s1_2_2_WWB;
			:: acks?ack2;  goto s1_0_2_WW0;
			:: acks?ack2;  goto s1_2_2_WWB;
		fi;
	s1_2_2_WBB: if
			:: msgs!msg2B;  goto s1_2_2_WBB;
			:: acks?ack2;  goto s1_0_2_WB0;
			:: acks?ack2;  goto s1_2_2_WBB;
		fi;
	s1_2_2_BRB: if
			:: msgs!msg2B;  goto s1_2_2_BRB;
			:: acks?ack2;  goto s1_0_2_BR0;
			:: acks?ack2;  goto s1_2_2_BRB;
		fi;
	s1_2_2_BWB: if
			:: msgs!msg2B;  goto s1_2_2_BWB;
			:: acks?ack2;  goto s1_0_2_BW0;
			:: acks?ack2;  goto s1_2_2_BWB;
		fi;
	s1_2_2_BBB: if
			:: msgs!msg2B;  goto s1_2_2_BBB;
			:: acks?ack2;  goto s1_0_2_BB0;
			:: acks?ack2;  goto s1_2_2_BBB;
		fi;
}

active proctype receiver()
{
	s0_0_0_000: if
			:: msgs?msg0R;  goto s0_0_0_R00;
			:: msgs?msg0R;  goto s0_0_0_000;
			:: msgs?msg0W;  goto s0_0_0_W00;
			:: msgs?msg0W;  goto s0_0_0_000;
			:: msgs?msg0B;  goto s0_0_0_B00;
			:: msgs?msg0B;  goto s0_0_0_000;
			:: msgs?msg1R;  goto s0_0_0_0R0;
			:: msgs?msg1R;  goto s0_0_0_000;
			:: msgs?msg1W;  goto s0_0_0_0W0;
			:: msgs?msg1W;  goto s0_0_0_000;
			:: msgs?msg1B;  goto s0_0_0_0B0;
			:: msgs?msg1B;  goto s0_0_0_000;
			:: msgs?msg2R;  goto s0_0_0_00R;
			:: msgs?msg2R;  goto s0_0_0_000;
			:: msgs?msg2W;  goto s0_0_0_00W;
			:: msgs?msg2W;  goto s0_0_0_000;
			:: msgs?msg2B;  goto s0_0_0_00B;
			:: msgs?msg2B;  goto s0_0_0_000;
		fi;
	s0_0_0_R00: if
			:: out!outR;  goto s1_1_1_000;
			:: msgs?msg0R;  goto s0_0_0_R00;
			:: msgs?msg0W;  goto s0_0_0_W00;
			:: msgs?msg0W;  goto s0_0_0_R00;
			:: msgs?msg0B;  goto s0_0_0_B00;
			:: msgs?msg0B;  goto s0_0_0_R00;
			:: msgs?msg1R;  goto s0_0_0_RR0;
			:: msgs?msg1R;  goto s0_0_0_R00;
			:: msgs?msg1W;  goto s0_0_0_RW0;
			:: msgs?msg1W;  goto s0_0_0_R00;
			:: msgs?msg1B;  goto s0_0_0_RB0;
			:: msgs?msg1B;  goto s0_0_0_R00;
			:: msgs?msg2R;  goto s0_0_0_R0R;
			:: msgs?msg2R;  goto s0_0_0_R00;
			:: msgs?msg2W;  goto s0_0_0_R0W;
			:: msgs?msg2W;  goto s0_0_0_R00;
			:: msgs?msg2B;  goto s0_0_0_R0B;
			:: msgs?msg2B;  goto s0_0_0_R00;
		fi;
	s0_0_0_W00: if
			:: out!outW;  goto s1_1_1_000;
			:: msgs?msg0R;  goto s0_0_0_R00;
			:: msgs?msg0R;  goto s0_0_0_W00;
			:: msgs?msg0W;  goto s0_0_0_W00;
			:: msgs?msg0B;  goto s0_0_0_B00;
			:: msgs?msg0B;  goto s0_0_0_W00;
			:: msgs?msg1R;  goto s0_0_0_WR0;
			:: msgs?msg1R;  goto s0_0_0_W00;
			:: msgs?msg1W;  goto s0_0_0_WW0;
			:: msgs?msg1W;  goto s0_0_0_W00;
			:: msgs?msg1B;  goto s0_0_0_WB0;
			:: msgs?msg1B;  goto s0_0_0_W00;
			:: msgs?msg2R;  goto s0_0_0_W0R;
			:: msgs?msg2R;  goto s0_0_0_W00;
			:: msgs?msg2W;  goto s0_0_0_W0W;
			:: msgs?msg2W;  goto s0_0_0_W00;
			:: msgs?msg2B;  goto s0_0_0_W0B;
			:: msgs?msg2B;  goto s0_0_0_W00;
		fi;
	s0_0_0_B00: if
			:: out!outB;  goto s1_1_1_000;
			:: msgs?msg0R;  goto s0_0_0_R00;
			:: msgs?msg0R;  goto s0_0_0_B00;
			:: msgs?msg0W;  goto s0_0_0_W00;
			:: msgs?msg0W;  goto s0_0_0_B00;
			:: msgs?msg0B;  goto s0_0_0_B00;
			:: msgs?msg1R;  goto s0_0_0_BR0;
			:: msgs?msg1R;  goto s0_0_0_B00;
			:: msgs?msg1W;  goto s0_0_0_BW0;
			:: msgs?msg1W;  goto s0_0_0_B00;
			:: msgs?msg1B;  goto s0_0_0_BB0;
			:: msgs?msg1B;  goto s0_0_0_B00;
			:: msgs?msg2R;  goto s0_0_0_B0R;
			:: msgs?msg2R;  goto s0_0_0_B00;
			:: msgs?msg2W;  goto s0_0_0_B0W;
			:: msgs?msg2W;  goto s0_0_0_B00;
			:: msgs?msg2B;  goto s0_0_0_B0B;
			:: msgs?msg2B;  goto s0_0_0_B00;
		fi;
	s0_0_0_0R0: if
			:: msgs?msg0R;  goto s0_0_0_RR0;
			:: msgs?msg0R;  goto s0_0_0_0R0;
			:: msgs?msg0W;  goto s0_0_0_WR0;
			:: msgs?msg0W;  goto s0_0_0_0R0;
			:: msgs?msg0B;  goto s0_0_0_BR0;
			:: msgs?msg0B;  goto s0_0_0_0R0;
			:: msgs?msg1R;  goto s0_0_0_0R0;
			:: msgs?msg1W;  goto s0_0_0_0W0;
			:: msgs?msg1W;  goto s0_0_0_0R0;
			:: msgs?msg1B;  goto s0_0_0_0B0;
			:: msgs?msg1B;  goto s0_0_0_0R0;
			:: msgs?msg2R;  goto s0_0_0_0RR;
			:: msgs?msg2R;  goto s0_0_0_0R0;
			:: msgs?msg2W;  goto s0_0_0_0RW;
			:: msgs?msg2W;  goto s0_0_0_0R0;
			:: msgs?msg2B;  goto s0_0_0_0RB;
			:: msgs?msg2B;  goto s0_0_0_0R0;
		fi;
	s0_0_0_0W0: if
			:: msgs?msg0R;  goto s0_0_0_RW0;
			:: msgs?msg0R;  goto s0_0_0_0W0;
			:: msgs?msg0W;  goto s0_0_0_WW0;
			:: msgs?msg0W;  goto s0_0_0_0W0;
			:: msgs?msg0B;  goto s0_0_0_BW0;
			:: msgs?msg0B;  goto s0_0_0_0W0;
			:: msgs?msg1R;  goto s0_0_0_0R0;
			:: msgs?msg1R;  goto s0_0_0_0W0;
			:: msgs?msg1W;  goto s0_0_0_0W0;
			:: msgs?msg1B;  goto s0_0_0_0B0;
			:: msgs?msg1B;  goto s0_0_0_0W0;
			:: msgs?msg2R;  goto s0_0_0_0WR;
			:: msgs?msg2R;  goto s0_0_0_0W0;
			:: msgs?msg2W;  goto s0_0_0_0WW;
			:: msgs?msg2W;  goto s0_0_0_0W0;
			:: msgs?msg2B;  goto s0_0_0_0WB;
			:: msgs?msg2B;  goto s0_0_0_0W0;
		fi;
	s0_0_0_0B0: if
			:: msgs?msg0R;  goto s0_0_0_RB0;
			:: msgs?msg0R;  goto s0_0_0_0B0;
			:: msgs?msg0W;  goto s0_0_0_WB0;
			:: msgs?msg0W;  goto s0_0_0_0B0;
			:: msgs?msg0B;  goto s0_0_0_BB0;
			:: msgs?msg0B;  goto s0_0_0_0B0;
			:: msgs?msg1R;  goto s0_0_0_0R0;
			:: msgs?msg1R;  goto s0_0_0_0B0;
			:: msgs?msg1W;  goto s0_0_0_0W0;
			:: msgs?msg1W;  goto s0_0_0_0B0;
			:: msgs?msg1B;  goto s0_0_0_0B0;
			:: msgs?msg2R;  goto s0_0_0_0BR;
			:: msgs?msg2R;  goto s0_0_0_0B0;
			:: msgs?msg2W;  goto s0_0_0_0BW;
			:: msgs?msg2W;  goto s0_0_0_0B0;
			:: msgs?msg2B;  goto s0_0_0_0BB;
			:: msgs?msg2B;  goto s0_0_0_0B0;
		fi;
	s0_0_0_00R: if
			:: msgs?msg0R;  goto s0_0_0_R0R;
			:: msgs?msg0R;  goto s0_0_0_00R;
			:: msgs?msg0W;  goto s0_0_0_W0R;
			:: msgs?msg0W;  goto s0_0_0_00R;
			:: msgs?msg0B;  goto s0_0_0_B0R;
			:: msgs?msg0B;  goto s0_0_0_00R;
			:: msgs?msg1R;  goto s0_0_0_0RR;
			:: msgs?msg1R;  goto s0_0_0_00R;
			:: msgs?msg1W;  goto s0_0_0_0WR;
			:: msgs?msg1W;  goto s0_0_0_00R;
			:: msgs?msg1B;  goto s0_0_0_0BR;
			:: msgs?msg1B;  goto s0_0_0_00R;
			:: msgs?msg2R;  goto s0_0_0_00R;
			:: msgs?msg2W;  goto s0_0_0_00W;
			:: msgs?msg2W;  goto s0_0_0_00R;
			:: msgs?msg2B;  goto s0_0_0_00B;
			:: msgs?msg2B;  goto s0_0_0_00R;
		fi;
	s0_0_0_00W: if
			:: msgs?msg0R;  goto s0_0_0_R0W;
			:: msgs?msg0R;  goto s0_0_0_00W;
			:: msgs?msg0W;  goto s0_0_0_W0W;
			:: msgs?msg0W;  goto s0_0_0_00W;
			:: msgs?msg0B;  goto s0_0_0_B0W;
			:: msgs?msg0B;  goto s0_0_0_00W;
			:: msgs?msg1R;  goto s0_0_0_0RW;
			:: msgs?msg1R;  goto s0_0_0_00W;
			:: msgs?msg1W;  goto s0_0_0_0WW;
			:: msgs?msg1W;  goto s0_0_0_00W;
			:: msgs?msg1B;  goto s0_0_0_0BW;
			:: msgs?msg1B;  goto s0_0_0_00W;
			:: msgs?msg2R;  goto s0_0_0_00R;
			:: msgs?msg2R;  goto s0_0_0_00W;
			:: msgs?msg2W;  goto s0_0_0_00W;
			:: msgs?msg2B;  goto s0_0_0_00B;
			:: msgs?msg2B;  goto s0_0_0_00W;
		fi;
	s0_0_0_00B: if
			:: msgs?msg0R;  goto s0_0_0_R0B;
			:: msgs?msg0R;  goto s0_0_0_00B;
			:: msgs?msg0W;  goto s0_0_0_W0B;
			:: msgs?msg0W;  goto s0_0_0_00B;
			:: msgs?msg0B;  goto s0_0_0_B0B;
			:: msgs?msg0B;  goto s0_0_0_00B;
			:: msgs?msg1R;  goto s0_0_0_0RB;
			:: msgs?msg1R;  goto s0_0_0_00B;
			:: msgs?msg1W;  goto s0_0_0_0WB;
			:: msgs?msg1W;  goto s0_0_0_00B;
			:: msgs?msg1B;  goto s0_0_0_0BB;
			:: msgs?msg1B;  goto s0_0_0_00B;
			:: msgs?msg2R;  goto s0_0_0_00R;
			:: msgs?msg2R;  goto s0_0_0_00B;
			:: msgs?msg2W;  goto s0_0_0_00W;
			:: msgs?msg2W;  goto s0_0_0_00B;
			:: msgs?msg2B;  goto s0_0_0_00B;
		fi;
	s1_1_1_000: if
			:: acks!ack0;  goto s1_1_1_000;
			:: msgs?msg0R;  goto s1_1_1_R00;
			:: msgs?msg0R;  goto s1_1_1_000;
			:: msgs?msg0W;  goto s1_1_1_W00;
			:: msgs?msg0W;  goto s1_1_1_000;
			:: msgs?msg0B;  goto s1_1_1_B00;
			:: msgs?msg0B;  goto s1_1_1_000;
			:: msgs?msg1R;  goto s1_1_1_0R0;
			:: msgs?msg1R;  goto s1_1_1_000;
			:: msgs?msg1W;  goto s1_1_1_0W0;
			:: msgs?msg1W;  goto s1_1_1_000;
			:: msgs?msg1B;  goto s1_1_1_0B0;
			:: msgs?msg1B;  goto s1_1_1_000;
			:: msgs?msg2R;  goto s1_1_1_00R;
			:: msgs?msg2R;  goto s1_1_1_000;
			:: msgs?msg2W;  goto s1_1_1_00W;
			:: msgs?msg2W;  goto s1_1_1_000;
			:: msgs?msg2B;  goto s1_1_1_00B;
			:: msgs?msg2B;  goto s1_1_1_000;
		fi;
	s0_0_0_RR0: if
			:: out!outR;  goto s1_1_1_0R0;
			:: msgs?msg0R;  goto s0_0_0_RR0;
			:: msgs?msg0W;  goto s0_0_0_WR0;
			:: msgs?msg0W;  goto s0_0_0_RR0;
			:: msgs?msg0B;  goto s0_0_0_BR0;
			:: msgs?msg0B;  goto s0_0_0_RR0;
			:: msgs?msg1R;  goto s0_0_0_RR0;
			:: msgs?msg1W;  goto s0_0_0_RW0;
			:: msgs?msg1W;  goto s0_0_0_RR0;
			:: msgs?msg1B;  goto s0_0_0_RB0;
			:: msgs?msg1B;  goto s0_0_0_RR0;
			:: msgs?msg2R;  goto s0_0_0_RRR;
			:: msgs?msg2R;  goto s0_0_0_RR0;
			:: msgs?msg2W;  goto s0_0_0_RRW;
			:: msgs?msg2W;  goto s0_0_0_RR0;
			:: msgs?msg2B;  goto s0_0_0_RRB;
			:: msgs?msg2B;  goto s0_0_0_RR0;
		fi;
	s0_0_0_RW0: if
			:: out!outR;  goto s1_1_1_0W0;
			:: msgs?msg0R;  goto s0_0_0_RW0;
			:: msgs?msg0W;  goto s0_0_0_WW0;
			:: msgs?msg0W;  goto s0_0_0_RW0;
			:: msgs?msg0B;  goto s0_0_0_BW0;
			:: msgs?msg0B;  goto s0_0_0_RW0;
			:: msgs?msg1R;  goto s0_0_0_RR0;
			:: msgs?msg1R;  goto s0_0_0_RW0;
			:: msgs?msg1W;  goto s0_0_0_RW0;
			:: msgs?msg1B;  goto s0_0_0_RB0;
			:: msgs?msg1B;  goto s0_0_0_RW0;
			:: msgs?msg2R;  goto s0_0_0_RWR;
			:: msgs?msg2R;  goto s0_0_0_RW0;
			:: msgs?msg2W;  goto s0_0_0_RWW;
			:: msgs?msg2W;  goto s0_0_0_RW0;
			:: msgs?msg2B;  goto s0_0_0_RWB;
			:: msgs?msg2B;  goto s0_0_0_RW0;
		fi;
	s0_0_0_RB0: if
			:: out!outR;  goto s1_1_1_0B0;
			:: msgs?msg0R;  goto s0_0_0_RB0;
			:: msgs?msg0W;  goto s0_0_0_WB0;
			:: msgs?msg0W;  goto s0_0_0_RB0;
			:: msgs?msg0B;  goto s0_0_0_BB0;
			:: msgs?msg0B;  goto s0_0_0_RB0;
			:: msgs?msg1R;  goto s0_0_0_RR0;
			:: msgs?msg1R;  goto s0_0_0_RB0;
			:: msgs?msg1W;  goto s0_0_0_RW0;
			:: msgs?msg1W;  goto s0_0_0_RB0;
			:: msgs?msg1B;  goto s0_0_0_RB0;
			:: msgs?msg2R;  goto s0_0_0_RBR;
			:: msgs?msg2R;  goto s0_0_0_RB0;
			:: msgs?msg2W;  goto s0_0_0_RBW;
			:: msgs?msg2W;  goto s0_0_0_RB0;
			:: msgs?msg2B;  goto s0_0_0_RBB;
			:: msgs?msg2B;  goto s0_0_0_RB0;
		fi;
	s0_0_0_R0R: if
			:: out!outR;  goto s1_1_1_00R;
			:: msgs?msg0R;  goto s0_0_0_R0R;
			:: msgs?msg0W;  goto s0_0_0_W0R;
			:: msgs?msg0W;  goto s0_0_0_R0R;
			:: msgs?msg0B;  goto s0_0_0_B0R;
			:: msgs?msg0B;  goto s0_0_0_R0R;
			:: msgs?msg1R;  goto s0_0_0_RRR;
			:: msgs?msg1R;  goto s0_0_0_R0R;
			:: msgs?msg1W;  goto s0_0_0_RWR;
			:: msgs?msg1W;  goto s0_0_0_R0R;
			:: msgs?msg1B;  goto s0_0_0_RBR;
			:: msgs?msg1B;  goto s0_0_0_R0R;
			:: msgs?msg2R;  goto s0_0_0_R0R;
			:: msgs?msg2W;  goto s0_0_0_R0W;
			:: msgs?msg2W;  goto s0_0_0_R0R;
			:: msgs?msg2B;  goto s0_0_0_R0B;
			:: msgs?msg2B;  goto s0_0_0_R0R;
		fi;
	s0_0_0_R0W: if
			:: out!outR;  goto s1_1_1_00W;
			:: msgs?msg0R;  goto s0_0_0_R0W;
			:: msgs?msg0W;  goto s0_0_0_W0W;
			:: msgs?msg0W;  goto s0_0_0_R0W;
			:: msgs?msg0B;  goto s0_0_0_B0W;
			:: msgs?msg0B;  goto s0_0_0_R0W;
			:: msgs?msg1R;  goto s0_0_0_RRW;
			:: msgs?msg1R;  goto s0_0_0_R0W;
			:: msgs?msg1W;  goto s0_0_0_RWW;
			:: msgs?msg1W;  goto s0_0_0_R0W;
			:: msgs?msg1B;  goto s0_0_0_RBW;
			:: msgs?msg1B;  goto s0_0_0_R0W;
			:: msgs?msg2R;  goto s0_0_0_R0R;
			:: msgs?msg2R;  goto s0_0_0_R0W;
			:: msgs?msg2W;  goto s0_0_0_R0W;
			:: msgs?msg2B;  goto s0_0_0_R0B;
			:: msgs?msg2B;  goto s0_0_0_R0W;
		fi;
	s0_0_0_R0B: if
			:: out!outR;  goto s1_1_1_00B;
			:: msgs?msg0R;  goto s0_0_0_R0B;
			:: msgs?msg0W;  goto s0_0_0_W0B;
			:: msgs?msg0W;  goto s0_0_0_R0B;
			:: msgs?msg0B;  goto s0_0_0_B0B;
			:: msgs?msg0B;  goto s0_0_0_R0B;
			:: msgs?msg1R;  goto s0_0_0_RRB;
			:: msgs?msg1R;  goto s0_0_0_R0B;
			:: msgs?msg1W;  goto s0_0_0_RWB;
			:: msgs?msg1W;  goto s0_0_0_R0B;
			:: msgs?msg1B;  goto s0_0_0_RBB;
			:: msgs?msg1B;  goto s0_0_0_R0B;
			:: msgs?msg2R;  goto s0_0_0_R0R;
			:: msgs?msg2R;  goto s0_0_0_R0B;
			:: msgs?msg2W;  goto s0_0_0_R0W;
			:: msgs?msg2W;  goto s0_0_0_R0B;
			:: msgs?msg2B;  goto s0_0_0_R0B;
		fi;
	s0_0_0_WR0: if
			:: out!outW;  goto s1_1_1_0R0;
			:: msgs?msg0R;  goto s0_0_0_RR0;
			:: msgs?msg0R;  goto s0_0_0_WR0;
			:: msgs?msg0W;  goto s0_0_0_WR0;
			:: msgs?msg0B;  goto s0_0_0_BR0;
			:: msgs?msg0B;  goto s0_0_0_WR0;
			:: msgs?msg1R;  goto s0_0_0_WR0;
			:: msgs?msg1W;  goto s0_0_0_WW0;
			:: msgs?msg1W;  goto s0_0_0_WR0;
			:: msgs?msg1B;  goto s0_0_0_WB0;
			:: msgs?msg1B;  goto s0_0_0_WR0;
			:: msgs?msg2R;  goto s0_0_0_WRR;
			:: msgs?msg2R;  goto s0_0_0_WR0;
			:: msgs?msg2W;  goto s0_0_0_WRW;
			:: msgs?msg2W;  goto s0_0_0_WR0;
			:: msgs?msg2B;  goto s0_0_0_WRB;
			:: msgs?msg2B;  goto s0_0_0_WR0;
		fi;
	s0_0_0_WW0: if
			:: out!outW;  goto s1_1_1_0W0;
			:: msgs?msg0R;  goto s0_0_0_RW0;
			:: msgs?msg0R;  goto s0_0_0_WW0;
			:: msgs?msg0W;  goto s0_0_0_WW0;
			:: msgs?msg0B;  goto s0_0_0_BW0;
			:: msgs?msg0B;  goto s0_0_0_WW0;
			:: msgs?msg1R;  goto s0_0_0_WR0;
			:: msgs?msg1R;  goto s0_0_0_WW0;
			:: msgs?msg1W;  goto s0_0_0_WW0;
			:: msgs?msg1B;  goto s0_0_0_WB0;
			:: msgs?msg1B;  goto s0_0_0_WW0;
			:: msgs?msg2R;  goto s0_0_0_WWR;
			:: msgs?msg2R;  goto s0_0_0_WW0;
			:: msgs?msg2W;  goto s0_0_0_WWW;
			:: msgs?msg2W;  goto s0_0_0_WW0;
			:: msgs?msg2B;  goto s0_0_0_WWB;
			:: msgs?msg2B;  goto s0_0_0_WW0;
		fi;
	s0_0_0_WB0: if
			:: out!outW;  goto s1_1_1_0B0;
			:: msgs?msg0R;  goto s0_0_0_RB0;
			:: msgs?msg0R;  goto s0_0_0_WB0;
			:: msgs?msg0W;  goto s0_0_0_WB0;
			:: msgs?msg0B;  goto s0_0_0_BB0;
			:: msgs?msg0B;  goto s0_0_0_WB0;
			:: msgs?msg1R;  goto s0_0_0_WR0;
			:: msgs?msg1R;  goto s0_0_0_WB0;
			:: msgs?msg1W;  goto s0_0_0_WW0;
			:: msgs?msg1W;  goto s0_0_0_WB0;
			:: msgs?msg1B;  goto s0_0_0_WB0;
			:: msgs?msg2R;  goto s0_0_0_WBR;
			:: msgs?msg2R;  goto s0_0_0_WB0;
			:: msgs?msg2W;  goto s0_0_0_WBW;
			:: msgs?msg2W;  goto s0_0_0_WB0;
			:: msgs?msg2B;  goto s0_0_0_WBB;
			:: msgs?msg2B;  goto s0_0_0_WB0;
		fi;
	s0_0_0_W0R: if
			:: out!outW;  goto s1_1_1_00R;
			:: msgs?msg0R;  goto s0_0_0_R0R;
			:: msgs?msg0R;  goto s0_0_0_W0R;
			:: msgs?msg0W;  goto s0_0_0_W0R;
			:: msgs?msg0B;  goto s0_0_0_B0R;
			:: msgs?msg0B;  goto s0_0_0_W0R;
			:: msgs?msg1R;  goto s0_0_0_WRR;
			:: msgs?msg1R;  goto s0_0_0_W0R;
			:: msgs?msg1W;  goto s0_0_0_WWR;
			:: msgs?msg1W;  goto s0_0_0_W0R;
			:: msgs?msg1B;  goto s0_0_0_WBR;
			:: msgs?msg1B;  goto s0_0_0_W0R;
			:: msgs?msg2R;  goto s0_0_0_W0R;
			:: msgs?msg2W;  goto s0_0_0_W0W;
			:: msgs?msg2W;  goto s0_0_0_W0R;
			:: msgs?msg2B;  goto s0_0_0_W0B;
			:: msgs?msg2B;  goto s0_0_0_W0R;
		fi;
	s0_0_0_W0W: if
			:: out!outW;  goto s1_1_1_00W;
			:: msgs?msg0R;  goto s0_0_0_R0W;
			:: msgs?msg0R;  goto s0_0_0_W0W;
			:: msgs?msg0W;  goto s0_0_0_W0W;
			:: msgs?msg0B;  goto s0_0_0_B0W;
			:: msgs?msg0B;  goto s0_0_0_W0W;
			:: msgs?msg1R;  goto s0_0_0_WRW;
			:: msgs?msg1R;  goto s0_0_0_W0W;
			:: msgs?msg1W;  goto s0_0_0_WWW;
			:: msgs?msg1W;  goto s0_0_0_W0W;
			:: msgs?msg1B;  goto s0_0_0_WBW;
			:: msgs?msg1B;  goto s0_0_0_W0W;
			:: msgs?msg2R;  goto s0_0_0_W0R;
			:: msgs?msg2R;  goto s0_0_0_W0W;
			:: msgs?msg2W;  goto s0_0_0_W0W;
			:: msgs?msg2B;  goto s0_0_0_W0B;
			:: msgs?msg2B;  goto s0_0_0_W0W;
		fi;
	s0_0_0_W0B: if
			:: out!outW;  goto s1_1_1_00B;
			:: msgs?msg0R;  goto s0_0_0_R0B;
			:: msgs?msg0R;  goto s0_0_0_W0B;
			:: msgs?msg0W;  goto s0_0_0_W0B;
			:: msgs?msg0B;  goto s0_0_0_B0B;
			:: msgs?msg0B;  goto s0_0_0_W0B;
			:: msgs?msg1R;  goto s0_0_0_WRB;
			:: msgs?msg1R;  goto s0_0_0_W0B;
			:: msgs?msg1W;  goto s0_0_0_WWB;
			:: msgs?msg1W;  goto s0_0_0_W0B;
			:: msgs?msg1B;  goto s0_0_0_WBB;
			:: msgs?msg1B;  goto s0_0_0_W0B;
			:: msgs?msg2R;  goto s0_0_0_W0R;
			:: msgs?msg2R;  goto s0_0_0_W0B;
			:: msgs?msg2W;  goto s0_0_0_W0W;
			:: msgs?msg2W;  goto s0_0_0_W0B;
			:: msgs?msg2B;  goto s0_0_0_W0B;
		fi;
	s0_0_0_BR0: if
			:: out!outB;  goto s1_1_1_0R0;
			:: msgs?msg0R;  goto s0_0_0_RR0;
			:: msgs?msg0R;  goto s0_0_0_BR0;
			:: msgs?msg0W;  goto s0_0_0_WR0;
			:: msgs?msg0W;  goto s0_0_0_BR0;
			:: msgs?msg0B;  goto s0_0_0_BR0;
			:: msgs?msg1R;  goto s0_0_0_BR0;
			:: msgs?msg1W;  goto s0_0_0_BW0;
			:: msgs?msg1W;  goto s0_0_0_BR0;
			:: msgs?msg1B;  goto s0_0_0_BB0;
			:: msgs?msg1B;  goto s0_0_0_BR0;
			:: msgs?msg2R;  goto s0_0_0_BRR;
			:: msgs?msg2R;  goto s0_0_0_BR0;
			:: msgs?msg2W;  goto s0_0_0_BRW;
			:: msgs?msg2W;  goto s0_0_0_BR0;
			:: msgs?msg2B;  goto s0_0_0_BRB;
			:: msgs?msg2B;  goto s0_0_0_BR0;
		fi;
	s0_0_0_BW0: if
			:: out!outB;  goto s1_1_1_0W0;
			:: msgs?msg0R;  goto s0_0_0_RW0;
			:: msgs?msg0R;  goto s0_0_0_BW0;
			:: msgs?msg0W;  goto s0_0_0_WW0;
			:: msgs?msg0W;  goto s0_0_0_BW0;
			:: msgs?msg0B;  goto s0_0_0_BW0;
			:: msgs?msg1R;  goto s0_0_0_BR0;
			:: msgs?msg1R;  goto s0_0_0_BW0;
			:: msgs?msg1W;  goto s0_0_0_BW0;
			:: msgs?msg1B;  goto s0_0_0_BB0;
			:: msgs?msg1B;  goto s0_0_0_BW0;
			:: msgs?msg2R;  goto s0_0_0_BWR;
			:: msgs?msg2R;  goto s0_0_0_BW0;
			:: msgs?msg2W;  goto s0_0_0_BWW;
			:: msgs?msg2W;  goto s0_0_0_BW0;
			:: msgs?msg2B;  goto s0_0_0_BWB;
			:: msgs?msg2B;  goto s0_0_0_BW0;
		fi;
	s0_0_0_BB0: if
			:: out!outB;  goto s1_1_1_0B0;
			:: msgs?msg0R;  goto s0_0_0_RB0;
			:: msgs?msg0R;  goto s0_0_0_BB0;
			:: msgs?msg0W;  goto s0_0_0_WB0;
			:: msgs?msg0W;  goto s0_0_0_BB0;
			:: msgs?msg0B;  goto s0_0_0_BB0;
			:: msgs?msg1R;  goto s0_0_0_BR0;
			:: msgs?msg1R;  goto s0_0_0_BB0;
			:: msgs?msg1W;  goto s0_0_0_BW0;
			:: msgs?msg1W;  goto s0_0_0_BB0;
			:: msgs?msg1B;  goto s0_0_0_BB0;
			:: msgs?msg2R;  goto s0_0_0_BBR;
			:: msgs?msg2R;  goto s0_0_0_BB0;
			:: msgs?msg2W;  goto s0_0_0_BBW;
			:: msgs?msg2W;  goto s0_0_0_BB0;
			:: msgs?msg2B;  goto s0_0_0_BBB;
			:: msgs?msg2B;  goto s0_0_0_BB0;
		fi;
	s0_0_0_B0R: if
			:: out!outB;  goto s1_1_1_00R;
			:: msgs?msg0R;  goto s0_0_0_R0R;
			:: msgs?msg0R;  goto s0_0_0_B0R;
			:: msgs?msg0W;  goto s0_0_0_W0R;
			:: msgs?msg0W;  goto s0_0_0_B0R;
			:: msgs?msg0B;  goto s0_0_0_B0R;
			:: msgs?msg1R;  goto s0_0_0_BRR;
			:: msgs?msg1R;  goto s0_0_0_B0R;
			:: msgs?msg1W;  goto s0_0_0_BWR;
			:: msgs?msg1W;  goto s0_0_0_B0R;
			:: msgs?msg1B;  goto s0_0_0_BBR;
			:: msgs?msg1B;  goto s0_0_0_B0R;
			:: msgs?msg2R;  goto s0_0_0_B0R;
			:: msgs?msg2W;  goto s0_0_0_B0W;
			:: msgs?msg2W;  goto s0_0_0_B0R;
			:: msgs?msg2B;  goto s0_0_0_B0B;
			:: msgs?msg2B;  goto s0_0_0_B0R;
		fi;
	s0_0_0_B0W: if
			:: out!outB;  goto s1_1_1_00W;
			:: msgs?msg0R;  goto s0_0_0_R0W;
			:: msgs?msg0R;  goto s0_0_0_B0W;
			:: msgs?msg0W;  goto s0_0_0_W0W;
			:: msgs?msg0W;  goto s0_0_0_B0W;
			:: msgs?msg0B;  goto s0_0_0_B0W;
			:: msgs?msg1R;  goto s0_0_0_BRW;
			:: msgs?msg1R;  goto s0_0_0_B0W;
			:: msgs?msg1W;  goto s0_0_0_BWW;
			:: msgs?msg1W;  goto s0_0_0_B0W;
			:: msgs?msg1B;  goto s0_0_0_BBW;
			:: msgs?msg1B;  goto s0_0_0_B0W;
			:: msgs?msg2R;  goto s0_0_0_B0R;
			:: msgs?msg2R;  goto s0_0_0_B0W;
			:: msgs?msg2W;  goto s0_0_0_B0W;
			:: msgs?msg2B;  goto s0_0_0_B0B;
			:: msgs?msg2B;  goto s0_0_0_B0W;
		fi;
	s0_0_0_B0B: if
			:: out!outB;  goto s1_1_1_00B;
			:: msgs?msg0R;  goto s0_0_0_R0B;
			:: msgs?msg0R;  goto s0_0_0_B0B;
			:: msgs?msg0W;  goto s0_0_0_W0B;
			:: msgs?msg0W;  goto s0_0_0_B0B;
			:: msgs?msg0B;  goto s0_0_0_B0B;
			:: msgs?msg1R;  goto s0_0_0_BRB;
			:: msgs?msg1R;  goto s0_0_0_B0B;
			:: msgs?msg1W;  goto s0_0_0_BWB;
			:: msgs?msg1W;  goto s0_0_0_B0B;
			:: msgs?msg1B;  goto s0_0_0_BBB;
			:: msgs?msg1B;  goto s0_0_0_B0B;
			:: msgs?msg2R;  goto s0_0_0_B0R;
			:: msgs?msg2R;  goto s0_0_0_B0B;
			:: msgs?msg2W;  goto s0_0_0_B0W;
			:: msgs?msg2W;  goto s0_0_0_B0B;
			:: msgs?msg2B;  goto s0_0_0_B0B;
		fi;
	s0_0_0_0RR: if
			:: msgs?msg0R;  goto s0_0_0_RRR;
			:: msgs?msg0R;  goto s0_0_0_0RR;
			:: msgs?msg0W;  goto s0_0_0_WRR;
			:: msgs?msg0W;  goto s0_0_0_0RR;
			:: msgs?msg0B;  goto s0_0_0_BRR;
			:: msgs?msg0B;  goto s0_0_0_0RR;
			:: msgs?msg1R;  goto s0_0_0_0RR;
			:: msgs?msg1W;  goto s0_0_0_0WR;
			:: msgs?msg1W;  goto s0_0_0_0RR;
			:: msgs?msg1B;  goto s0_0_0_0BR;
			:: msgs?msg1B;  goto s0_0_0_0RR;
			:: msgs?msg2R;  goto s0_0_0_0RR;
			:: msgs?msg2W;  goto s0_0_0_0RW;
			:: msgs?msg2W;  goto s0_0_0_0RR;
			:: msgs?msg2B;  goto s0_0_0_0RB;
			:: msgs?msg2B;  goto s0_0_0_0RR;
		fi;
	s0_0_0_0RW: if
			:: msgs?msg0R;  goto s0_0_0_RRW;
			:: msgs?msg0R;  goto s0_0_0_0RW;
			:: msgs?msg0W;  goto s0_0_0_WRW;
			:: msgs?msg0W;  goto s0_0_0_0RW;
			:: msgs?msg0B;  goto s0_0_0_BRW;
			:: msgs?msg0B;  goto s0_0_0_0RW;
			:: msgs?msg1R;  goto s0_0_0_0RW;
			:: msgs?msg1W;  goto s0_0_0_0WW;
			:: msgs?msg1W;  goto s0_0_0_0RW;
			:: msgs?msg1B;  goto s0_0_0_0BW;
			:: msgs?msg1B;  goto s0_0_0_0RW;
			:: msgs?msg2R;  goto s0_0_0_0RR;
			:: msgs?msg2R;  goto s0_0_0_0RW;
			:: msgs?msg2W;  goto s0_0_0_0RW;
			:: msgs?msg2B;  goto s0_0_0_0RB;
			:: msgs?msg2B;  goto s0_0_0_0RW;
		fi;
	s0_0_0_0RB: if
			:: msgs?msg0R;  goto s0_0_0_RRB;
			:: msgs?msg0R;  goto s0_0_0_0RB;
			:: msgs?msg0W;  goto s0_0_0_WRB;
			:: msgs?msg0W;  goto s0_0_0_0RB;
			:: msgs?msg0B;  goto s0_0_0_BRB;
			:: msgs?msg0B;  goto s0_0_0_0RB;
			:: msgs?msg1R;  goto s0_0_0_0RB;
			:: msgs?msg1W;  goto s0_0_0_0WB;
			:: msgs?msg1W;  goto s0_0_0_0RB;
			:: msgs?msg1B;  goto s0_0_0_0BB;
			:: msgs?msg1B;  goto s0_0_0_0RB;
			:: msgs?msg2R;  goto s0_0_0_0RR;
			:: msgs?msg2R;  goto s0_0_0_0RB;
			:: msgs?msg2W;  goto s0_0_0_0RW;
			:: msgs?msg2W;  goto s0_0_0_0RB;
			:: msgs?msg2B;  goto s0_0_0_0RB;
		fi;
	s0_0_0_0WR: if
			:: msgs?msg0R;  goto s0_0_0_RWR;
			:: msgs?msg0R;  goto s0_0_0_0WR;
			:: msgs?msg0W;  goto s0_0_0_WWR;
			:: msgs?msg0W;  goto s0_0_0_0WR;
			:: msgs?msg0B;  goto s0_0_0_BWR;
			:: msgs?msg0B;  goto s0_0_0_0WR;
			:: msgs?msg1R;  goto s0_0_0_0RR;
			:: msgs?msg1R;  goto s0_0_0_0WR;
			:: msgs?msg1W;  goto s0_0_0_0WR;
			:: msgs?msg1B;  goto s0_0_0_0BR;
			:: msgs?msg1B;  goto s0_0_0_0WR;
			:: msgs?msg2R;  goto s0_0_0_0WR;
			:: msgs?msg2W;  goto s0_0_0_0WW;
			:: msgs?msg2W;  goto s0_0_0_0WR;
			:: msgs?msg2B;  goto s0_0_0_0WB;
			:: msgs?msg2B;  goto s0_0_0_0WR;
		fi;
	s0_0_0_0WW: if
			:: msgs?msg0R;  goto s0_0_0_RWW;
			:: msgs?msg0R;  goto s0_0_0_0WW;
			:: msgs?msg0W;  goto s0_0_0_WWW;
			:: msgs?msg0W;  goto s0_0_0_0WW;
			:: msgs?msg0B;  goto s0_0_0_BWW;
			:: msgs?msg0B;  goto s0_0_0_0WW;
			:: msgs?msg1R;  goto s0_0_0_0RW;
			:: msgs?msg1R;  goto s0_0_0_0WW;
			:: msgs?msg1W;  goto s0_0_0_0WW;
			:: msgs?msg1B;  goto s0_0_0_0BW;
			:: msgs?msg1B;  goto s0_0_0_0WW;
			:: msgs?msg2R;  goto s0_0_0_0WR;
			:: msgs?msg2R;  goto s0_0_0_0WW;
			:: msgs?msg2W;  goto s0_0_0_0WW;
			:: msgs?msg2B;  goto s0_0_0_0WB;
			:: msgs?msg2B;  goto s0_0_0_0WW;
		fi;
	s0_0_0_0WB: if
			:: msgs?msg0R;  goto s0_0_0_RWB;
			:: msgs?msg0R;  goto s0_0_0_0WB;
			:: msgs?msg0W;  goto s0_0_0_WWB;
			:: msgs?msg0W;  goto s0_0_0_0WB;
			:: msgs?msg0B;  goto s0_0_0_BWB;
			:: msgs?msg0B;  goto s0_0_0_0WB;
			:: msgs?msg1R;  goto s0_0_0_0RB;
			:: msgs?msg1R;  goto s0_0_0_0WB;
			:: msgs?msg1W;  goto s0_0_0_0WB;
			:: msgs?msg1B;  goto s0_0_0_0BB;
			:: msgs?msg1B;  goto s0_0_0_0WB;
			:: msgs?msg2R;  goto s0_0_0_0WR;
			:: msgs?msg2R;  goto s0_0_0_0WB;
			:: msgs?msg2W;  goto s0_0_0_0WW;
			:: msgs?msg2W;  goto s0_0_0_0WB;
			:: msgs?msg2B;  goto s0_0_0_0WB;
		fi;
	s0_0_0_0BR: if
			:: msgs?msg0R;  goto s0_0_0_RBR;
			:: msgs?msg0R;  goto s0_0_0_0BR;
			:: msgs?msg0W;  goto s0_0_0_WBR;
			:: msgs?msg0W;  goto s0_0_0_0BR;
			:: msgs?msg0B;  goto s0_0_0_BBR;
			:: msgs?msg0B;  goto s0_0_0_0BR;
			:: msgs?msg1R;  goto s0_0_0_0RR;
			:: msgs?msg1R;  goto s0_0_0_0BR;
			:: msgs?msg1W;  goto s0_0_0_0WR;
			:: msgs?msg1W;  goto s0_0_0_0BR;
			:: msgs?msg1B;  goto s0_0_0_0BR;
			:: msgs?msg2R;  goto s0_0_0_0BR;
			:: msgs?msg2W;  goto s0_0_0_0BW;
			:: msgs?msg2W;  goto s0_0_0_0BR;
			:: msgs?msg2B;  goto s0_0_0_0BB;
			:: msgs?msg2B;  goto s0_0_0_0BR;
		fi;
	s0_0_0_0BW: if
			:: msgs?msg0R;  goto s0_0_0_RBW;
			:: msgs?msg0R;  goto s0_0_0_0BW;
			:: msgs?msg0W;  goto s0_0_0_WBW;
			:: msgs?msg0W;  goto s0_0_0_0BW;
			:: msgs?msg0B;  goto s0_0_0_BBW;
			:: msgs?msg0B;  goto s0_0_0_0BW;
			:: msgs?msg1R;  goto s0_0_0_0RW;
			:: msgs?msg1R;  goto s0_0_0_0BW;
			:: msgs?msg1W;  goto s0_0_0_0WW;
			:: msgs?msg1W;  goto s0_0_0_0BW;
			:: msgs?msg1B;  goto s0_0_0_0BW;
			:: msgs?msg2R;  goto s0_0_0_0BR;
			:: msgs?msg2R;  goto s0_0_0_0BW;
			:: msgs?msg2W;  goto s0_0_0_0BW;
			:: msgs?msg2B;  goto s0_0_0_0BB;
			:: msgs?msg2B;  goto s0_0_0_0BW;
		fi;
	s0_0_0_0BB: if
			:: msgs?msg0R;  goto s0_0_0_RBB;
			:: msgs?msg0R;  goto s0_0_0_0BB;
			:: msgs?msg0W;  goto s0_0_0_WBB;
			:: msgs?msg0W;  goto s0_0_0_0BB;
			:: msgs?msg0B;  goto s0_0_0_BBB;
			:: msgs?msg0B;  goto s0_0_0_0BB;
			:: msgs?msg1R;  goto s0_0_0_0RB;
			:: msgs?msg1R;  goto s0_0_0_0BB;
			:: msgs?msg1W;  goto s0_0_0_0WB;
			:: msgs?msg1W;  goto s0_0_0_0BB;
			:: msgs?msg1B;  goto s0_0_0_0BB;
			:: msgs?msg2R;  goto s0_0_0_0BR;
			:: msgs?msg2R;  goto s0_0_0_0BB;
			:: msgs?msg2W;  goto s0_0_0_0BW;
			:: msgs?msg2W;  goto s0_0_0_0BB;
			:: msgs?msg2B;  goto s0_0_0_0BB;
		fi;
	s1_1_1_R00: if
			:: acks!ack0;  goto s1_1_1_R00;
			:: msgs?msg0R;  goto s1_1_1_R00;
			:: msgs?msg0W;  goto s1_1_1_W00;
			:: msgs?msg0W;  goto s1_1_1_R00;
			:: msgs?msg0B;  goto s1_1_1_B00;
			:: msgs?msg0B;  goto s1_1_1_R00;
			:: msgs?msg1R;  goto s1_1_1_RR0;
			:: msgs?msg1R;  goto s1_1_1_R00;
			:: msgs?msg1W;  goto s1_1_1_RW0;
			:: msgs?msg1W;  goto s1_1_1_R00;
			:: msgs?msg1B;  goto s1_1_1_RB0;
			:: msgs?msg1B;  goto s1_1_1_R00;
			:: msgs?msg2R;  goto s1_1_1_R0R;
			:: msgs?msg2R;  goto s1_1_1_R00;
			:: msgs?msg2W;  goto s1_1_1_R0W;
			:: msgs?msg2W;  goto s1_1_1_R00;
			:: msgs?msg2B;  goto s1_1_1_R0B;
			:: msgs?msg2B;  goto s1_1_1_R00;
		fi;
	s1_1_1_W00: if
			:: acks!ack0;  goto s1_1_1_W00;
			:: msgs?msg0R;  goto s1_1_1_R00;
			:: msgs?msg0R;  goto s1_1_1_W00;
			:: msgs?msg0W;  goto s1_1_1_W00;
			:: msgs?msg0B;  goto s1_1_1_B00;
			:: msgs?msg0B;  goto s1_1_1_W00;
			:: msgs?msg1R;  goto s1_1_1_WR0;
			:: msgs?msg1R;  goto s1_1_1_W00;
			:: msgs?msg1W;  goto s1_1_1_WW0;
			:: msgs?msg1W;  goto s1_1_1_W00;
			:: msgs?msg1B;  goto s1_1_1_WB0;
			:: msgs?msg1B;  goto s1_1_1_W00;
			:: msgs?msg2R;  goto s1_1_1_W0R;
			:: msgs?msg2R;  goto s1_1_1_W00;
			:: msgs?msg2W;  goto s1_1_1_W0W;
			:: msgs?msg2W;  goto s1_1_1_W00;
			:: msgs?msg2B;  goto s1_1_1_W0B;
			:: msgs?msg2B;  goto s1_1_1_W00;
		fi;
	s1_1_1_B00: if
			:: acks!ack0;  goto s1_1_1_B00;
			:: msgs?msg0R;  goto s1_1_1_R00;
			:: msgs?msg0R;  goto s1_1_1_B00;
			:: msgs?msg0W;  goto s1_1_1_W00;
			:: msgs?msg0W;  goto s1_1_1_B00;
			:: msgs?msg0B;  goto s1_1_1_B00;
			:: msgs?msg1R;  goto s1_1_1_BR0;
			:: msgs?msg1R;  goto s1_1_1_B00;
			:: msgs?msg1W;  goto s1_1_1_BW0;
			:: msgs?msg1W;  goto s1_1_1_B00;
			:: msgs?msg1B;  goto s1_1_1_BB0;
			:: msgs?msg1B;  goto s1_1_1_B00;
			:: msgs?msg2R;  goto s1_1_1_B0R;
			:: msgs?msg2R;  goto s1_1_1_B00;
			:: msgs?msg2W;  goto s1_1_1_B0W;
			:: msgs?msg2W;  goto s1_1_1_B00;
			:: msgs?msg2B;  goto s1_1_1_B0B;
			:: msgs?msg2B;  goto s1_1_1_B00;
		fi;
	s1_1_1_0R0: if
			:: out!outR;  goto s1_2_2_000;
			:: msgs?msg0R;  goto s1_1_1_RR0;
			:: msgs?msg0R;  goto s1_1_1_0R0;
			:: msgs?msg0W;  goto s1_1_1_WR0;
			:: msgs?msg0W;  goto s1_1_1_0R0;
			:: msgs?msg0B;  goto s1_1_1_BR0;
			:: msgs?msg0B;  goto s1_1_1_0R0;
			:: msgs?msg1R;  goto s1_1_1_0R0;
			:: msgs?msg1W;  goto s1_1_1_0W0;
			:: msgs?msg1W;  goto s1_1_1_0R0;
			:: msgs?msg1B;  goto s1_1_1_0B0;
			:: msgs?msg1B;  goto s1_1_1_0R0;
			:: msgs?msg2R;  goto s1_1_1_0RR;
			:: msgs?msg2R;  goto s1_1_1_0R0;
			:: msgs?msg2W;  goto s1_1_1_0RW;
			:: msgs?msg2W;  goto s1_1_1_0R0;
			:: msgs?msg2B;  goto s1_1_1_0RB;
			:: msgs?msg2B;  goto s1_1_1_0R0;
		fi;
	s1_1_1_0W0: if
			:: out!outW;  goto s1_2_2_000;
			:: msgs?msg0R;  goto s1_1_1_RW0;
			:: msgs?msg0R;  goto s1_1_1_0W0;
			:: msgs?msg0W;  goto s1_1_1_WW0;
			:: msgs?msg0W;  goto s1_1_1_0W0;
			:: msgs?msg0B;  goto s1_1_1_BW0;
			:: msgs?msg0B;  goto s1_1_1_0W0;
			:: msgs?msg1R;  goto s1_1_1_0R0;
			:: msgs?msg1R;  goto s1_1_1_0W0;
			:: msgs?msg1W;  goto s1_1_1_0W0;
			:: msgs?msg1B;  goto s1_1_1_0B0;
			:: msgs?msg1B;  goto s1_1_1_0W0;
			:: msgs?msg2R;  goto s1_1_1_0WR;
			:: msgs?msg2R;  goto s1_1_1_0W0;
			:: msgs?msg2W;  goto s1_1_1_0WW;
			:: msgs?msg2W;  goto s1_1_1_0W0;
			:: msgs?msg2B;  goto s1_1_1_0WB;
			:: msgs?msg2B;  goto s1_1_1_0W0;
		fi;
	s1_1_1_0B0: if
			:: out!outB;  goto s1_2_2_000;
			:: msgs?msg0R;  goto s1_1_1_RB0;
			:: msgs?msg0R;  goto s1_1_1_0B0;
			:: msgs?msg0W;  goto s1_1_1_WB0;
			:: msgs?msg0W;  goto s1_1_1_0B0;
			:: msgs?msg0B;  goto s1_1_1_BB0;
			:: msgs?msg0B;  goto s1_1_1_0B0;
			:: msgs?msg1R;  goto s1_1_1_0R0;
			:: msgs?msg1R;  goto s1_1_1_0B0;
			:: msgs?msg1W;  goto s1_1_1_0W0;
			:: msgs?msg1W;  goto s1_1_1_0B0;
			:: msgs?msg1B;  goto s1_1_1_0B0;
			:: msgs?msg2R;  goto s1_1_1_0BR;
			:: msgs?msg2R;  goto s1_1_1_0B0;
			:: msgs?msg2W;  goto s1_1_1_0BW;
			:: msgs?msg2W;  goto s1_1_1_0B0;
			:: msgs?msg2B;  goto s1_1_1_0BB;
			:: msgs?msg2B;  goto s1_1_1_0B0;
		fi;
	s1_1_1_00R: if
			:: acks!ack0;  goto s1_1_1_00R;
			:: msgs?msg0R;  goto s1_1_1_R0R;
			:: msgs?msg0R;  goto s1_1_1_00R;
			:: msgs?msg0W;  goto s1_1_1_W0R;
			:: msgs?msg0W;  goto s1_1_1_00R;
			:: msgs?msg0B;  goto s1_1_1_B0R;
			:: msgs?msg0B;  goto s1_1_1_00R;
			:: msgs?msg1R;  goto s1_1_1_0RR;
			:: msgs?msg1R;  goto s1_1_1_00R;
			:: msgs?msg1W;  goto s1_1_1_0WR;
			:: msgs?msg1W;  goto s1_1_1_00R;
			:: msgs?msg1B;  goto s1_1_1_0BR;
			:: msgs?msg1B;  goto s1_1_1_00R;
			:: msgs?msg2R;  goto s1_1_1_00R;
			:: msgs?msg2W;  goto s1_1_1_00W;
			:: msgs?msg2W;  goto s1_1_1_00R;
			:: msgs?msg2B;  goto s1_1_1_00B;
			:: msgs?msg2B;  goto s1_1_1_00R;
		fi;
	s1_1_1_00W: if
			:: acks!ack0;  goto s1_1_1_00W;
			:: msgs?msg0R;  goto s1_1_1_R0W;
			:: msgs?msg0R;  goto s1_1_1_00W;
			:: msgs?msg0W;  goto s1_1_1_W0W;
			:: msgs?msg0W;  goto s1_1_1_00W;
			:: msgs?msg0B;  goto s1_1_1_B0W;
			:: msgs?msg0B;  goto s1_1_1_00W;
			:: msgs?msg1R;  goto s1_1_1_0RW;
			:: msgs?msg1R;  goto s1_1_1_00W;
			:: msgs?msg1W;  goto s1_1_1_0WW;
			:: msgs?msg1W;  goto s1_1_1_00W;
			:: msgs?msg1B;  goto s1_1_1_0BW;
			:: msgs?msg1B;  goto s1_1_1_00W;
			:: msgs?msg2R;  goto s1_1_1_00R;
			:: msgs?msg2R;  goto s1_1_1_00W;
			:: msgs?msg2W;  goto s1_1_1_00W;
			:: msgs?msg2B;  goto s1_1_1_00B;
			:: msgs?msg2B;  goto s1_1_1_00W;
		fi;
	s1_1_1_00B: if
			:: acks!ack0;  goto s1_1_1_00B;
			:: msgs?msg0R;  goto s1_1_1_R0B;
			:: msgs?msg0R;  goto s1_1_1_00B;
			:: msgs?msg0W;  goto s1_1_1_W0B;
			:: msgs?msg0W;  goto s1_1_1_00B;
			:: msgs?msg0B;  goto s1_1_1_B0B;
			:: msgs?msg0B;  goto s1_1_1_00B;
			:: msgs?msg1R;  goto s1_1_1_0RB;
			:: msgs?msg1R;  goto s1_1_1_00B;
			:: msgs?msg1W;  goto s1_1_1_0WB;
			:: msgs?msg1W;  goto s1_1_1_00B;
			:: msgs?msg1B;  goto s1_1_1_0BB;
			:: msgs?msg1B;  goto s1_1_1_00B;
			:: msgs?msg2R;  goto s1_1_1_00R;
			:: msgs?msg2R;  goto s1_1_1_00B;
			:: msgs?msg2W;  goto s1_1_1_00W;
			:: msgs?msg2W;  goto s1_1_1_00B;
			:: msgs?msg2B;  goto s1_1_1_00B;
		fi;
	s0_0_0_RRR: if
			:: out!outR;  goto s1_1_1_0RR;
			:: msgs?msg0R;  goto s0_0_0_RRR;
			:: msgs?msg0W;  goto s0_0_0_WRR;
			:: msgs?msg0W;  goto s0_0_0_RRR;
			:: msgs?msg0B;  goto s0_0_0_BRR;
			:: msgs?msg0B;  goto s0_0_0_RRR;
			:: msgs?msg1R;  goto s0_0_0_RRR;
			:: msgs?msg1W;  goto s0_0_0_RWR;
			:: msgs?msg1W;  goto s0_0_0_RRR;
			:: msgs?msg1B;  goto s0_0_0_RBR;
			:: msgs?msg1B;  goto s0_0_0_RRR;
			:: msgs?msg2R;  goto s0_0_0_RRR;
			:: msgs?msg2W;  goto s0_0_0_RRW;
			:: msgs?msg2W;  goto s0_0_0_RRR;
			:: msgs?msg2B;  goto s0_0_0_RRB;
			:: msgs?msg2B;  goto s0_0_0_RRR;
		fi;
	s0_0_0_RRW: if
			:: out!outR;  goto s1_1_1_0RW;
			:: msgs?msg0R;  goto s0_0_0_RRW;
			:: msgs?msg0W;  goto s0_0_0_WRW;
			:: msgs?msg0W;  goto s0_0_0_RRW;
			:: msgs?msg0B;  goto s0_0_0_BRW;
			:: msgs?msg0B;  goto s0_0_0_RRW;
			:: msgs?msg1R;  goto s0_0_0_RRW;
			:: msgs?msg1W;  goto s0_0_0_RWW;
			:: msgs?msg1W;  goto s0_0_0_RRW;
			:: msgs?msg1B;  goto s0_0_0_RBW;
			:: msgs?msg1B;  goto s0_0_0_RRW;
			:: msgs?msg2R;  goto s0_0_0_RRR;
			:: msgs?msg2R;  goto s0_0_0_RRW;
			:: msgs?msg2W;  goto s0_0_0_RRW;
			:: msgs?msg2B;  goto s0_0_0_RRB;
			:: msgs?msg2B;  goto s0_0_0_RRW;
		fi;
	s0_0_0_RRB: if
			:: out!outR;  goto s1_1_1_0RB;
			:: msgs?msg0R;  goto s0_0_0_RRB;
			:: msgs?msg0W;  goto s0_0_0_WRB;
			:: msgs?msg0W;  goto s0_0_0_RRB;
			:: msgs?msg0B;  goto s0_0_0_BRB;
			:: msgs?msg0B;  goto s0_0_0_RRB;
			:: msgs?msg1R;  goto s0_0_0_RRB;
			:: msgs?msg1W;  goto s0_0_0_RWB;
			:: msgs?msg1W;  goto s0_0_0_RRB;
			:: msgs?msg1B;  goto s0_0_0_RBB;
			:: msgs?msg1B;  goto s0_0_0_RRB;
			:: msgs?msg2R;  goto s0_0_0_RRR;
			:: msgs?msg2R;  goto s0_0_0_RRB;
			:: msgs?msg2W;  goto s0_0_0_RRW;
			:: msgs?msg2W;  goto s0_0_0_RRB;
			:: msgs?msg2B;  goto s0_0_0_RRB;
		fi;
	s0_0_0_RWR: if
			:: out!outR;  goto s1_1_1_0WR;
			:: msgs?msg0R;  goto s0_0_0_RWR;
			:: msgs?msg0W;  goto s0_0_0_WWR;
			:: msgs?msg0W;  goto s0_0_0_RWR;
			:: msgs?msg0B;  goto s0_0_0_BWR;
			:: msgs?msg0B;  goto s0_0_0_RWR;
			:: msgs?msg1R;  goto s0_0_0_RRR;
			:: msgs?msg1R;  goto s0_0_0_RWR;
			:: msgs?msg1W;  goto s0_0_0_RWR;
			:: msgs?msg1B;  goto s0_0_0_RBR;
			:: msgs?msg1B;  goto s0_0_0_RWR;
			:: msgs?msg2R;  goto s0_0_0_RWR;
			:: msgs?msg2W;  goto s0_0_0_RWW;
			:: msgs?msg2W;  goto s0_0_0_RWR;
			:: msgs?msg2B;  goto s0_0_0_RWB;
			:: msgs?msg2B;  goto s0_0_0_RWR;
		fi;
	s0_0_0_RWW: if
			:: out!outR;  goto s1_1_1_0WW;
			:: msgs?msg0R;  goto s0_0_0_RWW;
			:: msgs?msg0W;  goto s0_0_0_WWW;
			:: msgs?msg0W;  goto s0_0_0_RWW;
			:: msgs?msg0B;  goto s0_0_0_BWW;
			:: msgs?msg0B;  goto s0_0_0_RWW;
			:: msgs?msg1R;  goto s0_0_0_RRW;
			:: msgs?msg1R;  goto s0_0_0_RWW;
			:: msgs?msg1W;  goto s0_0_0_RWW;
			:: msgs?msg1B;  goto s0_0_0_RBW;
			:: msgs?msg1B;  goto s0_0_0_RWW;
			:: msgs?msg2R;  goto s0_0_0_RWR;
			:: msgs?msg2R;  goto s0_0_0_RWW;
			:: msgs?msg2W;  goto s0_0_0_RWW;
			:: msgs?msg2B;  goto s0_0_0_RWB;
			:: msgs?msg2B;  goto s0_0_0_RWW;
		fi;
	s0_0_0_RWB: if
			:: out!outR;  goto s1_1_1_0WB;
			:: msgs?msg0R;  goto s0_0_0_RWB;
			:: msgs?msg0W;  goto s0_0_0_WWB;
			:: msgs?msg0W;  goto s0_0_0_RWB;
			:: msgs?msg0B;  goto s0_0_0_BWB;
			:: msgs?msg0B;  goto s0_0_0_RWB;
			:: msgs?msg1R;  goto s0_0_0_RRB;
			:: msgs?msg1R;  goto s0_0_0_RWB;
			:: msgs?msg1W;  goto s0_0_0_RWB;
			:: msgs?msg1B;  goto s0_0_0_RBB;
			:: msgs?msg1B;  goto s0_0_0_RWB;
			:: msgs?msg2R;  goto s0_0_0_RWR;
			:: msgs?msg2R;  goto s0_0_0_RWB;
			:: msgs?msg2W;  goto s0_0_0_RWW;
			:: msgs?msg2W;  goto s0_0_0_RWB;
			:: msgs?msg2B;  goto s0_0_0_RWB;
		fi;
	s0_0_0_RBR: if
			:: out!outR;  goto s1_1_1_0BR;
			:: msgs?msg0R;  goto s0_0_0_RBR;
			:: msgs?msg0W;  goto s0_0_0_WBR;
			:: msgs?msg0W;  goto s0_0_0_RBR;
			:: msgs?msg0B;  goto s0_0_0_BBR;
			:: msgs?msg0B;  goto s0_0_0_RBR;
			:: msgs?msg1R;  goto s0_0_0_RRR;
			:: msgs?msg1R;  goto s0_0_0_RBR;
			:: msgs?msg1W;  goto s0_0_0_RWR;
			:: msgs?msg1W;  goto s0_0_0_RBR;
			:: msgs?msg1B;  goto s0_0_0_RBR;
			:: msgs?msg2R;  goto s0_0_0_RBR;
			:: msgs?msg2W;  goto s0_0_0_RBW;
			:: msgs?msg2W;  goto s0_0_0_RBR;
			:: msgs?msg2B;  goto s0_0_0_RBB;
			:: msgs?msg2B;  goto s0_0_0_RBR;
		fi;
	s0_0_0_RBW: if
			:: out!outR;  goto s1_1_1_0BW;
			:: msgs?msg0R;  goto s0_0_0_RBW;
			:: msgs?msg0W;  goto s0_0_0_WBW;
			:: msgs?msg0W;  goto s0_0_0_RBW;
			:: msgs?msg0B;  goto s0_0_0_BBW;
			:: msgs?msg0B;  goto s0_0_0_RBW;
			:: msgs?msg1R;  goto s0_0_0_RRW;
			:: msgs?msg1R;  goto s0_0_0_RBW;
			:: msgs?msg1W;  goto s0_0_0_RWW;
			:: msgs?msg1W;  goto s0_0_0_RBW;
			:: msgs?msg1B;  goto s0_0_0_RBW;
			:: msgs?msg2R;  goto s0_0_0_RBR;
			:: msgs?msg2R;  goto s0_0_0_RBW;
			:: msgs?msg2W;  goto s0_0_0_RBW;
			:: msgs?msg2B;  goto s0_0_0_RBB;
			:: msgs?msg2B;  goto s0_0_0_RBW;
		fi;
	s0_0_0_RBB: if
			:: out!outR;  goto s1_1_1_0BB;
			:: msgs?msg0R;  goto s0_0_0_RBB;
			:: msgs?msg0W;  goto s0_0_0_WBB;
			:: msgs?msg0W;  goto s0_0_0_RBB;
			:: msgs?msg0B;  goto s0_0_0_BBB;
			:: msgs?msg0B;  goto s0_0_0_RBB;
			:: msgs?msg1R;  goto s0_0_0_RRB;
			:: msgs?msg1R;  goto s0_0_0_RBB;
			:: msgs?msg1W;  goto s0_0_0_RWB;
			:: msgs?msg1W;  goto s0_0_0_RBB;
			:: msgs?msg1B;  goto s0_0_0_RBB;
			:: msgs?msg2R;  goto s0_0_0_RBR;
			:: msgs?msg2R;  goto s0_0_0_RBB;
			:: msgs?msg2W;  goto s0_0_0_RBW;
			:: msgs?msg2W;  goto s0_0_0_RBB;
			:: msgs?msg2B;  goto s0_0_0_RBB;
		fi;
	s0_0_0_WRR: if
			:: out!outW;  goto s1_1_1_0RR;
			:: msgs?msg0R;  goto s0_0_0_RRR;
			:: msgs?msg0R;  goto s0_0_0_WRR;
			:: msgs?msg0W;  goto s0_0_0_WRR;
			:: msgs?msg0B;  goto s0_0_0_BRR;
			:: msgs?msg0B;  goto s0_0_0_WRR;
			:: msgs?msg1R;  goto s0_0_0_WRR;
			:: msgs?msg1W;  goto s0_0_0_WWR;
			:: msgs?msg1W;  goto s0_0_0_WRR;
			:: msgs?msg1B;  goto s0_0_0_WBR;
			:: msgs?msg1B;  goto s0_0_0_WRR;
			:: msgs?msg2R;  goto s0_0_0_WRR;
			:: msgs?msg2W;  goto s0_0_0_WRW;
			:: msgs?msg2W;  goto s0_0_0_WRR;
			:: msgs?msg2B;  goto s0_0_0_WRB;
			:: msgs?msg2B;  goto s0_0_0_WRR;
		fi;
	s0_0_0_WRW: if
			:: out!outW;  goto s1_1_1_0RW;
			:: msgs?msg0R;  goto s0_0_0_RRW;
			:: msgs?msg0R;  goto s0_0_0_WRW;
			:: msgs?msg0W;  goto s0_0_0_WRW;
			:: msgs?msg0B;  goto s0_0_0_BRW;
			:: msgs?msg0B;  goto s0_0_0_WRW;
			:: msgs?msg1R;  goto s0_0_0_WRW;
			:: msgs?msg1W;  goto s0_0_0_WWW;
			:: msgs?msg1W;  goto s0_0_0_WRW;
			:: msgs?msg1B;  goto s0_0_0_WBW;
			:: msgs?msg1B;  goto s0_0_0_WRW;
			:: msgs?msg2R;  goto s0_0_0_WRR;
			:: msgs?msg2R;  goto s0_0_0_WRW;
			:: msgs?msg2W;  goto s0_0_0_WRW;
			:: msgs?msg2B;  goto s0_0_0_WRB;
			:: msgs?msg2B;  goto s0_0_0_WRW;
		fi;
	s0_0_0_WRB: if
			:: out!outW;  goto s1_1_1_0RB;
			:: msgs?msg0R;  goto s0_0_0_RRB;
			:: msgs?msg0R;  goto s0_0_0_WRB;
			:: msgs?msg0W;  goto s0_0_0_WRB;
			:: msgs?msg0B;  goto s0_0_0_BRB;
			:: msgs?msg0B;  goto s0_0_0_WRB;
			:: msgs?msg1R;  goto s0_0_0_WRB;
			:: msgs?msg1W;  goto s0_0_0_WWB;
			:: msgs?msg1W;  goto s0_0_0_WRB;
			:: msgs?msg1B;  goto s0_0_0_WBB;
			:: msgs?msg1B;  goto s0_0_0_WRB;
			:: msgs?msg2R;  goto s0_0_0_WRR;
			:: msgs?msg2R;  goto s0_0_0_WRB;
			:: msgs?msg2W;  goto s0_0_0_WRW;
			:: msgs?msg2W;  goto s0_0_0_WRB;
			:: msgs?msg2B;  goto s0_0_0_WRB;
		fi;
	s0_0_0_WWR: if
			:: out!outW;  goto s1_1_1_0WR;
			:: msgs?msg0R;  goto s0_0_0_RWR;
			:: msgs?msg0R;  goto s0_0_0_WWR;
			:: msgs?msg0W;  goto s0_0_0_WWR;
			:: msgs?msg0B;  goto s0_0_0_BWR;
			:: msgs?msg0B;  goto s0_0_0_WWR;
			:: msgs?msg1R;  goto s0_0_0_WRR;
			:: msgs?msg1R;  goto s0_0_0_WWR;
			:: msgs?msg1W;  goto s0_0_0_WWR;
			:: msgs?msg1B;  goto s0_0_0_WBR;
			:: msgs?msg1B;  goto s0_0_0_WWR;
			:: msgs?msg2R;  goto s0_0_0_WWR;
			:: msgs?msg2W;  goto s0_0_0_WWW;
			:: msgs?msg2W;  goto s0_0_0_WWR;
			:: msgs?msg2B;  goto s0_0_0_WWB;
			:: msgs?msg2B;  goto s0_0_0_WWR;
		fi;
	s0_0_0_WWW: if
			:: out!outW;  goto s1_1_1_0WW;
			:: msgs?msg0R;  goto s0_0_0_RWW;
			:: msgs?msg0R;  goto s0_0_0_WWW;
			:: msgs?msg0W;  goto s0_0_0_WWW;
			:: msgs?msg0B;  goto s0_0_0_BWW;
			:: msgs?msg0B;  goto s0_0_0_WWW;
			:: msgs?msg1R;  goto s0_0_0_WRW;
			:: msgs?msg1R;  goto s0_0_0_WWW;
			:: msgs?msg1W;  goto s0_0_0_WWW;
			:: msgs?msg1B;  goto s0_0_0_WBW;
			:: msgs?msg1B;  goto s0_0_0_WWW;
			:: msgs?msg2R;  goto s0_0_0_WWR;
			:: msgs?msg2R;  goto s0_0_0_WWW;
			:: msgs?msg2W;  goto s0_0_0_WWW;
			:: msgs?msg2B;  goto s0_0_0_WWB;
			:: msgs?msg2B;  goto s0_0_0_WWW;
		fi;
	s0_0_0_WWB: if
			:: out!outW;  goto s1_1_1_0WB;
			:: msgs?msg0R;  goto s0_0_0_RWB;
			:: msgs?msg0R;  goto s0_0_0_WWB;
			:: msgs?msg0W;  goto s0_0_0_WWB;
			:: msgs?msg0B;  goto s0_0_0_BWB;
			:: msgs?msg0B;  goto s0_0_0_WWB;
			:: msgs?msg1R;  goto s0_0_0_WRB;
			:: msgs?msg1R;  goto s0_0_0_WWB;
			:: msgs?msg1W;  goto s0_0_0_WWB;
			:: msgs?msg1B;  goto s0_0_0_WBB;
			:: msgs?msg1B;  goto s0_0_0_WWB;
			:: msgs?msg2R;  goto s0_0_0_WWR;
			:: msgs?msg2R;  goto s0_0_0_WWB;
			:: msgs?msg2W;  goto s0_0_0_WWW;
			:: msgs?msg2W;  goto s0_0_0_WWB;
			:: msgs?msg2B;  goto s0_0_0_WWB;
		fi;
	s0_0_0_WBR: if
			:: out!outW;  goto s1_1_1_0BR;
			:: msgs?msg0R;  goto s0_0_0_RBR;
			:: msgs?msg0R;  goto s0_0_0_WBR;
			:: msgs?msg0W;  goto s0_0_0_WBR;
			:: msgs?msg0B;  goto s0_0_0_BBR;
			:: msgs?msg0B;  goto s0_0_0_WBR;
			:: msgs?msg1R;  goto s0_0_0_WRR;
			:: msgs?msg1R;  goto s0_0_0_WBR;
			:: msgs?msg1W;  goto s0_0_0_WWR;
			:: msgs?msg1W;  goto s0_0_0_WBR;
			:: msgs?msg1B;  goto s0_0_0_WBR;
			:: msgs?msg2R;  goto s0_0_0_WBR;
			:: msgs?msg2W;  goto s0_0_0_WBW;
			:: msgs?msg2W;  goto s0_0_0_WBR;
			:: msgs?msg2B;  goto s0_0_0_WBB;
			:: msgs?msg2B;  goto s0_0_0_WBR;
		fi;
	s0_0_0_WBW: if
			:: out!outW;  goto s1_1_1_0BW;
			:: msgs?msg0R;  goto s0_0_0_RBW;
			:: msgs?msg0R;  goto s0_0_0_WBW;
			:: msgs?msg0W;  goto s0_0_0_WBW;
			:: msgs?msg0B;  goto s0_0_0_BBW;
			:: msgs?msg0B;  goto s0_0_0_WBW;
			:: msgs?msg1R;  goto s0_0_0_WRW;
			:: msgs?msg1R;  goto s0_0_0_WBW;
			:: msgs?msg1W;  goto s0_0_0_WWW;
			:: msgs?msg1W;  goto s0_0_0_WBW;
			:: msgs?msg1B;  goto s0_0_0_WBW;
			:: msgs?msg2R;  goto s0_0_0_WBR;
			:: msgs?msg2R;  goto s0_0_0_WBW;
			:: msgs?msg2W;  goto s0_0_0_WBW;
			:: msgs?msg2B;  goto s0_0_0_WBB;
			:: msgs?msg2B;  goto s0_0_0_WBW;
		fi;
	s0_0_0_WBB: if
			:: out!outW;  goto s1_1_1_0BB;
			:: msgs?msg0R;  goto s0_0_0_RBB;
			:: msgs?msg0R;  goto s0_0_0_WBB;
			:: msgs?msg0W;  goto s0_0_0_WBB;
			:: msgs?msg0B;  goto s0_0_0_BBB;
			:: msgs?msg0B;  goto s0_0_0_WBB;
			:: msgs?msg1R;  goto s0_0_0_WRB;
			:: msgs?msg1R;  goto s0_0_0_WBB;
			:: msgs?msg1W;  goto s0_0_0_WWB;
			:: msgs?msg1W;  goto s0_0_0_WBB;
			:: msgs?msg1B;  goto s0_0_0_WBB;
			:: msgs?msg2R;  goto s0_0_0_WBR;
			:: msgs?msg2R;  goto s0_0_0_WBB;
			:: msgs?msg2W;  goto s0_0_0_WBW;
			:: msgs?msg2W;  goto s0_0_0_WBB;
			:: msgs?msg2B;  goto s0_0_0_WBB;
		fi;
	s0_0_0_BRR: if
			:: out!outB;  goto s1_1_1_0RR;
			:: msgs?msg0R;  goto s0_0_0_RRR;
			:: msgs?msg0R;  goto s0_0_0_BRR;
			:: msgs?msg0W;  goto s0_0_0_WRR;
			:: msgs?msg0W;  goto s0_0_0_BRR;
			:: msgs?msg0B;  goto s0_0_0_BRR;
			:: msgs?msg1R;  goto s0_0_0_BRR;
			:: msgs?msg1W;  goto s0_0_0_BWR;
			:: msgs?msg1W;  goto s0_0_0_BRR;
			:: msgs?msg1B;  goto s0_0_0_BBR;
			:: msgs?msg1B;  goto s0_0_0_BRR;
			:: msgs?msg2R;  goto s0_0_0_BRR;
			:: msgs?msg2W;  goto s0_0_0_BRW;
			:: msgs?msg2W;  goto s0_0_0_BRR;
			:: msgs?msg2B;  goto s0_0_0_BRB;
			:: msgs?msg2B;  goto s0_0_0_BRR;
		fi;
	s0_0_0_BRW: if
			:: out!outB;  goto s1_1_1_0RW;
			:: msgs?msg0R;  goto s0_0_0_RRW;
			:: msgs?msg0R;  goto s0_0_0_BRW;
			:: msgs?msg0W;  goto s0_0_0_WRW;
			:: msgs?msg0W;  goto s0_0_0_BRW;
			:: msgs?msg0B;  goto s0_0_0_BRW;
			:: msgs?msg1R;  goto s0_0_0_BRW;
			:: msgs?msg1W;  goto s0_0_0_BWW;
			:: msgs?msg1W;  goto s0_0_0_BRW;
			:: msgs?msg1B;  goto s0_0_0_BBW;
			:: msgs?msg1B;  goto s0_0_0_BRW;
			:: msgs?msg2R;  goto s0_0_0_BRR;
			:: msgs?msg2R;  goto s0_0_0_BRW;
			:: msgs?msg2W;  goto s0_0_0_BRW;
			:: msgs?msg2B;  goto s0_0_0_BRB;
			:: msgs?msg2B;  goto s0_0_0_BRW;
		fi;
	s0_0_0_BRB: if
			:: out!outB;  goto s1_1_1_0RB;
			:: msgs?msg0R;  goto s0_0_0_RRB;
			:: msgs?msg0R;  goto s0_0_0_BRB;
			:: msgs?msg0W;  goto s0_0_0_WRB;
			:: msgs?msg0W;  goto s0_0_0_BRB;
			:: msgs?msg0B;  goto s0_0_0_BRB;
			:: msgs?msg1R;  goto s0_0_0_BRB;
			:: msgs?msg1W;  goto s0_0_0_BWB;
			:: msgs?msg1W;  goto s0_0_0_BRB;
			:: msgs?msg1B;  goto s0_0_0_BBB;
			:: msgs?msg1B;  goto s0_0_0_BRB;
			:: msgs?msg2R;  goto s0_0_0_BRR;
			:: msgs?msg2R;  goto s0_0_0_BRB;
			:: msgs?msg2W;  goto s0_0_0_BRW;
			:: msgs?msg2W;  goto s0_0_0_BRB;
			:: msgs?msg2B;  goto s0_0_0_BRB;
		fi;
	s0_0_0_BWR: if
			:: out!outB;  goto s1_1_1_0WR;
			:: msgs?msg0R;  goto s0_0_0_RWR;
			:: msgs?msg0R;  goto s0_0_0_BWR;
			:: msgs?msg0W;  goto s0_0_0_WWR;
			:: msgs?msg0W;  goto s0_0_0_BWR;
			:: msgs?msg0B;  goto s0_0_0_BWR;
			:: msgs?msg1R;  goto s0_0_0_BRR;
			:: msgs?msg1R;  goto s0_0_0_BWR;
			:: msgs?msg1W;  goto s0_0_0_BWR;
			:: msgs?msg1B;  goto s0_0_0_BBR;
			:: msgs?msg1B;  goto s0_0_0_BWR;
			:: msgs?msg2R;  goto s0_0_0_BWR;
			:: msgs?msg2W;  goto s0_0_0_BWW;
			:: msgs?msg2W;  goto s0_0_0_BWR;
			:: msgs?msg2B;  goto s0_0_0_BWB;
			:: msgs?msg2B;  goto s0_0_0_BWR;
		fi;
	s0_0_0_BWW: if
			:: out!outB;  goto s1_1_1_0WW;
			:: msgs?msg0R;  goto s0_0_0_RWW;
			:: msgs?msg0R;  goto s0_0_0_BWW;
			:: msgs?msg0W;  goto s0_0_0_WWW;
			:: msgs?msg0W;  goto s0_0_0_BWW;
			:: msgs?msg0B;  goto s0_0_0_BWW;
			:: msgs?msg1R;  goto s0_0_0_BRW;
			:: msgs?msg1R;  goto s0_0_0_BWW;
			:: msgs?msg1W;  goto s0_0_0_BWW;
			:: msgs?msg1B;  goto s0_0_0_BBW;
			:: msgs?msg1B;  goto s0_0_0_BWW;
			:: msgs?msg2R;  goto s0_0_0_BWR;
			:: msgs?msg2R;  goto s0_0_0_BWW;
			:: msgs?msg2W;  goto s0_0_0_BWW;
			:: msgs?msg2B;  goto s0_0_0_BWB;
			:: msgs?msg2B;  goto s0_0_0_BWW;
		fi;
	s0_0_0_BWB: if
			:: out!outB;  goto s1_1_1_0WB;
			:: msgs?msg0R;  goto s0_0_0_RWB;
			:: msgs?msg0R;  goto s0_0_0_BWB;
			:: msgs?msg0W;  goto s0_0_0_WWB;
			:: msgs?msg0W;  goto s0_0_0_BWB;
			:: msgs?msg0B;  goto s0_0_0_BWB;
			:: msgs?msg1R;  goto s0_0_0_BRB;
			:: msgs?msg1R;  goto s0_0_0_BWB;
			:: msgs?msg1W;  goto s0_0_0_BWB;
			:: msgs?msg1B;  goto s0_0_0_BBB;
			:: msgs?msg1B;  goto s0_0_0_BWB;
			:: msgs?msg2R;  goto s0_0_0_BWR;
			:: msgs?msg2R;  goto s0_0_0_BWB;
			:: msgs?msg2W;  goto s0_0_0_BWW;
			:: msgs?msg2W;  goto s0_0_0_BWB;
			:: msgs?msg2B;  goto s0_0_0_BWB;
		fi;
	s0_0_0_BBR: if
			:: out!outB;  goto s1_1_1_0BR;
			:: msgs?msg0R;  goto s0_0_0_RBR;
			:: msgs?msg0R;  goto s0_0_0_BBR;
			:: msgs?msg0W;  goto s0_0_0_WBR;
			:: msgs?msg0W;  goto s0_0_0_BBR;
			:: msgs?msg0B;  goto s0_0_0_BBR;
			:: msgs?msg1R;  goto s0_0_0_BRR;
			:: msgs?msg1R;  goto s0_0_0_BBR;
			:: msgs?msg1W;  goto s0_0_0_BWR;
			:: msgs?msg1W;  goto s0_0_0_BBR;
			:: msgs?msg1B;  goto s0_0_0_BBR;
			:: msgs?msg2R;  goto s0_0_0_BBR;
			:: msgs?msg2W;  goto s0_0_0_BBW;
			:: msgs?msg2W;  goto s0_0_0_BBR;
			:: msgs?msg2B;  goto s0_0_0_BBB;
			:: msgs?msg2B;  goto s0_0_0_BBR;
		fi;
	s0_0_0_BBW: if
			:: out!outB;  goto s1_1_1_0BW;
			:: msgs?msg0R;  goto s0_0_0_RBW;
			:: msgs?msg0R;  goto s0_0_0_BBW;
			:: msgs?msg0W;  goto s0_0_0_WBW;
			:: msgs?msg0W;  goto s0_0_0_BBW;
			:: msgs?msg0B;  goto s0_0_0_BBW;
			:: msgs?msg1R;  goto s0_0_0_BRW;
			:: msgs?msg1R;  goto s0_0_0_BBW;
			:: msgs?msg1W;  goto s0_0_0_BWW;
			:: msgs?msg1W;  goto s0_0_0_BBW;
			:: msgs?msg1B;  goto s0_0_0_BBW;
			:: msgs?msg2R;  goto s0_0_0_BBR;
			:: msgs?msg2R;  goto s0_0_0_BBW;
			:: msgs?msg2W;  goto s0_0_0_BBW;
			:: msgs?msg2B;  goto s0_0_0_BBB;
			:: msgs?msg2B;  goto s0_0_0_BBW;
		fi;
	s0_0_0_BBB: if
			:: out!outB;  goto s1_1_1_0BB;
			:: msgs?msg0R;  goto s0_0_0_RBB;
			:: msgs?msg0R;  goto s0_0_0_BBB;
			:: msgs?msg0W;  goto s0_0_0_WBB;
			:: msgs?msg0W;  goto s0_0_0_BBB;
			:: msgs?msg0B;  goto s0_0_0_BBB;
			:: msgs?msg1R;  goto s0_0_0_BRB;
			:: msgs?msg1R;  goto s0_0_0_BBB;
			:: msgs?msg1W;  goto s0_0_0_BWB;
			:: msgs?msg1W;  goto s0_0_0_BBB;
			:: msgs?msg1B;  goto s0_0_0_BBB;
			:: msgs?msg2R;  goto s0_0_0_BBR;
			:: msgs?msg2R;  goto s0_0_0_BBB;
			:: msgs?msg2W;  goto s0_0_0_BBW;
			:: msgs?msg2W;  goto s0_0_0_BBB;
			:: msgs?msg2B;  goto s0_0_0_BBB;
		fi;
	s1_1_1_RR0: if
			:: out!outR;  goto s1_2_2_R00;
			:: msgs?msg0R;  goto s1_1_1_RR0;
			:: msgs?msg0W;  goto s1_1_1_WR0;
			:: msgs?msg0W;  goto s1_1_1_RR0;
			:: msgs?msg0B;  goto s1_1_1_BR0;
			:: msgs?msg0B;  goto s1_1_1_RR0;
			:: msgs?msg1R;  goto s1_1_1_RR0;
			:: msgs?msg1W;  goto s1_1_1_RW0;
			:: msgs?msg1W;  goto s1_1_1_RR0;
			:: msgs?msg1B;  goto s1_1_1_RB0;
			:: msgs?msg1B;  goto s1_1_1_RR0;
			:: msgs?msg2R;  goto s1_1_1_RRR;
			:: msgs?msg2R;  goto s1_1_1_RR0;
			:: msgs?msg2W;  goto s1_1_1_RRW;
			:: msgs?msg2W;  goto s1_1_1_RR0;
			:: msgs?msg2B;  goto s1_1_1_RRB;
			:: msgs?msg2B;  goto s1_1_1_RR0;
		fi;
	s1_1_1_RW0: if
			:: out!outW;  goto s1_2_2_R00;
			:: msgs?msg0R;  goto s1_1_1_RW0;
			:: msgs?msg0W;  goto s1_1_1_WW0;
			:: msgs?msg0W;  goto s1_1_1_RW0;
			:: msgs?msg0B;  goto s1_1_1_BW0;
			:: msgs?msg0B;  goto s1_1_1_RW0;
			:: msgs?msg1R;  goto s1_1_1_RR0;
			:: msgs?msg1R;  goto s1_1_1_RW0;
			:: msgs?msg1W;  goto s1_1_1_RW0;
			:: msgs?msg1B;  goto s1_1_1_RB0;
			:: msgs?msg1B;  goto s1_1_1_RW0;
			:: msgs?msg2R;  goto s1_1_1_RWR;
			:: msgs?msg2R;  goto s1_1_1_RW0;
			:: msgs?msg2W;  goto s1_1_1_RWW;
			:: msgs?msg2W;  goto s1_1_1_RW0;
			:: msgs?msg2B;  goto s1_1_1_RWB;
			:: msgs?msg2B;  goto s1_1_1_RW0;
		fi;
	s1_1_1_RB0: if
			:: out!outB;  goto s1_2_2_R00;
			:: msgs?msg0R;  goto s1_1_1_RB0;
			:: msgs?msg0W;  goto s1_1_1_WB0;
			:: msgs?msg0W;  goto s1_1_1_RB0;
			:: msgs?msg0B;  goto s1_1_1_BB0;
			:: msgs?msg0B;  goto s1_1_1_RB0;
			:: msgs?msg1R;  goto s1_1_1_RR0;
			:: msgs?msg1R;  goto s1_1_1_RB0;
			:: msgs?msg1W;  goto s1_1_1_RW0;
			:: msgs?msg1W;  goto s1_1_1_RB0;
			:: msgs?msg1B;  goto s1_1_1_RB0;
			:: msgs?msg2R;  goto s1_1_1_RBR;
			:: msgs?msg2R;  goto s1_1_1_RB0;
			:: msgs?msg2W;  goto s1_1_1_RBW;
			:: msgs?msg2W;  goto s1_1_1_RB0;
			:: msgs?msg2B;  goto s1_1_1_RBB;
			:: msgs?msg2B;  goto s1_1_1_RB0;
		fi;
	s1_1_1_R0R: if
			:: acks!ack0;  goto s1_1_1_R0R;
			:: msgs?msg0R;  goto s1_1_1_R0R;
			:: msgs?msg0W;  goto s1_1_1_W0R;
			:: msgs?msg0W;  goto s1_1_1_R0R;
			:: msgs?msg0B;  goto s1_1_1_B0R;
			:: msgs?msg0B;  goto s1_1_1_R0R;
			:: msgs?msg1R;  goto s1_1_1_RRR;
			:: msgs?msg1R;  goto s1_1_1_R0R;
			:: msgs?msg1W;  goto s1_1_1_RWR;
			:: msgs?msg1W;  goto s1_1_1_R0R;
			:: msgs?msg1B;  goto s1_1_1_RBR;
			:: msgs?msg1B;  goto s1_1_1_R0R;
			:: msgs?msg2R;  goto s1_1_1_R0R;
			:: msgs?msg2W;  goto s1_1_1_R0W;
			:: msgs?msg2W;  goto s1_1_1_R0R;
			:: msgs?msg2B;  goto s1_1_1_R0B;
			:: msgs?msg2B;  goto s1_1_1_R0R;
		fi;
	s1_1_1_R0W: if
			:: acks!ack0;  goto s1_1_1_R0W;
			:: msgs?msg0R;  goto s1_1_1_R0W;
			:: msgs?msg0W;  goto s1_1_1_W0W;
			:: msgs?msg0W;  goto s1_1_1_R0W;
			:: msgs?msg0B;  goto s1_1_1_B0W;
			:: msgs?msg0B;  goto s1_1_1_R0W;
			:: msgs?msg1R;  goto s1_1_1_RRW;
			:: msgs?msg1R;  goto s1_1_1_R0W;
			:: msgs?msg1W;  goto s1_1_1_RWW;
			:: msgs?msg1W;  goto s1_1_1_R0W;
			:: msgs?msg1B;  goto s1_1_1_RBW;
			:: msgs?msg1B;  goto s1_1_1_R0W;
			:: msgs?msg2R;  goto s1_1_1_R0R;
			:: msgs?msg2R;  goto s1_1_1_R0W;
			:: msgs?msg2W;  goto s1_1_1_R0W;
			:: msgs?msg2B;  goto s1_1_1_R0B;
			:: msgs?msg2B;  goto s1_1_1_R0W;
		fi;
	s1_1_1_R0B: if
			:: acks!ack0;  goto s1_1_1_R0B;
			:: msgs?msg0R;  goto s1_1_1_R0B;
			:: msgs?msg0W;  goto s1_1_1_W0B;
			:: msgs?msg0W;  goto s1_1_1_R0B;
			:: msgs?msg0B;  goto s1_1_1_B0B;
			:: msgs?msg0B;  goto s1_1_1_R0B;
			:: msgs?msg1R;  goto s1_1_1_RRB;
			:: msgs?msg1R;  goto s1_1_1_R0B;
			:: msgs?msg1W;  goto s1_1_1_RWB;
			:: msgs?msg1W;  goto s1_1_1_R0B;
			:: msgs?msg1B;  goto s1_1_1_RBB;
			:: msgs?msg1B;  goto s1_1_1_R0B;
			:: msgs?msg2R;  goto s1_1_1_R0R;
			:: msgs?msg2R;  goto s1_1_1_R0B;
			:: msgs?msg2W;  goto s1_1_1_R0W;
			:: msgs?msg2W;  goto s1_1_1_R0B;
			:: msgs?msg2B;  goto s1_1_1_R0B;
		fi;
	s1_1_1_WR0: if
			:: out!outR;  goto s1_2_2_W00;
			:: msgs?msg0R;  goto s1_1_1_RR0;
			:: msgs?msg0R;  goto s1_1_1_WR0;
			:: msgs?msg0W;  goto s1_1_1_WR0;
			:: msgs?msg0B;  goto s1_1_1_BR0;
			:: msgs?msg0B;  goto s1_1_1_WR0;
			:: msgs?msg1R;  goto s1_1_1_WR0;
			:: msgs?msg1W;  goto s1_1_1_WW0;
			:: msgs?msg1W;  goto s1_1_1_WR0;
			:: msgs?msg1B;  goto s1_1_1_WB0;
			:: msgs?msg1B;  goto s1_1_1_WR0;
			:: msgs?msg2R;  goto s1_1_1_WRR;
			:: msgs?msg2R;  goto s1_1_1_WR0;
			:: msgs?msg2W;  goto s1_1_1_WRW;
			:: msgs?msg2W;  goto s1_1_1_WR0;
			:: msgs?msg2B;  goto s1_1_1_WRB;
			:: msgs?msg2B;  goto s1_1_1_WR0;
		fi;
	s1_1_1_WW0: if
			:: out!outW;  goto s1_2_2_W00;
			:: msgs?msg0R;  goto s1_1_1_RW0;
			:: msgs?msg0R;  goto s1_1_1_WW0;
			:: msgs?msg0W;  goto s1_1_1_WW0;
			:: msgs?msg0B;  goto s1_1_1_BW0;
			:: msgs?msg0B;  goto s1_1_1_WW0;
			:: msgs?msg1R;  goto s1_1_1_WR0;
			:: msgs?msg1R;  goto s1_1_1_WW0;
			:: msgs?msg1W;  goto s1_1_1_WW0;
			:: msgs?msg1B;  goto s1_1_1_WB0;
			:: msgs?msg1B;  goto s1_1_1_WW0;
			:: msgs?msg2R;  goto s1_1_1_WWR;
			:: msgs?msg2R;  goto s1_1_1_WW0;
			:: msgs?msg2W;  goto s1_1_1_WWW;
			:: msgs?msg2W;  goto s1_1_1_WW0;
			:: msgs?msg2B;  goto s1_1_1_WWB;
			:: msgs?msg2B;  goto s1_1_1_WW0;
		fi;
	s1_1_1_WB0: if
			:: out!outB;  goto s1_2_2_W00;
			:: msgs?msg0R;  goto s1_1_1_RB0;
			:: msgs?msg0R;  goto s1_1_1_WB0;
			:: msgs?msg0W;  goto s1_1_1_WB0;
			:: msgs?msg0B;  goto s1_1_1_BB0;
			:: msgs?msg0B;  goto s1_1_1_WB0;
			:: msgs?msg1R;  goto s1_1_1_WR0;
			:: msgs?msg1R;  goto s1_1_1_WB0;
			:: msgs?msg1W;  goto s1_1_1_WW0;
			:: msgs?msg1W;  goto s1_1_1_WB0;
			:: msgs?msg1B;  goto s1_1_1_WB0;
			:: msgs?msg2R;  goto s1_1_1_WBR;
			:: msgs?msg2R;  goto s1_1_1_WB0;
			:: msgs?msg2W;  goto s1_1_1_WBW;
			:: msgs?msg2W;  goto s1_1_1_WB0;
			:: msgs?msg2B;  goto s1_1_1_WBB;
			:: msgs?msg2B;  goto s1_1_1_WB0;
		fi;
	s1_1_1_W0R: if
			:: acks!ack0;  goto s1_1_1_W0R;
			:: msgs?msg0R;  goto s1_1_1_R0R;
			:: msgs?msg0R;  goto s1_1_1_W0R;
			:: msgs?msg0W;  goto s1_1_1_W0R;
			:: msgs?msg0B;  goto s1_1_1_B0R;
			:: msgs?msg0B;  goto s1_1_1_W0R;
			:: msgs?msg1R;  goto s1_1_1_WRR;
			:: msgs?msg1R;  goto s1_1_1_W0R;
			:: msgs?msg1W;  goto s1_1_1_WWR;
			:: msgs?msg1W;  goto s1_1_1_W0R;
			:: msgs?msg1B;  goto s1_1_1_WBR;
			:: msgs?msg1B;  goto s1_1_1_W0R;
			:: msgs?msg2R;  goto s1_1_1_W0R;
			:: msgs?msg2W;  goto s1_1_1_W0W;
			:: msgs?msg2W;  goto s1_1_1_W0R;
			:: msgs?msg2B;  goto s1_1_1_W0B;
			:: msgs?msg2B;  goto s1_1_1_W0R;
		fi;
	s1_1_1_W0W: if
			:: acks!ack0;  goto s1_1_1_W0W;
			:: msgs?msg0R;  goto s1_1_1_R0W;
			:: msgs?msg0R;  goto s1_1_1_W0W;
			:: msgs?msg0W;  goto s1_1_1_W0W;
			:: msgs?msg0B;  goto s1_1_1_B0W;
			:: msgs?msg0B;  goto s1_1_1_W0W;
			:: msgs?msg1R;  goto s1_1_1_WRW;
			:: msgs?msg1R;  goto s1_1_1_W0W;
			:: msgs?msg1W;  goto s1_1_1_WWW;
			:: msgs?msg1W;  goto s1_1_1_W0W;
			:: msgs?msg1B;  goto s1_1_1_WBW;
			:: msgs?msg1B;  goto s1_1_1_W0W;
			:: msgs?msg2R;  goto s1_1_1_W0R;
			:: msgs?msg2R;  goto s1_1_1_W0W;
			:: msgs?msg2W;  goto s1_1_1_W0W;
			:: msgs?msg2B;  goto s1_1_1_W0B;
			:: msgs?msg2B;  goto s1_1_1_W0W;
		fi;
	s1_1_1_W0B: if
			:: acks!ack0;  goto s1_1_1_W0B;
			:: msgs?msg0R;  goto s1_1_1_R0B;
			:: msgs?msg0R;  goto s1_1_1_W0B;
			:: msgs?msg0W;  goto s1_1_1_W0B;
			:: msgs?msg0B;  goto s1_1_1_B0B;
			:: msgs?msg0B;  goto s1_1_1_W0B;
			:: msgs?msg1R;  goto s1_1_1_WRB;
			:: msgs?msg1R;  goto s1_1_1_W0B;
			:: msgs?msg1W;  goto s1_1_1_WWB;
			:: msgs?msg1W;  goto s1_1_1_W0B;
			:: msgs?msg1B;  goto s1_1_1_WBB;
			:: msgs?msg1B;  goto s1_1_1_W0B;
			:: msgs?msg2R;  goto s1_1_1_W0R;
			:: msgs?msg2R;  goto s1_1_1_W0B;
			:: msgs?msg2W;  goto s1_1_1_W0W;
			:: msgs?msg2W;  goto s1_1_1_W0B;
			:: msgs?msg2B;  goto s1_1_1_W0B;
		fi;
	s1_1_1_BR0: if
			:: out!outR;  goto s1_2_2_B00;
			:: msgs?msg0R;  goto s1_1_1_RR0;
			:: msgs?msg0R;  goto s1_1_1_BR0;
			:: msgs?msg0W;  goto s1_1_1_WR0;
			:: msgs?msg0W;  goto s1_1_1_BR0;
			:: msgs?msg0B;  goto s1_1_1_BR0;
			:: msgs?msg1R;  goto s1_1_1_BR0;
			:: msgs?msg1W;  goto s1_1_1_BW0;
			:: msgs?msg1W;  goto s1_1_1_BR0;
			:: msgs?msg1B;  goto s1_1_1_BB0;
			:: msgs?msg1B;  goto s1_1_1_BR0;
			:: msgs?msg2R;  goto s1_1_1_BRR;
			:: msgs?msg2R;  goto s1_1_1_BR0;
			:: msgs?msg2W;  goto s1_1_1_BRW;
			:: msgs?msg2W;  goto s1_1_1_BR0;
			:: msgs?msg2B;  goto s1_1_1_BRB;
			:: msgs?msg2B;  goto s1_1_1_BR0;
		fi;
	s1_1_1_BW0: if
			:: out!outW;  goto s1_2_2_B00;
			:: msgs?msg0R;  goto s1_1_1_RW0;
			:: msgs?msg0R;  goto s1_1_1_BW0;
			:: msgs?msg0W;  goto s1_1_1_WW0;
			:: msgs?msg0W;  goto s1_1_1_BW0;
			:: msgs?msg0B;  goto s1_1_1_BW0;
			:: msgs?msg1R;  goto s1_1_1_BR0;
			:: msgs?msg1R;  goto s1_1_1_BW0;
			:: msgs?msg1W;  goto s1_1_1_BW0;
			:: msgs?msg1B;  goto s1_1_1_BB0;
			:: msgs?msg1B;  goto s1_1_1_BW0;
			:: msgs?msg2R;  goto s1_1_1_BWR;
			:: msgs?msg2R;  goto s1_1_1_BW0;
			:: msgs?msg2W;  goto s1_1_1_BWW;
			:: msgs?msg2W;  goto s1_1_1_BW0;
			:: msgs?msg2B;  goto s1_1_1_BWB;
			:: msgs?msg2B;  goto s1_1_1_BW0;
		fi;
	s1_1_1_BB0: if
			:: out!outB;  goto s1_2_2_B00;
			:: msgs?msg0R;  goto s1_1_1_RB0;
			:: msgs?msg0R;  goto s1_1_1_BB0;
			:: msgs?msg0W;  goto s1_1_1_WB0;
			:: msgs?msg0W;  goto s1_1_1_BB0;
			:: msgs?msg0B;  goto s1_1_1_BB0;
			:: msgs?msg1R;  goto s1_1_1_BR0;
			:: msgs?msg1R;  goto s1_1_1_BB0;
			:: msgs?msg1W;  goto s1_1_1_BW0;
			:: msgs?msg1W;  goto s1_1_1_BB0;
			:: msgs?msg1B;  goto s1_1_1_BB0;
			:: msgs?msg2R;  goto s1_1_1_BBR;
			:: msgs?msg2R;  goto s1_1_1_BB0;
			:: msgs?msg2W;  goto s1_1_1_BBW;
			:: msgs?msg2W;  goto s1_1_1_BB0;
			:: msgs?msg2B;  goto s1_1_1_BBB;
			:: msgs?msg2B;  goto s1_1_1_BB0;
		fi;
	s1_1_1_B0R: if
			:: acks!ack0;  goto s1_1_1_B0R;
			:: msgs?msg0R;  goto s1_1_1_R0R;
			:: msgs?msg0R;  goto s1_1_1_B0R;
			:: msgs?msg0W;  goto s1_1_1_W0R;
			:: msgs?msg0W;  goto s1_1_1_B0R;
			:: msgs?msg0B;  goto s1_1_1_B0R;
			:: msgs?msg1R;  goto s1_1_1_BRR;
			:: msgs?msg1R;  goto s1_1_1_B0R;
			:: msgs?msg1W;  goto s1_1_1_BWR;
			:: msgs?msg1W;  goto s1_1_1_B0R;
			:: msgs?msg1B;  goto s1_1_1_BBR;
			:: msgs?msg1B;  goto s1_1_1_B0R;
			:: msgs?msg2R;  goto s1_1_1_B0R;
			:: msgs?msg2W;  goto s1_1_1_B0W;
			:: msgs?msg2W;  goto s1_1_1_B0R;
			:: msgs?msg2B;  goto s1_1_1_B0B;
			:: msgs?msg2B;  goto s1_1_1_B0R;
		fi;
	s1_1_1_B0W: if
			:: acks!ack0;  goto s1_1_1_B0W;
			:: msgs?msg0R;  goto s1_1_1_R0W;
			:: msgs?msg0R;  goto s1_1_1_B0W;
			:: msgs?msg0W;  goto s1_1_1_W0W;
			:: msgs?msg0W;  goto s1_1_1_B0W;
			:: msgs?msg0B;  goto s1_1_1_B0W;
			:: msgs?msg1R;  goto s1_1_1_BRW;
			:: msgs?msg1R;  goto s1_1_1_B0W;
			:: msgs?msg1W;  goto s1_1_1_BWW;
			:: msgs?msg1W;  goto s1_1_1_B0W;
			:: msgs?msg1B;  goto s1_1_1_BBW;
			:: msgs?msg1B;  goto s1_1_1_B0W;
			:: msgs?msg2R;  goto s1_1_1_B0R;
			:: msgs?msg2R;  goto s1_1_1_B0W;
			:: msgs?msg2W;  goto s1_1_1_B0W;
			:: msgs?msg2B;  goto s1_1_1_B0B;
			:: msgs?msg2B;  goto s1_1_1_B0W;
		fi;
	s1_1_1_B0B: if
			:: acks!ack0;  goto s1_1_1_B0B;
			:: msgs?msg0R;  goto s1_1_1_R0B;
			:: msgs?msg0R;  goto s1_1_1_B0B;
			:: msgs?msg0W;  goto s1_1_1_W0B;
			:: msgs?msg0W;  goto s1_1_1_B0B;
			:: msgs?msg0B;  goto s1_1_1_B0B;
			:: msgs?msg1R;  goto s1_1_1_BRB;
			:: msgs?msg1R;  goto s1_1_1_B0B;
			:: msgs?msg1W;  goto s1_1_1_BWB;
			:: msgs?msg1W;  goto s1_1_1_B0B;
			:: msgs?msg1B;  goto s1_1_1_BBB;
			:: msgs?msg1B;  goto s1_1_1_B0B;
			:: msgs?msg2R;  goto s1_1_1_B0R;
			:: msgs?msg2R;  goto s1_1_1_B0B;
			:: msgs?msg2W;  goto s1_1_1_B0W;
			:: msgs?msg2W;  goto s1_1_1_B0B;
			:: msgs?msg2B;  goto s1_1_1_B0B;
		fi;
	s1_2_2_000: if
			:: acks!ack1;  goto s1_2_2_000;
			:: msgs?msg0R;  goto s1_2_2_R00;
			:: msgs?msg0R;  goto s1_2_2_000;
			:: msgs?msg0W;  goto s1_2_2_W00;
			:: msgs?msg0W;  goto s1_2_2_000;
			:: msgs?msg0B;  goto s1_2_2_B00;
			:: msgs?msg0B;  goto s1_2_2_000;
			:: msgs?msg1R;  goto s1_2_2_0R0;
			:: msgs?msg1R;  goto s1_2_2_000;
			:: msgs?msg1W;  goto s1_2_2_0W0;
			:: msgs?msg1W;  goto s1_2_2_000;
			:: msgs?msg1B;  goto s1_2_2_0B0;
			:: msgs?msg1B;  goto s1_2_2_000;
			:: msgs?msg2R;  goto s1_2_2_00R;
			:: msgs?msg2R;  goto s1_2_2_000;
			:: msgs?msg2W;  goto s1_2_2_00W;
			:: msgs?msg2W;  goto s1_2_2_000;
			:: msgs?msg2B;  goto s1_2_2_00B;
			:: msgs?msg2B;  goto s1_2_2_000;
		fi;
	s1_1_1_0RR: if
			:: out!outR;  goto s1_2_2_00R;
			:: msgs?msg0R;  goto s1_1_1_RRR;
			:: msgs?msg0R;  goto s1_1_1_0RR;
			:: msgs?msg0W;  goto s1_1_1_WRR;
			:: msgs?msg0W;  goto s1_1_1_0RR;
			:: msgs?msg0B;  goto s1_1_1_BRR;
			:: msgs?msg0B;  goto s1_1_1_0RR;
			:: msgs?msg1R;  goto s1_1_1_0RR;
			:: msgs?msg1W;  goto s1_1_1_0WR;
			:: msgs?msg1W;  goto s1_1_1_0RR;
			:: msgs?msg1B;  goto s1_1_1_0BR;
			:: msgs?msg1B;  goto s1_1_1_0RR;
			:: msgs?msg2R;  goto s1_1_1_0RR;
			:: msgs?msg2W;  goto s1_1_1_0RW;
			:: msgs?msg2W;  goto s1_1_1_0RR;
			:: msgs?msg2B;  goto s1_1_1_0RB;
			:: msgs?msg2B;  goto s1_1_1_0RR;
		fi;
	s1_1_1_0RW: if
			:: out!outR;  goto s1_2_2_00W;
			:: msgs?msg0R;  goto s1_1_1_RRW;
			:: msgs?msg0R;  goto s1_1_1_0RW;
			:: msgs?msg0W;  goto s1_1_1_WRW;
			:: msgs?msg0W;  goto s1_1_1_0RW;
			:: msgs?msg0B;  goto s1_1_1_BRW;
			:: msgs?msg0B;  goto s1_1_1_0RW;
			:: msgs?msg1R;  goto s1_1_1_0RW;
			:: msgs?msg1W;  goto s1_1_1_0WW;
			:: msgs?msg1W;  goto s1_1_1_0RW;
			:: msgs?msg1B;  goto s1_1_1_0BW;
			:: msgs?msg1B;  goto s1_1_1_0RW;
			:: msgs?msg2R;  goto s1_1_1_0RR;
			:: msgs?msg2R;  goto s1_1_1_0RW;
			:: msgs?msg2W;  goto s1_1_1_0RW;
			:: msgs?msg2B;  goto s1_1_1_0RB;
			:: msgs?msg2B;  goto s1_1_1_0RW;
		fi;
	s1_1_1_0RB: if
			:: out!outR;  goto s1_2_2_00B;
			:: msgs?msg0R;  goto s1_1_1_RRB;
			:: msgs?msg0R;  goto s1_1_1_0RB;
			:: msgs?msg0W;  goto s1_1_1_WRB;
			:: msgs?msg0W;  goto s1_1_1_0RB;
			:: msgs?msg0B;  goto s1_1_1_BRB;
			:: msgs?msg0B;  goto s1_1_1_0RB;
			:: msgs?msg1R;  goto s1_1_1_0RB;
			:: msgs?msg1W;  goto s1_1_1_0WB;
			:: msgs?msg1W;  goto s1_1_1_0RB;
			:: msgs?msg1B;  goto s1_1_1_0BB;
			:: msgs?msg1B;  goto s1_1_1_0RB;
			:: msgs?msg2R;  goto s1_1_1_0RR;
			:: msgs?msg2R;  goto s1_1_1_0RB;
			:: msgs?msg2W;  goto s1_1_1_0RW;
			:: msgs?msg2W;  goto s1_1_1_0RB;
			:: msgs?msg2B;  goto s1_1_1_0RB;
		fi;
	s1_1_1_0WR: if
			:: out!outW;  goto s1_2_2_00R;
			:: msgs?msg0R;  goto s1_1_1_RWR;
			:: msgs?msg0R;  goto s1_1_1_0WR;
			:: msgs?msg0W;  goto s1_1_1_WWR;
			:: msgs?msg0W;  goto s1_1_1_0WR;
			:: msgs?msg0B;  goto s1_1_1_BWR;
			:: msgs?msg0B;  goto s1_1_1_0WR;
			:: msgs?msg1R;  goto s1_1_1_0RR;
			:: msgs?msg1R;  goto s1_1_1_0WR;
			:: msgs?msg1W;  goto s1_1_1_0WR;
			:: msgs?msg1B;  goto s1_1_1_0BR;
			:: msgs?msg1B;  goto s1_1_1_0WR;
			:: msgs?msg2R;  goto s1_1_1_0WR;
			:: msgs?msg2W;  goto s1_1_1_0WW;
			:: msgs?msg2W;  goto s1_1_1_0WR;
			:: msgs?msg2B;  goto s1_1_1_0WB;
			:: msgs?msg2B;  goto s1_1_1_0WR;
		fi;
	s1_1_1_0WW: if
			:: out!outW;  goto s1_2_2_00W;
			:: msgs?msg0R;  goto s1_1_1_RWW;
			:: msgs?msg0R;  goto s1_1_1_0WW;
			:: msgs?msg0W;  goto s1_1_1_WWW;
			:: msgs?msg0W;  goto s1_1_1_0WW;
			:: msgs?msg0B;  goto s1_1_1_BWW;
			:: msgs?msg0B;  goto s1_1_1_0WW;
			:: msgs?msg1R;  goto s1_1_1_0RW;
			:: msgs?msg1R;  goto s1_1_1_0WW;
			:: msgs?msg1W;  goto s1_1_1_0WW;
			:: msgs?msg1B;  goto s1_1_1_0BW;
			:: msgs?msg1B;  goto s1_1_1_0WW;
			:: msgs?msg2R;  goto s1_1_1_0WR;
			:: msgs?msg2R;  goto s1_1_1_0WW;
			:: msgs?msg2W;  goto s1_1_1_0WW;
			:: msgs?msg2B;  goto s1_1_1_0WB;
			:: msgs?msg2B;  goto s1_1_1_0WW;
		fi;
	s1_1_1_0WB: if
			:: out!outW;  goto s1_2_2_00B;
			:: msgs?msg0R;  goto s1_1_1_RWB;
			:: msgs?msg0R;  goto s1_1_1_0WB;
			:: msgs?msg0W;  goto s1_1_1_WWB;
			:: msgs?msg0W;  goto s1_1_1_0WB;
			:: msgs?msg0B;  goto s1_1_1_BWB;
			:: msgs?msg0B;  goto s1_1_1_0WB;
			:: msgs?msg1R;  goto s1_1_1_0RB;
			:: msgs?msg1R;  goto s1_1_1_0WB;
			:: msgs?msg1W;  goto s1_1_1_0WB;
			:: msgs?msg1B;  goto s1_1_1_0BB;
			:: msgs?msg1B;  goto s1_1_1_0WB;
			:: msgs?msg2R;  goto s1_1_1_0WR;
			:: msgs?msg2R;  goto s1_1_1_0WB;
			:: msgs?msg2W;  goto s1_1_1_0WW;
			:: msgs?msg2W;  goto s1_1_1_0WB;
			:: msgs?msg2B;  goto s1_1_1_0WB;
		fi;
	s1_1_1_0BR: if
			:: out!outB;  goto s1_2_2_00R;
			:: msgs?msg0R;  goto s1_1_1_RBR;
			:: msgs?msg0R;  goto s1_1_1_0BR;
			:: msgs?msg0W;  goto s1_1_1_WBR;
			:: msgs?msg0W;  goto s1_1_1_0BR;
			:: msgs?msg0B;  goto s1_1_1_BBR;
			:: msgs?msg0B;  goto s1_1_1_0BR;
			:: msgs?msg1R;  goto s1_1_1_0RR;
			:: msgs?msg1R;  goto s1_1_1_0BR;
			:: msgs?msg1W;  goto s1_1_1_0WR;
			:: msgs?msg1W;  goto s1_1_1_0BR;
			:: msgs?msg1B;  goto s1_1_1_0BR;
			:: msgs?msg2R;  goto s1_1_1_0BR;
			:: msgs?msg2W;  goto s1_1_1_0BW;
			:: msgs?msg2W;  goto s1_1_1_0BR;
			:: msgs?msg2B;  goto s1_1_1_0BB;
			:: msgs?msg2B;  goto s1_1_1_0BR;
		fi;
	s1_1_1_0BW: if
			:: out!outB;  goto s1_2_2_00W;
			:: msgs?msg0R;  goto s1_1_1_RBW;
			:: msgs?msg0R;  goto s1_1_1_0BW;
			:: msgs?msg0W;  goto s1_1_1_WBW;
			:: msgs?msg0W;  goto s1_1_1_0BW;
			:: msgs?msg0B;  goto s1_1_1_BBW;
			:: msgs?msg0B;  goto s1_1_1_0BW;
			:: msgs?msg1R;  goto s1_1_1_0RW;
			:: msgs?msg1R;  goto s1_1_1_0BW;
			:: msgs?msg1W;  goto s1_1_1_0WW;
			:: msgs?msg1W;  goto s1_1_1_0BW;
			:: msgs?msg1B;  goto s1_1_1_0BW;
			:: msgs?msg2R;  goto s1_1_1_0BR;
			:: msgs?msg2R;  goto s1_1_1_0BW;
			:: msgs?msg2W;  goto s1_1_1_0BW;
			:: msgs?msg2B;  goto s1_1_1_0BB;
			:: msgs?msg2B;  goto s1_1_1_0BW;
		fi;
	s1_1_1_0BB: if
			:: out!outB;  goto s1_2_2_00B;
			:: msgs?msg0R;  goto s1_1_1_RBB;
			:: msgs?msg0R;  goto s1_1_1_0BB;
			:: msgs?msg0W;  goto s1_1_1_WBB;
			:: msgs?msg0W;  goto s1_1_1_0BB;
			:: msgs?msg0B;  goto s1_1_1_BBB;
			:: msgs?msg0B;  goto s1_1_1_0BB;
			:: msgs?msg1R;  goto s1_1_1_0RB;
			:: msgs?msg1R;  goto s1_1_1_0BB;
			:: msgs?msg1W;  goto s1_1_1_0WB;
			:: msgs?msg1W;  goto s1_1_1_0BB;
			:: msgs?msg1B;  goto s1_1_1_0BB;
			:: msgs?msg2R;  goto s1_1_1_0BR;
			:: msgs?msg2R;  goto s1_1_1_0BB;
			:: msgs?msg2W;  goto s1_1_1_0BW;
			:: msgs?msg2W;  goto s1_1_1_0BB;
			:: msgs?msg2B;  goto s1_1_1_0BB;
		fi;
	s1_2_2_R00: if
			:: acks!ack1;  goto s1_2_2_R00;
			:: msgs?msg0R;  goto s1_2_2_R00;
			:: msgs?msg0W;  goto s1_2_2_W00;
			:: msgs?msg0W;  goto s1_2_2_R00;
			:: msgs?msg0B;  goto s1_2_2_B00;
			:: msgs?msg0B;  goto s1_2_2_R00;
			:: msgs?msg1R;  goto s1_2_2_RR0;
			:: msgs?msg1R;  goto s1_2_2_R00;
			:: msgs?msg1W;  goto s1_2_2_RW0;
			:: msgs?msg1W;  goto s1_2_2_R00;
			:: msgs?msg1B;  goto s1_2_2_RB0;
			:: msgs?msg1B;  goto s1_2_2_R00;
			:: msgs?msg2R;  goto s1_2_2_R0R;
			:: msgs?msg2R;  goto s1_2_2_R00;
			:: msgs?msg2W;  goto s1_2_2_R0W;
			:: msgs?msg2W;  goto s1_2_2_R00;
			:: msgs?msg2B;  goto s1_2_2_R0B;
			:: msgs?msg2B;  goto s1_2_2_R00;
		fi;
	s1_1_1_RRR: if
			:: out!outR;  goto s1_2_2_R0R;
			:: msgs?msg0R;  goto s1_1_1_RRR;
			:: msgs?msg0W;  goto s1_1_1_WRR;
			:: msgs?msg0W;  goto s1_1_1_RRR;
			:: msgs?msg0B;  goto s1_1_1_BRR;
			:: msgs?msg0B;  goto s1_1_1_RRR;
			:: msgs?msg1R;  goto s1_1_1_RRR;
			:: msgs?msg1W;  goto s1_1_1_RWR;
			:: msgs?msg1W;  goto s1_1_1_RRR;
			:: msgs?msg1B;  goto s1_1_1_RBR;
			:: msgs?msg1B;  goto s1_1_1_RRR;
			:: msgs?msg2R;  goto s1_1_1_RRR;
			:: msgs?msg2W;  goto s1_1_1_RRW;
			:: msgs?msg2W;  goto s1_1_1_RRR;
			:: msgs?msg2B;  goto s1_1_1_RRB;
			:: msgs?msg2B;  goto s1_1_1_RRR;
		fi;
	s1_1_1_RRW: if
			:: out!outR;  goto s1_2_2_R0W;
			:: msgs?msg0R;  goto s1_1_1_RRW;
			:: msgs?msg0W;  goto s1_1_1_WRW;
			:: msgs?msg0W;  goto s1_1_1_RRW;
			:: msgs?msg0B;  goto s1_1_1_BRW;
			:: msgs?msg0B;  goto s1_1_1_RRW;
			:: msgs?msg1R;  goto s1_1_1_RRW;
			:: msgs?msg1W;  goto s1_1_1_RWW;
			:: msgs?msg1W;  goto s1_1_1_RRW;
			:: msgs?msg1B;  goto s1_1_1_RBW;
			:: msgs?msg1B;  goto s1_1_1_RRW;
			:: msgs?msg2R;  goto s1_1_1_RRR;
			:: msgs?msg2R;  goto s1_1_1_RRW;
			:: msgs?msg2W;  goto s1_1_1_RRW;
			:: msgs?msg2B;  goto s1_1_1_RRB;
			:: msgs?msg2B;  goto s1_1_1_RRW;
		fi;
	s1_1_1_RRB: if
			:: out!outR;  goto s1_2_2_R0B;
			:: msgs?msg0R;  goto s1_1_1_RRB;
			:: msgs?msg0W;  goto s1_1_1_WRB;
			:: msgs?msg0W;  goto s1_1_1_RRB;
			:: msgs?msg0B;  goto s1_1_1_BRB;
			:: msgs?msg0B;  goto s1_1_1_RRB;
			:: msgs?msg1R;  goto s1_1_1_RRB;
			:: msgs?msg1W;  goto s1_1_1_RWB;
			:: msgs?msg1W;  goto s1_1_1_RRB;
			:: msgs?msg1B;  goto s1_1_1_RBB;
			:: msgs?msg1B;  goto s1_1_1_RRB;
			:: msgs?msg2R;  goto s1_1_1_RRR;
			:: msgs?msg2R;  goto s1_1_1_RRB;
			:: msgs?msg2W;  goto s1_1_1_RRW;
			:: msgs?msg2W;  goto s1_1_1_RRB;
			:: msgs?msg2B;  goto s1_1_1_RRB;
		fi;
	s1_1_1_RWR: if
			:: out!outW;  goto s1_2_2_R0R;
			:: msgs?msg0R;  goto s1_1_1_RWR;
			:: msgs?msg0W;  goto s1_1_1_WWR;
			:: msgs?msg0W;  goto s1_1_1_RWR;
			:: msgs?msg0B;  goto s1_1_1_BWR;
			:: msgs?msg0B;  goto s1_1_1_RWR;
			:: msgs?msg1R;  goto s1_1_1_RRR;
			:: msgs?msg1R;  goto s1_1_1_RWR;
			:: msgs?msg1W;  goto s1_1_1_RWR;
			:: msgs?msg1B;  goto s1_1_1_RBR;
			:: msgs?msg1B;  goto s1_1_1_RWR;
			:: msgs?msg2R;  goto s1_1_1_RWR;
			:: msgs?msg2W;  goto s1_1_1_RWW;
			:: msgs?msg2W;  goto s1_1_1_RWR;
			:: msgs?msg2B;  goto s1_1_1_RWB;
			:: msgs?msg2B;  goto s1_1_1_RWR;
		fi;
	s1_1_1_RWW: if
			:: out!outW;  goto s1_2_2_R0W;
			:: msgs?msg0R;  goto s1_1_1_RWW;
			:: msgs?msg0W;  goto s1_1_1_WWW;
			:: msgs?msg0W;  goto s1_1_1_RWW;
			:: msgs?msg0B;  goto s1_1_1_BWW;
			:: msgs?msg0B;  goto s1_1_1_RWW;
			:: msgs?msg1R;  goto s1_1_1_RRW;
			:: msgs?msg1R;  goto s1_1_1_RWW;
			:: msgs?msg1W;  goto s1_1_1_RWW;
			:: msgs?msg1B;  goto s1_1_1_RBW;
			:: msgs?msg1B;  goto s1_1_1_RWW;
			:: msgs?msg2R;  goto s1_1_1_RWR;
			:: msgs?msg2R;  goto s1_1_1_RWW;
			:: msgs?msg2W;  goto s1_1_1_RWW;
			:: msgs?msg2B;  goto s1_1_1_RWB;
			:: msgs?msg2B;  goto s1_1_1_RWW;
		fi;
	s1_1_1_RWB: if
			:: out!outW;  goto s1_2_2_R0B;
			:: msgs?msg0R;  goto s1_1_1_RWB;
			:: msgs?msg0W;  goto s1_1_1_WWB;
			:: msgs?msg0W;  goto s1_1_1_RWB;
			:: msgs?msg0B;  goto s1_1_1_BWB;
			:: msgs?msg0B;  goto s1_1_1_RWB;
			:: msgs?msg1R;  goto s1_1_1_RRB;
			:: msgs?msg1R;  goto s1_1_1_RWB;
			:: msgs?msg1W;  goto s1_1_1_RWB;
			:: msgs?msg1B;  goto s1_1_1_RBB;
			:: msgs?msg1B;  goto s1_1_1_RWB;
			:: msgs?msg2R;  goto s1_1_1_RWR;
			:: msgs?msg2R;  goto s1_1_1_RWB;
			:: msgs?msg2W;  goto s1_1_1_RWW;
			:: msgs?msg2W;  goto s1_1_1_RWB;
			:: msgs?msg2B;  goto s1_1_1_RWB;
		fi;
	s1_1_1_RBR: if
			:: out!outB;  goto s1_2_2_R0R;
			:: msgs?msg0R;  goto s1_1_1_RBR;
			:: msgs?msg0W;  goto s1_1_1_WBR;
			:: msgs?msg0W;  goto s1_1_1_RBR;
			:: msgs?msg0B;  goto s1_1_1_BBR;
			:: msgs?msg0B;  goto s1_1_1_RBR;
			:: msgs?msg1R;  goto s1_1_1_RRR;
			:: msgs?msg1R;  goto s1_1_1_RBR;
			:: msgs?msg1W;  goto s1_1_1_RWR;
			:: msgs?msg1W;  goto s1_1_1_RBR;
			:: msgs?msg1B;  goto s1_1_1_RBR;
			:: msgs?msg2R;  goto s1_1_1_RBR;
			:: msgs?msg2W;  goto s1_1_1_RBW;
			:: msgs?msg2W;  goto s1_1_1_RBR;
			:: msgs?msg2B;  goto s1_1_1_RBB;
			:: msgs?msg2B;  goto s1_1_1_RBR;
		fi;
	s1_1_1_RBW: if
			:: out!outB;  goto s1_2_2_R0W;
			:: msgs?msg0R;  goto s1_1_1_RBW;
			:: msgs?msg0W;  goto s1_1_1_WBW;
			:: msgs?msg0W;  goto s1_1_1_RBW;
			:: msgs?msg0B;  goto s1_1_1_BBW;
			:: msgs?msg0B;  goto s1_1_1_RBW;
			:: msgs?msg1R;  goto s1_1_1_RRW;
			:: msgs?msg1R;  goto s1_1_1_RBW;
			:: msgs?msg1W;  goto s1_1_1_RWW;
			:: msgs?msg1W;  goto s1_1_1_RBW;
			:: msgs?msg1B;  goto s1_1_1_RBW;
			:: msgs?msg2R;  goto s1_1_1_RBR;
			:: msgs?msg2R;  goto s1_1_1_RBW;
			:: msgs?msg2W;  goto s1_1_1_RBW;
			:: msgs?msg2B;  goto s1_1_1_RBB;
			:: msgs?msg2B;  goto s1_1_1_RBW;
		fi;
	s1_1_1_RBB: if
			:: out!outB;  goto s1_2_2_R0B;
			:: msgs?msg0R;  goto s1_1_1_RBB;
			:: msgs?msg0W;  goto s1_1_1_WBB;
			:: msgs?msg0W;  goto s1_1_1_RBB;
			:: msgs?msg0B;  goto s1_1_1_BBB;
			:: msgs?msg0B;  goto s1_1_1_RBB;
			:: msgs?msg1R;  goto s1_1_1_RRB;
			:: msgs?msg1R;  goto s1_1_1_RBB;
			:: msgs?msg1W;  goto s1_1_1_RWB;
			:: msgs?msg1W;  goto s1_1_1_RBB;
			:: msgs?msg1B;  goto s1_1_1_RBB;
			:: msgs?msg2R;  goto s1_1_1_RBR;
			:: msgs?msg2R;  goto s1_1_1_RBB;
			:: msgs?msg2W;  goto s1_1_1_RBW;
			:: msgs?msg2W;  goto s1_1_1_RBB;
			:: msgs?msg2B;  goto s1_1_1_RBB;
		fi;
	s1_2_2_W00: if
			:: acks!ack1;  goto s1_2_2_W00;
			:: msgs?msg0R;  goto s1_2_2_R00;
			:: msgs?msg0R;  goto s1_2_2_W00;
			:: msgs?msg0W;  goto s1_2_2_W00;
			:: msgs?msg0B;  goto s1_2_2_B00;
			:: msgs?msg0B;  goto s1_2_2_W00;
			:: msgs?msg1R;  goto s1_2_2_WR0;
			:: msgs?msg1R;  goto s1_2_2_W00;
			:: msgs?msg1W;  goto s1_2_2_WW0;
			:: msgs?msg1W;  goto s1_2_2_W00;
			:: msgs?msg1B;  goto s1_2_2_WB0;
			:: msgs?msg1B;  goto s1_2_2_W00;
			:: msgs?msg2R;  goto s1_2_2_W0R;
			:: msgs?msg2R;  goto s1_2_2_W00;
			:: msgs?msg2W;  goto s1_2_2_W0W;
			:: msgs?msg2W;  goto s1_2_2_W00;
			:: msgs?msg2B;  goto s1_2_2_W0B;
			:: msgs?msg2B;  goto s1_2_2_W00;
		fi;
	s1_1_1_WRR: if
			:: out!outR;  goto s1_2_2_W0R;
			:: msgs?msg0R;  goto s1_1_1_RRR;
			:: msgs?msg0R;  goto s1_1_1_WRR;
			:: msgs?msg0W;  goto s1_1_1_WRR;
			:: msgs?msg0B;  goto s1_1_1_BRR;
			:: msgs?msg0B;  goto s1_1_1_WRR;
			:: msgs?msg1R;  goto s1_1_1_WRR;
			:: msgs?msg1W;  goto s1_1_1_WWR;
			:: msgs?msg1W;  goto s1_1_1_WRR;
			:: msgs?msg1B;  goto s1_1_1_WBR;
			:: msgs?msg1B;  goto s1_1_1_WRR;
			:: msgs?msg2R;  goto s1_1_1_WRR;
			:: msgs?msg2W;  goto s1_1_1_WRW;
			:: msgs?msg2W;  goto s1_1_1_WRR;
			:: msgs?msg2B;  goto s1_1_1_WRB;
			:: msgs?msg2B;  goto s1_1_1_WRR;
		fi;
	s1_1_1_WRW: if
			:: out!outR;  goto s1_2_2_W0W;
			:: msgs?msg0R;  goto s1_1_1_RRW;
			:: msgs?msg0R;  goto s1_1_1_WRW;
			:: msgs?msg0W;  goto s1_1_1_WRW;
			:: msgs?msg0B;  goto s1_1_1_BRW;
			:: msgs?msg0B;  goto s1_1_1_WRW;
			:: msgs?msg1R;  goto s1_1_1_WRW;
			:: msgs?msg1W;  goto s1_1_1_WWW;
			:: msgs?msg1W;  goto s1_1_1_WRW;
			:: msgs?msg1B;  goto s1_1_1_WBW;
			:: msgs?msg1B;  goto s1_1_1_WRW;
			:: msgs?msg2R;  goto s1_1_1_WRR;
			:: msgs?msg2R;  goto s1_1_1_WRW;
			:: msgs?msg2W;  goto s1_1_1_WRW;
			:: msgs?msg2B;  goto s1_1_1_WRB;
			:: msgs?msg2B;  goto s1_1_1_WRW;
		fi;
	s1_1_1_WRB: if
			:: out!outR;  goto s1_2_2_W0B;
			:: msgs?msg0R;  goto s1_1_1_RRB;
			:: msgs?msg0R;  goto s1_1_1_WRB;
			:: msgs?msg0W;  goto s1_1_1_WRB;
			:: msgs?msg0B;  goto s1_1_1_BRB;
			:: msgs?msg0B;  goto s1_1_1_WRB;
			:: msgs?msg1R;  goto s1_1_1_WRB;
			:: msgs?msg1W;  goto s1_1_1_WWB;
			:: msgs?msg1W;  goto s1_1_1_WRB;
			:: msgs?msg1B;  goto s1_1_1_WBB;
			:: msgs?msg1B;  goto s1_1_1_WRB;
			:: msgs?msg2R;  goto s1_1_1_WRR;
			:: msgs?msg2R;  goto s1_1_1_WRB;
			:: msgs?msg2W;  goto s1_1_1_WRW;
			:: msgs?msg2W;  goto s1_1_1_WRB;
			:: msgs?msg2B;  goto s1_1_1_WRB;
		fi;
	s1_1_1_WWR: if
			:: out!outW;  goto s1_2_2_W0R;
			:: msgs?msg0R;  goto s1_1_1_RWR;
			:: msgs?msg0R;  goto s1_1_1_WWR;
			:: msgs?msg0W;  goto s1_1_1_WWR;
			:: msgs?msg0B;  goto s1_1_1_BWR;
			:: msgs?msg0B;  goto s1_1_1_WWR;
			:: msgs?msg1R;  goto s1_1_1_WRR;
			:: msgs?msg1R;  goto s1_1_1_WWR;
			:: msgs?msg1W;  goto s1_1_1_WWR;
			:: msgs?msg1B;  goto s1_1_1_WBR;
			:: msgs?msg1B;  goto s1_1_1_WWR;
			:: msgs?msg2R;  goto s1_1_1_WWR;
			:: msgs?msg2W;  goto s1_1_1_WWW;
			:: msgs?msg2W;  goto s1_1_1_WWR;
			:: msgs?msg2B;  goto s1_1_1_WWB;
			:: msgs?msg2B;  goto s1_1_1_WWR;
		fi;
	s1_1_1_WWW: if
			:: out!outW;  goto s1_2_2_W0W;
			:: msgs?msg0R;  goto s1_1_1_RWW;
			:: msgs?msg0R;  goto s1_1_1_WWW;
			:: msgs?msg0W;  goto s1_1_1_WWW;
			:: msgs?msg0B;  goto s1_1_1_BWW;
			:: msgs?msg0B;  goto s1_1_1_WWW;
			:: msgs?msg1R;  goto s1_1_1_WRW;
			:: msgs?msg1R;  goto s1_1_1_WWW;
			:: msgs?msg1W;  goto s1_1_1_WWW;
			:: msgs?msg1B;  goto s1_1_1_WBW;
			:: msgs?msg1B;  goto s1_1_1_WWW;
			:: msgs?msg2R;  goto s1_1_1_WWR;
			:: msgs?msg2R;  goto s1_1_1_WWW;
			:: msgs?msg2W;  goto s1_1_1_WWW;
			:: msgs?msg2B;  goto s1_1_1_WWB;
			:: msgs?msg2B;  goto s1_1_1_WWW;
		fi;
	s1_1_1_WWB: if
			:: out!outW;  goto s1_2_2_W0B;
			:: msgs?msg0R;  goto s1_1_1_RWB;
			:: msgs?msg0R;  goto s1_1_1_WWB;
			:: msgs?msg0W;  goto s1_1_1_WWB;
			:: msgs?msg0B;  goto s1_1_1_BWB;
			:: msgs?msg0B;  goto s1_1_1_WWB;
			:: msgs?msg1R;  goto s1_1_1_WRB;
			:: msgs?msg1R;  goto s1_1_1_WWB;
			:: msgs?msg1W;  goto s1_1_1_WWB;
			:: msgs?msg1B;  goto s1_1_1_WBB;
			:: msgs?msg1B;  goto s1_1_1_WWB;
			:: msgs?msg2R;  goto s1_1_1_WWR;
			:: msgs?msg2R;  goto s1_1_1_WWB;
			:: msgs?msg2W;  goto s1_1_1_WWW;
			:: msgs?msg2W;  goto s1_1_1_WWB;
			:: msgs?msg2B;  goto s1_1_1_WWB;
		fi;
	s1_1_1_WBR: if
			:: out!outB;  goto s1_2_2_W0R;
			:: msgs?msg0R;  goto s1_1_1_RBR;
			:: msgs?msg0R;  goto s1_1_1_WBR;
			:: msgs?msg0W;  goto s1_1_1_WBR;
			:: msgs?msg0B;  goto s1_1_1_BBR;
			:: msgs?msg0B;  goto s1_1_1_WBR;
			:: msgs?msg1R;  goto s1_1_1_WRR;
			:: msgs?msg1R;  goto s1_1_1_WBR;
			:: msgs?msg1W;  goto s1_1_1_WWR;
			:: msgs?msg1W;  goto s1_1_1_WBR;
			:: msgs?msg1B;  goto s1_1_1_WBR;
			:: msgs?msg2R;  goto s1_1_1_WBR;
			:: msgs?msg2W;  goto s1_1_1_WBW;
			:: msgs?msg2W;  goto s1_1_1_WBR;
			:: msgs?msg2B;  goto s1_1_1_WBB;
			:: msgs?msg2B;  goto s1_1_1_WBR;
		fi;
	s1_1_1_WBW: if
			:: out!outB;  goto s1_2_2_W0W;
			:: msgs?msg0R;  goto s1_1_1_RBW;
			:: msgs?msg0R;  goto s1_1_1_WBW;
			:: msgs?msg0W;  goto s1_1_1_WBW;
			:: msgs?msg0B;  goto s1_1_1_BBW;
			:: msgs?msg0B;  goto s1_1_1_WBW;
			:: msgs?msg1R;  goto s1_1_1_WRW;
			:: msgs?msg1R;  goto s1_1_1_WBW;
			:: msgs?msg1W;  goto s1_1_1_WWW;
			:: msgs?msg1W;  goto s1_1_1_WBW;
			:: msgs?msg1B;  goto s1_1_1_WBW;
			:: msgs?msg2R;  goto s1_1_1_WBR;
			:: msgs?msg2R;  goto s1_1_1_WBW;
			:: msgs?msg2W;  goto s1_1_1_WBW;
			:: msgs?msg2B;  goto s1_1_1_WBB;
			:: msgs?msg2B;  goto s1_1_1_WBW;
		fi;
	s1_1_1_WBB: if
			:: out!outB;  goto s1_2_2_W0B;
			:: msgs?msg0R;  goto s1_1_1_RBB;
			:: msgs?msg0R;  goto s1_1_1_WBB;
			:: msgs?msg0W;  goto s1_1_1_WBB;
			:: msgs?msg0B;  goto s1_1_1_BBB;
			:: msgs?msg0B;  goto s1_1_1_WBB;
			:: msgs?msg1R;  goto s1_1_1_WRB;
			:: msgs?msg1R;  goto s1_1_1_WBB;
			:: msgs?msg1W;  goto s1_1_1_WWB;
			:: msgs?msg1W;  goto s1_1_1_WBB;
			:: msgs?msg1B;  goto s1_1_1_WBB;
			:: msgs?msg2R;  goto s1_1_1_WBR;
			:: msgs?msg2R;  goto s1_1_1_WBB;
			:: msgs?msg2W;  goto s1_1_1_WBW;
			:: msgs?msg2W;  goto s1_1_1_WBB;
			:: msgs?msg2B;  goto s1_1_1_WBB;
		fi;
	s1_2_2_B00: if
			:: acks!ack1;  goto s1_2_2_B00;
			:: msgs?msg0R;  goto s1_2_2_R00;
			:: msgs?msg0R;  goto s1_2_2_B00;
			:: msgs?msg0W;  goto s1_2_2_W00;
			:: msgs?msg0W;  goto s1_2_2_B00;
			:: msgs?msg0B;  goto s1_2_2_B00;
			:: msgs?msg1R;  goto s1_2_2_BR0;
			:: msgs?msg1R;  goto s1_2_2_B00;
			:: msgs?msg1W;  goto s1_2_2_BW0;
			:: msgs?msg1W;  goto s1_2_2_B00;
			:: msgs?msg1B;  goto s1_2_2_BB0;
			:: msgs?msg1B;  goto s1_2_2_B00;
			:: msgs?msg2R;  goto s1_2_2_B0R;
			:: msgs?msg2R;  goto s1_2_2_B00;
			:: msgs?msg2W;  goto s1_2_2_B0W;
			:: msgs?msg2W;  goto s1_2_2_B00;
			:: msgs?msg2B;  goto s1_2_2_B0B;
			:: msgs?msg2B;  goto s1_2_2_B00;
		fi;
	s1_1_1_BRR: if
			:: out!outR;  goto s1_2_2_B0R;
			:: msgs?msg0R;  goto s1_1_1_RRR;
			:: msgs?msg0R;  goto s1_1_1_BRR;
			:: msgs?msg0W;  goto s1_1_1_WRR;
			:: msgs?msg0W;  goto s1_1_1_BRR;
			:: msgs?msg0B;  goto s1_1_1_BRR;
			:: msgs?msg1R;  goto s1_1_1_BRR;
			:: msgs?msg1W;  goto s1_1_1_BWR;
			:: msgs?msg1W;  goto s1_1_1_BRR;
			:: msgs?msg1B;  goto s1_1_1_BBR;
			:: msgs?msg1B;  goto s1_1_1_BRR;
			:: msgs?msg2R;  goto s1_1_1_BRR;
			:: msgs?msg2W;  goto s1_1_1_BRW;
			:: msgs?msg2W;  goto s1_1_1_BRR;
			:: msgs?msg2B;  goto s1_1_1_BRB;
			:: msgs?msg2B;  goto s1_1_1_BRR;
		fi;
	s1_1_1_BRW: if
			:: out!outR;  goto s1_2_2_B0W;
			:: msgs?msg0R;  goto s1_1_1_RRW;
			:: msgs?msg0R;  goto s1_1_1_BRW;
			:: msgs?msg0W;  goto s1_1_1_WRW;
			:: msgs?msg0W;  goto s1_1_1_BRW;
			:: msgs?msg0B;  goto s1_1_1_BRW;
			:: msgs?msg1R;  goto s1_1_1_BRW;
			:: msgs?msg1W;  goto s1_1_1_BWW;
			:: msgs?msg1W;  goto s1_1_1_BRW;
			:: msgs?msg1B;  goto s1_1_1_BBW;
			:: msgs?msg1B;  goto s1_1_1_BRW;
			:: msgs?msg2R;  goto s1_1_1_BRR;
			:: msgs?msg2R;  goto s1_1_1_BRW;
			:: msgs?msg2W;  goto s1_1_1_BRW;
			:: msgs?msg2B;  goto s1_1_1_BRB;
			:: msgs?msg2B;  goto s1_1_1_BRW;
		fi;
	s1_1_1_BRB: if
			:: out!outR;  goto s1_2_2_B0B;
			:: msgs?msg0R;  goto s1_1_1_RRB;
			:: msgs?msg0R;  goto s1_1_1_BRB;
			:: msgs?msg0W;  goto s1_1_1_WRB;
			:: msgs?msg0W;  goto s1_1_1_BRB;
			:: msgs?msg0B;  goto s1_1_1_BRB;
			:: msgs?msg1R;  goto s1_1_1_BRB;
			:: msgs?msg1W;  goto s1_1_1_BWB;
			:: msgs?msg1W;  goto s1_1_1_BRB;
			:: msgs?msg1B;  goto s1_1_1_BBB;
			:: msgs?msg1B;  goto s1_1_1_BRB;
			:: msgs?msg2R;  goto s1_1_1_BRR;
			:: msgs?msg2R;  goto s1_1_1_BRB;
			:: msgs?msg2W;  goto s1_1_1_BRW;
			:: msgs?msg2W;  goto s1_1_1_BRB;
			:: msgs?msg2B;  goto s1_1_1_BRB;
		fi;
	s1_1_1_BWR: if
			:: out!outW;  goto s1_2_2_B0R;
			:: msgs?msg0R;  goto s1_1_1_RWR;
			:: msgs?msg0R;  goto s1_1_1_BWR;
			:: msgs?msg0W;  goto s1_1_1_WWR;
			:: msgs?msg0W;  goto s1_1_1_BWR;
			:: msgs?msg0B;  goto s1_1_1_BWR;
			:: msgs?msg1R;  goto s1_1_1_BRR;
			:: msgs?msg1R;  goto s1_1_1_BWR;
			:: msgs?msg1W;  goto s1_1_1_BWR;
			:: msgs?msg1B;  goto s1_1_1_BBR;
			:: msgs?msg1B;  goto s1_1_1_BWR;
			:: msgs?msg2R;  goto s1_1_1_BWR;
			:: msgs?msg2W;  goto s1_1_1_BWW;
			:: msgs?msg2W;  goto s1_1_1_BWR;
			:: msgs?msg2B;  goto s1_1_1_BWB;
			:: msgs?msg2B;  goto s1_1_1_BWR;
		fi;
	s1_1_1_BWW: if
			:: out!outW;  goto s1_2_2_B0W;
			:: msgs?msg0R;  goto s1_1_1_RWW;
			:: msgs?msg0R;  goto s1_1_1_BWW;
			:: msgs?msg0W;  goto s1_1_1_WWW;
			:: msgs?msg0W;  goto s1_1_1_BWW;
			:: msgs?msg0B;  goto s1_1_1_BWW;
			:: msgs?msg1R;  goto s1_1_1_BRW;
			:: msgs?msg1R;  goto s1_1_1_BWW;
			:: msgs?msg1W;  goto s1_1_1_BWW;
			:: msgs?msg1B;  goto s1_1_1_BBW;
			:: msgs?msg1B;  goto s1_1_1_BWW;
			:: msgs?msg2R;  goto s1_1_1_BWR;
			:: msgs?msg2R;  goto s1_1_1_BWW;
			:: msgs?msg2W;  goto s1_1_1_BWW;
			:: msgs?msg2B;  goto s1_1_1_BWB;
			:: msgs?msg2B;  goto s1_1_1_BWW;
		fi;
	s1_1_1_BWB: if
			:: out!outW;  goto s1_2_2_B0B;
			:: msgs?msg0R;  goto s1_1_1_RWB;
			:: msgs?msg0R;  goto s1_1_1_BWB;
			:: msgs?msg0W;  goto s1_1_1_WWB;
			:: msgs?msg0W;  goto s1_1_1_BWB;
			:: msgs?msg0B;  goto s1_1_1_BWB;
			:: msgs?msg1R;  goto s1_1_1_BRB;
			:: msgs?msg1R;  goto s1_1_1_BWB;
			:: msgs?msg1W;  goto s1_1_1_BWB;
			:: msgs?msg1B;  goto s1_1_1_BBB;
			:: msgs?msg1B;  goto s1_1_1_BWB;
			:: msgs?msg2R;  goto s1_1_1_BWR;
			:: msgs?msg2R;  goto s1_1_1_BWB;
			:: msgs?msg2W;  goto s1_1_1_BWW;
			:: msgs?msg2W;  goto s1_1_1_BWB;
			:: msgs?msg2B;  goto s1_1_1_BWB;
		fi;
	s1_1_1_BBR: if
			:: out!outB;  goto s1_2_2_B0R;
			:: msgs?msg0R;  goto s1_1_1_RBR;
			:: msgs?msg0R;  goto s1_1_1_BBR;
			:: msgs?msg0W;  goto s1_1_1_WBR;
			:: msgs?msg0W;  goto s1_1_1_BBR;
			:: msgs?msg0B;  goto s1_1_1_BBR;
			:: msgs?msg1R;  goto s1_1_1_BRR;
			:: msgs?msg1R;  goto s1_1_1_BBR;
			:: msgs?msg1W;  goto s1_1_1_BWR;
			:: msgs?msg1W;  goto s1_1_1_BBR;
			:: msgs?msg1B;  goto s1_1_1_BBR;
			:: msgs?msg2R;  goto s1_1_1_BBR;
			:: msgs?msg2W;  goto s1_1_1_BBW;
			:: msgs?msg2W;  goto s1_1_1_BBR;
			:: msgs?msg2B;  goto s1_1_1_BBB;
			:: msgs?msg2B;  goto s1_1_1_BBR;
		fi;
	s1_1_1_BBW: if
			:: out!outB;  goto s1_2_2_B0W;
			:: msgs?msg0R;  goto s1_1_1_RBW;
			:: msgs?msg0R;  goto s1_1_1_BBW;
			:: msgs?msg0W;  goto s1_1_1_WBW;
			:: msgs?msg0W;  goto s1_1_1_BBW;
			:: msgs?msg0B;  goto s1_1_1_BBW;
			:: msgs?msg1R;  goto s1_1_1_BRW;
			:: msgs?msg1R;  goto s1_1_1_BBW;
			:: msgs?msg1W;  goto s1_1_1_BWW;
			:: msgs?msg1W;  goto s1_1_1_BBW;
			:: msgs?msg1B;  goto s1_1_1_BBW;
			:: msgs?msg2R;  goto s1_1_1_BBR;
			:: msgs?msg2R;  goto s1_1_1_BBW;
			:: msgs?msg2W;  goto s1_1_1_BBW;
			:: msgs?msg2B;  goto s1_1_1_BBB;
			:: msgs?msg2B;  goto s1_1_1_BBW;
		fi;
	s1_1_1_BBB: if
			:: out!outB;  goto s1_2_2_B0B;
			:: msgs?msg0R;  goto s1_1_1_RBB;
			:: msgs?msg0R;  goto s1_1_1_BBB;
			:: msgs?msg0W;  goto s1_1_1_WBB;
			:: msgs?msg0W;  goto s1_1_1_BBB;
			:: msgs?msg0B;  goto s1_1_1_BBB;
			:: msgs?msg1R;  goto s1_1_1_BRB;
			:: msgs?msg1R;  goto s1_1_1_BBB;
			:: msgs?msg1W;  goto s1_1_1_BWB;
			:: msgs?msg1W;  goto s1_1_1_BBB;
			:: msgs?msg1B;  goto s1_1_1_BBB;
			:: msgs?msg2R;  goto s1_1_1_BBR;
			:: msgs?msg2R;  goto s1_1_1_BBB;
			:: msgs?msg2W;  goto s1_1_1_BBW;
			:: msgs?msg2W;  goto s1_1_1_BBB;
			:: msgs?msg2B;  goto s1_1_1_BBB;
		fi;
	s1_2_2_0R0: if
			:: acks!ack1;  goto s1_2_2_0R0;
			:: msgs?msg0R;  goto s1_2_2_RR0;
			:: msgs?msg0R;  goto s1_2_2_0R0;
			:: msgs?msg0W;  goto s1_2_2_WR0;
			:: msgs?msg0W;  goto s1_2_2_0R0;
			:: msgs?msg0B;  goto s1_2_2_BR0;
			:: msgs?msg0B;  goto s1_2_2_0R0;
			:: msgs?msg1R;  goto s1_2_2_0R0;
			:: msgs?msg1W;  goto s1_2_2_0W0;
			:: msgs?msg1W;  goto s1_2_2_0R0;
			:: msgs?msg1B;  goto s1_2_2_0B0;
			:: msgs?msg1B;  goto s1_2_2_0R0;
			:: msgs?msg2R;  goto s1_2_2_0RR;
			:: msgs?msg2R;  goto s1_2_2_0R0;
			:: msgs?msg2W;  goto s1_2_2_0RW;
			:: msgs?msg2W;  goto s1_2_2_0R0;
			:: msgs?msg2B;  goto s1_2_2_0RB;
			:: msgs?msg2B;  goto s1_2_2_0R0;
		fi;
	s1_2_2_0W0: if
			:: acks!ack1;  goto s1_2_2_0W0;
			:: msgs?msg0R;  goto s1_2_2_RW0;
			:: msgs?msg0R;  goto s1_2_2_0W0;
			:: msgs?msg0W;  goto s1_2_2_WW0;
			:: msgs?msg0W;  goto s1_2_2_0W0;
			:: msgs?msg0B;  goto s1_2_2_BW0;
			:: msgs?msg0B;  goto s1_2_2_0W0;
			:: msgs?msg1R;  goto s1_2_2_0R0;
			:: msgs?msg1R;  goto s1_2_2_0W0;
			:: msgs?msg1W;  goto s1_2_2_0W0;
			:: msgs?msg1B;  goto s1_2_2_0B0;
			:: msgs?msg1B;  goto s1_2_2_0W0;
			:: msgs?msg2R;  goto s1_2_2_0WR;
			:: msgs?msg2R;  goto s1_2_2_0W0;
			:: msgs?msg2W;  goto s1_2_2_0WW;
			:: msgs?msg2W;  goto s1_2_2_0W0;
			:: msgs?msg2B;  goto s1_2_2_0WB;
			:: msgs?msg2B;  goto s1_2_2_0W0;
		fi;
	s1_2_2_0B0: if
			:: acks!ack1;  goto s1_2_2_0B0;
			:: msgs?msg0R;  goto s1_2_2_RB0;
			:: msgs?msg0R;  goto s1_2_2_0B0;
			:: msgs?msg0W;  goto s1_2_2_WB0;
			:: msgs?msg0W;  goto s1_2_2_0B0;
			:: msgs?msg0B;  goto s1_2_2_BB0;
			:: msgs?msg0B;  goto s1_2_2_0B0;
			:: msgs?msg1R;  goto s1_2_2_0R0;
			:: msgs?msg1R;  goto s1_2_2_0B0;
			:: msgs?msg1W;  goto s1_2_2_0W0;
			:: msgs?msg1W;  goto s1_2_2_0B0;
			:: msgs?msg1B;  goto s1_2_2_0B0;
			:: msgs?msg2R;  goto s1_2_2_0BR;
			:: msgs?msg2R;  goto s1_2_2_0B0;
			:: msgs?msg2W;  goto s1_2_2_0BW;
			:: msgs?msg2W;  goto s1_2_2_0B0;
			:: msgs?msg2B;  goto s1_2_2_0BB;
			:: msgs?msg2B;  goto s1_2_2_0B0;
		fi;
	s1_2_2_00R: if
			:: out!outR;  goto s1_0_0_000;
			:: msgs?msg0R;  goto s1_2_2_R0R;
			:: msgs?msg0R;  goto s1_2_2_00R;
			:: msgs?msg0W;  goto s1_2_2_W0R;
			:: msgs?msg0W;  goto s1_2_2_00R;
			:: msgs?msg0B;  goto s1_2_2_B0R;
			:: msgs?msg0B;  goto s1_2_2_00R;
			:: msgs?msg1R;  goto s1_2_2_0RR;
			:: msgs?msg1R;  goto s1_2_2_00R;
			:: msgs?msg1W;  goto s1_2_2_0WR;
			:: msgs?msg1W;  goto s1_2_2_00R;
			:: msgs?msg1B;  goto s1_2_2_0BR;
			:: msgs?msg1B;  goto s1_2_2_00R;
			:: msgs?msg2R;  goto s1_2_2_00R;
			:: msgs?msg2W;  goto s1_2_2_00W;
			:: msgs?msg2W;  goto s1_2_2_00R;
			:: msgs?msg2B;  goto s1_2_2_00B;
			:: msgs?msg2B;  goto s1_2_2_00R;
		fi;
	s1_2_2_00W: if
			:: out!outW;  goto s1_0_0_000;
			:: msgs?msg0R;  goto s1_2_2_R0W;
			:: msgs?msg0R;  goto s1_2_2_00W;
			:: msgs?msg0W;  goto s1_2_2_W0W;
			:: msgs?msg0W;  goto s1_2_2_00W;
			:: msgs?msg0B;  goto s1_2_2_B0W;
			:: msgs?msg0B;  goto s1_2_2_00W;
			:: msgs?msg1R;  goto s1_2_2_0RW;
			:: msgs?msg1R;  goto s1_2_2_00W;
			:: msgs?msg1W;  goto s1_2_2_0WW;
			:: msgs?msg1W;  goto s1_2_2_00W;
			:: msgs?msg1B;  goto s1_2_2_0BW;
			:: msgs?msg1B;  goto s1_2_2_00W;
			:: msgs?msg2R;  goto s1_2_2_00R;
			:: msgs?msg2R;  goto s1_2_2_00W;
			:: msgs?msg2W;  goto s1_2_2_00W;
			:: msgs?msg2B;  goto s1_2_2_00B;
			:: msgs?msg2B;  goto s1_2_2_00W;
		fi;
	s1_2_2_00B: if
			:: out!outB;  goto s1_0_0_000;
			:: msgs?msg0R;  goto s1_2_2_R0B;
			:: msgs?msg0R;  goto s1_2_2_00B;
			:: msgs?msg0W;  goto s1_2_2_W0B;
			:: msgs?msg0W;  goto s1_2_2_00B;
			:: msgs?msg0B;  goto s1_2_2_B0B;
			:: msgs?msg0B;  goto s1_2_2_00B;
			:: msgs?msg1R;  goto s1_2_2_0RB;
			:: msgs?msg1R;  goto s1_2_2_00B;
			:: msgs?msg1W;  goto s1_2_2_0WB;
			:: msgs?msg1W;  goto s1_2_2_00B;
			:: msgs?msg1B;  goto s1_2_2_0BB;
			:: msgs?msg1B;  goto s1_2_2_00B;
			:: msgs?msg2R;  goto s1_2_2_00R;
			:: msgs?msg2R;  goto s1_2_2_00B;
			:: msgs?msg2W;  goto s1_2_2_00W;
			:: msgs?msg2W;  goto s1_2_2_00B;
			:: msgs?msg2B;  goto s1_2_2_00B;
		fi;
	s1_2_2_RR0: if
			:: acks!ack1;  goto s1_2_2_RR0;
			:: msgs?msg0R;  goto s1_2_2_RR0;
			:: msgs?msg0W;  goto s1_2_2_WR0;
			:: msgs?msg0W;  goto s1_2_2_RR0;
			:: msgs?msg0B;  goto s1_2_2_BR0;
			:: msgs?msg0B;  goto s1_2_2_RR0;
			:: msgs?msg1R;  goto s1_2_2_RR0;
			:: msgs?msg1W;  goto s1_2_2_RW0;
			:: msgs?msg1W;  goto s1_2_2_RR0;
			:: msgs?msg1B;  goto s1_2_2_RB0;
			:: msgs?msg1B;  goto s1_2_2_RR0;
			:: msgs?msg2R;  goto s1_2_2_RRR;
			:: msgs?msg2R;  goto s1_2_2_RR0;
			:: msgs?msg2W;  goto s1_2_2_RRW;
			:: msgs?msg2W;  goto s1_2_2_RR0;
			:: msgs?msg2B;  goto s1_2_2_RRB;
			:: msgs?msg2B;  goto s1_2_2_RR0;
		fi;
	s1_2_2_RW0: if
			:: acks!ack1;  goto s1_2_2_RW0;
			:: msgs?msg0R;  goto s1_2_2_RW0;
			:: msgs?msg0W;  goto s1_2_2_WW0;
			:: msgs?msg0W;  goto s1_2_2_RW0;
			:: msgs?msg0B;  goto s1_2_2_BW0;
			:: msgs?msg0B;  goto s1_2_2_RW0;
			:: msgs?msg1R;  goto s1_2_2_RR0;
			:: msgs?msg1R;  goto s1_2_2_RW0;
			:: msgs?msg1W;  goto s1_2_2_RW0;
			:: msgs?msg1B;  goto s1_2_2_RB0;
			:: msgs?msg1B;  goto s1_2_2_RW0;
			:: msgs?msg2R;  goto s1_2_2_RWR;
			:: msgs?msg2R;  goto s1_2_2_RW0;
			:: msgs?msg2W;  goto s1_2_2_RWW;
			:: msgs?msg2W;  goto s1_2_2_RW0;
			:: msgs?msg2B;  goto s1_2_2_RWB;
			:: msgs?msg2B;  goto s1_2_2_RW0;
		fi;
	s1_2_2_RB0: if
			:: acks!ack1;  goto s1_2_2_RB0;
			:: msgs?msg0R;  goto s1_2_2_RB0;
			:: msgs?msg0W;  goto s1_2_2_WB0;
			:: msgs?msg0W;  goto s1_2_2_RB0;
			:: msgs?msg0B;  goto s1_2_2_BB0;
			:: msgs?msg0B;  goto s1_2_2_RB0;
			:: msgs?msg1R;  goto s1_2_2_RR0;
			:: msgs?msg1R;  goto s1_2_2_RB0;
			:: msgs?msg1W;  goto s1_2_2_RW0;
			:: msgs?msg1W;  goto s1_2_2_RB0;
			:: msgs?msg1B;  goto s1_2_2_RB0;
			:: msgs?msg2R;  goto s1_2_2_RBR;
			:: msgs?msg2R;  goto s1_2_2_RB0;
			:: msgs?msg2W;  goto s1_2_2_RBW;
			:: msgs?msg2W;  goto s1_2_2_RB0;
			:: msgs?msg2B;  goto s1_2_2_RBB;
			:: msgs?msg2B;  goto s1_2_2_RB0;
		fi;
	s1_2_2_R0R: if
			:: out!outR;  goto s1_0_0_R00;
			:: msgs?msg0R;  goto s1_2_2_R0R;
			:: msgs?msg0W;  goto s1_2_2_W0R;
			:: msgs?msg0W;  goto s1_2_2_R0R;
			:: msgs?msg0B;  goto s1_2_2_B0R;
			:: msgs?msg0B;  goto s1_2_2_R0R;
			:: msgs?msg1R;  goto s1_2_2_RRR;
			:: msgs?msg1R;  goto s1_2_2_R0R;
			:: msgs?msg1W;  goto s1_2_2_RWR;
			:: msgs?msg1W;  goto s1_2_2_R0R;
			:: msgs?msg1B;  goto s1_2_2_RBR;
			:: msgs?msg1B;  goto s1_2_2_R0R;
			:: msgs?msg2R;  goto s1_2_2_R0R;
			:: msgs?msg2W;  goto s1_2_2_R0W;
			:: msgs?msg2W;  goto s1_2_2_R0R;
			:: msgs?msg2B;  goto s1_2_2_R0B;
			:: msgs?msg2B;  goto s1_2_2_R0R;
		fi;
	s1_2_2_R0W: if
			:: out!outW;  goto s1_0_0_R00;
			:: msgs?msg0R;  goto s1_2_2_R0W;
			:: msgs?msg0W;  goto s1_2_2_W0W;
			:: msgs?msg0W;  goto s1_2_2_R0W;
			:: msgs?msg0B;  goto s1_2_2_B0W;
			:: msgs?msg0B;  goto s1_2_2_R0W;
			:: msgs?msg1R;  goto s1_2_2_RRW;
			:: msgs?msg1R;  goto s1_2_2_R0W;
			:: msgs?msg1W;  goto s1_2_2_RWW;
			:: msgs?msg1W;  goto s1_2_2_R0W;
			:: msgs?msg1B;  goto s1_2_2_RBW;
			:: msgs?msg1B;  goto s1_2_2_R0W;
			:: msgs?msg2R;  goto s1_2_2_R0R;
			:: msgs?msg2R;  goto s1_2_2_R0W;
			:: msgs?msg2W;  goto s1_2_2_R0W;
			:: msgs?msg2B;  goto s1_2_2_R0B;
			:: msgs?msg2B;  goto s1_2_2_R0W;
		fi;
	s1_2_2_R0B: if
			:: out!outB;  goto s1_0_0_R00;
			:: msgs?msg0R;  goto s1_2_2_R0B;
			:: msgs?msg0W;  goto s1_2_2_W0B;
			:: msgs?msg0W;  goto s1_2_2_R0B;
			:: msgs?msg0B;  goto s1_2_2_B0B;
			:: msgs?msg0B;  goto s1_2_2_R0B;
			:: msgs?msg1R;  goto s1_2_2_RRB;
			:: msgs?msg1R;  goto s1_2_2_R0B;
			:: msgs?msg1W;  goto s1_2_2_RWB;
			:: msgs?msg1W;  goto s1_2_2_R0B;
			:: msgs?msg1B;  goto s1_2_2_RBB;
			:: msgs?msg1B;  goto s1_2_2_R0B;
			:: msgs?msg2R;  goto s1_2_2_R0R;
			:: msgs?msg2R;  goto s1_2_2_R0B;
			:: msgs?msg2W;  goto s1_2_2_R0W;
			:: msgs?msg2W;  goto s1_2_2_R0B;
			:: msgs?msg2B;  goto s1_2_2_R0B;
		fi;
	s1_2_2_WR0: if
			:: acks!ack1;  goto s1_2_2_WR0;
			:: msgs?msg0R;  goto s1_2_2_RR0;
			:: msgs?msg0R;  goto s1_2_2_WR0;
			:: msgs?msg0W;  goto s1_2_2_WR0;
			:: msgs?msg0B;  goto s1_2_2_BR0;
			:: msgs?msg0B;  goto s1_2_2_WR0;
			:: msgs?msg1R;  goto s1_2_2_WR0;
			:: msgs?msg1W;  goto s1_2_2_WW0;
			:: msgs?msg1W;  goto s1_2_2_WR0;
			:: msgs?msg1B;  goto s1_2_2_WB0;
			:: msgs?msg1B;  goto s1_2_2_WR0;
			:: msgs?msg2R;  goto s1_2_2_WRR;
			:: msgs?msg2R;  goto s1_2_2_WR0;
			:: msgs?msg2W;  goto s1_2_2_WRW;
			:: msgs?msg2W;  goto s1_2_2_WR0;
			:: msgs?msg2B;  goto s1_2_2_WRB;
			:: msgs?msg2B;  goto s1_2_2_WR0;
		fi;
	s1_2_2_WW0: if
			:: acks!ack1;  goto s1_2_2_WW0;
			:: msgs?msg0R;  goto s1_2_2_RW0;
			:: msgs?msg0R;  goto s1_2_2_WW0;
			:: msgs?msg0W;  goto s1_2_2_WW0;
			:: msgs?msg0B;  goto s1_2_2_BW0;
			:: msgs?msg0B;  goto s1_2_2_WW0;
			:: msgs?msg1R;  goto s1_2_2_WR0;
			:: msgs?msg1R;  goto s1_2_2_WW0;
			:: msgs?msg1W;  goto s1_2_2_WW0;
			:: msgs?msg1B;  goto s1_2_2_WB0;
			:: msgs?msg1B;  goto s1_2_2_WW0;
			:: msgs?msg2R;  goto s1_2_2_WWR;
			:: msgs?msg2R;  goto s1_2_2_WW0;
			:: msgs?msg2W;  goto s1_2_2_WWW;
			:: msgs?msg2W;  goto s1_2_2_WW0;
			:: msgs?msg2B;  goto s1_2_2_WWB;
			:: msgs?msg2B;  goto s1_2_2_WW0;
		fi;
	s1_2_2_WB0: if
			:: acks!ack1;  goto s1_2_2_WB0;
			:: msgs?msg0R;  goto s1_2_2_RB0;
			:: msgs?msg0R;  goto s1_2_2_WB0;
			:: msgs?msg0W;  goto s1_2_2_WB0;
			:: msgs?msg0B;  goto s1_2_2_BB0;
			:: msgs?msg0B;  goto s1_2_2_WB0;
			:: msgs?msg1R;  goto s1_2_2_WR0;
			:: msgs?msg1R;  goto s1_2_2_WB0;
			:: msgs?msg1W;  goto s1_2_2_WW0;
			:: msgs?msg1W;  goto s1_2_2_WB0;
			:: msgs?msg1B;  goto s1_2_2_WB0;
			:: msgs?msg2R;  goto s1_2_2_WBR;
			:: msgs?msg2R;  goto s1_2_2_WB0;
			:: msgs?msg2W;  goto s1_2_2_WBW;
			:: msgs?msg2W;  goto s1_2_2_WB0;
			:: msgs?msg2B;  goto s1_2_2_WBB;
			:: msgs?msg2B;  goto s1_2_2_WB0;
		fi;
	s1_2_2_W0R: if
			:: out!outR;  goto s1_0_0_W00;
			:: msgs?msg0R;  goto s1_2_2_R0R;
			:: msgs?msg0R;  goto s1_2_2_W0R;
			:: msgs?msg0W;  goto s1_2_2_W0R;
			:: msgs?msg0B;  goto s1_2_2_B0R;
			:: msgs?msg0B;  goto s1_2_2_W0R;
			:: msgs?msg1R;  goto s1_2_2_WRR;
			:: msgs?msg1R;  goto s1_2_2_W0R;
			:: msgs?msg1W;  goto s1_2_2_WWR;
			:: msgs?msg1W;  goto s1_2_2_W0R;
			:: msgs?msg1B;  goto s1_2_2_WBR;
			:: msgs?msg1B;  goto s1_2_2_W0R;
			:: msgs?msg2R;  goto s1_2_2_W0R;
			:: msgs?msg2W;  goto s1_2_2_W0W;
			:: msgs?msg2W;  goto s1_2_2_W0R;
			:: msgs?msg2B;  goto s1_2_2_W0B;
			:: msgs?msg2B;  goto s1_2_2_W0R;
		fi;
	s1_2_2_W0W: if
			:: out!outW;  goto s1_0_0_W00;
			:: msgs?msg0R;  goto s1_2_2_R0W;
			:: msgs?msg0R;  goto s1_2_2_W0W;
			:: msgs?msg0W;  goto s1_2_2_W0W;
			:: msgs?msg0B;  goto s1_2_2_B0W;
			:: msgs?msg0B;  goto s1_2_2_W0W;
			:: msgs?msg1R;  goto s1_2_2_WRW;
			:: msgs?msg1R;  goto s1_2_2_W0W;
			:: msgs?msg1W;  goto s1_2_2_WWW;
			:: msgs?msg1W;  goto s1_2_2_W0W;
			:: msgs?msg1B;  goto s1_2_2_WBW;
			:: msgs?msg1B;  goto s1_2_2_W0W;
			:: msgs?msg2R;  goto s1_2_2_W0R;
			:: msgs?msg2R;  goto s1_2_2_W0W;
			:: msgs?msg2W;  goto s1_2_2_W0W;
			:: msgs?msg2B;  goto s1_2_2_W0B;
			:: msgs?msg2B;  goto s1_2_2_W0W;
		fi;
	s1_2_2_W0B: if
			:: out!outB;  goto s1_0_0_W00;
			:: msgs?msg0R;  goto s1_2_2_R0B;
			:: msgs?msg0R;  goto s1_2_2_W0B;
			:: msgs?msg0W;  goto s1_2_2_W0B;
			:: msgs?msg0B;  goto s1_2_2_B0B;
			:: msgs?msg0B;  goto s1_2_2_W0B;
			:: msgs?msg1R;  goto s1_2_2_WRB;
			:: msgs?msg1R;  goto s1_2_2_W0B;
			:: msgs?msg1W;  goto s1_2_2_WWB;
			:: msgs?msg1W;  goto s1_2_2_W0B;
			:: msgs?msg1B;  goto s1_2_2_WBB;
			:: msgs?msg1B;  goto s1_2_2_W0B;
			:: msgs?msg2R;  goto s1_2_2_W0R;
			:: msgs?msg2R;  goto s1_2_2_W0B;
			:: msgs?msg2W;  goto s1_2_2_W0W;
			:: msgs?msg2W;  goto s1_2_2_W0B;
			:: msgs?msg2B;  goto s1_2_2_W0B;
		fi;
	s1_2_2_BR0: if
			:: acks!ack1;  goto s1_2_2_BR0;
			:: msgs?msg0R;  goto s1_2_2_RR0;
			:: msgs?msg0R;  goto s1_2_2_BR0;
			:: msgs?msg0W;  goto s1_2_2_WR0;
			:: msgs?msg0W;  goto s1_2_2_BR0;
			:: msgs?msg0B;  goto s1_2_2_BR0;
			:: msgs?msg1R;  goto s1_2_2_BR0;
			:: msgs?msg1W;  goto s1_2_2_BW0;
			:: msgs?msg1W;  goto s1_2_2_BR0;
			:: msgs?msg1B;  goto s1_2_2_BB0;
			:: msgs?msg1B;  goto s1_2_2_BR0;
			:: msgs?msg2R;  goto s1_2_2_BRR;
			:: msgs?msg2R;  goto s1_2_2_BR0;
			:: msgs?msg2W;  goto s1_2_2_BRW;
			:: msgs?msg2W;  goto s1_2_2_BR0;
			:: msgs?msg2B;  goto s1_2_2_BRB;
			:: msgs?msg2B;  goto s1_2_2_BR0;
		fi;
	s1_2_2_BW0: if
			:: acks!ack1;  goto s1_2_2_BW0;
			:: msgs?msg0R;  goto s1_2_2_RW0;
			:: msgs?msg0R;  goto s1_2_2_BW0;
			:: msgs?msg0W;  goto s1_2_2_WW0;
			:: msgs?msg0W;  goto s1_2_2_BW0;
			:: msgs?msg0B;  goto s1_2_2_BW0;
			:: msgs?msg1R;  goto s1_2_2_BR0;
			:: msgs?msg1R;  goto s1_2_2_BW0;
			:: msgs?msg1W;  goto s1_2_2_BW0;
			:: msgs?msg1B;  goto s1_2_2_BB0;
			:: msgs?msg1B;  goto s1_2_2_BW0;
			:: msgs?msg2R;  goto s1_2_2_BWR;
			:: msgs?msg2R;  goto s1_2_2_BW0;
			:: msgs?msg2W;  goto s1_2_2_BWW;
			:: msgs?msg2W;  goto s1_2_2_BW0;
			:: msgs?msg2B;  goto s1_2_2_BWB;
			:: msgs?msg2B;  goto s1_2_2_BW0;
		fi;
	s1_2_2_BB0: if
			:: acks!ack1;  goto s1_2_2_BB0;
			:: msgs?msg0R;  goto s1_2_2_RB0;
			:: msgs?msg0R;  goto s1_2_2_BB0;
			:: msgs?msg0W;  goto s1_2_2_WB0;
			:: msgs?msg0W;  goto s1_2_2_BB0;
			:: msgs?msg0B;  goto s1_2_2_BB0;
			:: msgs?msg1R;  goto s1_2_2_BR0;
			:: msgs?msg1R;  goto s1_2_2_BB0;
			:: msgs?msg1W;  goto s1_2_2_BW0;
			:: msgs?msg1W;  goto s1_2_2_BB0;
			:: msgs?msg1B;  goto s1_2_2_BB0;
			:: msgs?msg2R;  goto s1_2_2_BBR;
			:: msgs?msg2R;  goto s1_2_2_BB0;
			:: msgs?msg2W;  goto s1_2_2_BBW;
			:: msgs?msg2W;  goto s1_2_2_BB0;
			:: msgs?msg2B;  goto s1_2_2_BBB;
			:: msgs?msg2B;  goto s1_2_2_BB0;
		fi;
	s1_2_2_B0R: if
			:: out!outR;  goto s1_0_0_B00;
			:: msgs?msg0R;  goto s1_2_2_R0R;
			:: msgs?msg0R;  goto s1_2_2_B0R;
			:: msgs?msg0W;  goto s1_2_2_W0R;
			:: msgs?msg0W;  goto s1_2_2_B0R;
			:: msgs?msg0B;  goto s1_2_2_B0R;
			:: msgs?msg1R;  goto s1_2_2_BRR;
			:: msgs?msg1R;  goto s1_2_2_B0R;
			:: msgs?msg1W;  goto s1_2_2_BWR;
			:: msgs?msg1W;  goto s1_2_2_B0R;
			:: msgs?msg1B;  goto s1_2_2_BBR;
			:: msgs?msg1B;  goto s1_2_2_B0R;
			:: msgs?msg2R;  goto s1_2_2_B0R;
			:: msgs?msg2W;  goto s1_2_2_B0W;
			:: msgs?msg2W;  goto s1_2_2_B0R;
			:: msgs?msg2B;  goto s1_2_2_B0B;
			:: msgs?msg2B;  goto s1_2_2_B0R;
		fi;
	s1_2_2_B0W: if
			:: out!outW;  goto s1_0_0_B00;
			:: msgs?msg0R;  goto s1_2_2_R0W;
			:: msgs?msg0R;  goto s1_2_2_B0W;
			:: msgs?msg0W;  goto s1_2_2_W0W;
			:: msgs?msg0W;  goto s1_2_2_B0W;
			:: msgs?msg0B;  goto s1_2_2_B0W;
			:: msgs?msg1R;  goto s1_2_2_BRW;
			:: msgs?msg1R;  goto s1_2_2_B0W;
			:: msgs?msg1W;  goto s1_2_2_BWW;
			:: msgs?msg1W;  goto s1_2_2_B0W;
			:: msgs?msg1B;  goto s1_2_2_BBW;
			:: msgs?msg1B;  goto s1_2_2_B0W;
			:: msgs?msg2R;  goto s1_2_2_B0R;
			:: msgs?msg2R;  goto s1_2_2_B0W;
			:: msgs?msg2W;  goto s1_2_2_B0W;
			:: msgs?msg2B;  goto s1_2_2_B0B;
			:: msgs?msg2B;  goto s1_2_2_B0W;
		fi;
	s1_2_2_B0B: if
			:: out!outB;  goto s1_0_0_B00;
			:: msgs?msg0R;  goto s1_2_2_R0B;
			:: msgs?msg0R;  goto s1_2_2_B0B;
			:: msgs?msg0W;  goto s1_2_2_W0B;
			:: msgs?msg0W;  goto s1_2_2_B0B;
			:: msgs?msg0B;  goto s1_2_2_B0B;
			:: msgs?msg1R;  goto s1_2_2_BRB;
			:: msgs?msg1R;  goto s1_2_2_B0B;
			:: msgs?msg1W;  goto s1_2_2_BWB;
			:: msgs?msg1W;  goto s1_2_2_B0B;
			:: msgs?msg1B;  goto s1_2_2_BBB;
			:: msgs?msg1B;  goto s1_2_2_B0B;
			:: msgs?msg2R;  goto s1_2_2_B0R;
			:: msgs?msg2R;  goto s1_2_2_B0B;
			:: msgs?msg2W;  goto s1_2_2_B0W;
			:: msgs?msg2W;  goto s1_2_2_B0B;
			:: msgs?msg2B;  goto s1_2_2_B0B;
		fi;
	s1_2_2_0RR: if
			:: out!outR;  goto s1_0_0_0R0;
			:: msgs?msg0R;  goto s1_2_2_RRR;
			:: msgs?msg0R;  goto s1_2_2_0RR;
			:: msgs?msg0W;  goto s1_2_2_WRR;
			:: msgs?msg0W;  goto s1_2_2_0RR;
			:: msgs?msg0B;  goto s1_2_2_BRR;
			:: msgs?msg0B;  goto s1_2_2_0RR;
			:: msgs?msg1R;  goto s1_2_2_0RR;
			:: msgs?msg1W;  goto s1_2_2_0WR;
			:: msgs?msg1W;  goto s1_2_2_0RR;
			:: msgs?msg1B;  goto s1_2_2_0BR;
			:: msgs?msg1B;  goto s1_2_2_0RR;
			:: msgs?msg2R;  goto s1_2_2_0RR;
			:: msgs?msg2W;  goto s1_2_2_0RW;
			:: msgs?msg2W;  goto s1_2_2_0RR;
			:: msgs?msg2B;  goto s1_2_2_0RB;
			:: msgs?msg2B;  goto s1_2_2_0RR;
		fi;
	s1_2_2_0RW: if
			:: out!outW;  goto s1_0_0_0R0;
			:: msgs?msg0R;  goto s1_2_2_RRW;
			:: msgs?msg0R;  goto s1_2_2_0RW;
			:: msgs?msg0W;  goto s1_2_2_WRW;
			:: msgs?msg0W;  goto s1_2_2_0RW;
			:: msgs?msg0B;  goto s1_2_2_BRW;
			:: msgs?msg0B;  goto s1_2_2_0RW;
			:: msgs?msg1R;  goto s1_2_2_0RW;
			:: msgs?msg1W;  goto s1_2_2_0WW;
			:: msgs?msg1W;  goto s1_2_2_0RW;
			:: msgs?msg1B;  goto s1_2_2_0BW;
			:: msgs?msg1B;  goto s1_2_2_0RW;
			:: msgs?msg2R;  goto s1_2_2_0RR;
			:: msgs?msg2R;  goto s1_2_2_0RW;
			:: msgs?msg2W;  goto s1_2_2_0RW;
			:: msgs?msg2B;  goto s1_2_2_0RB;
			:: msgs?msg2B;  goto s1_2_2_0RW;
		fi;
	s1_2_2_0RB: if
			:: out!outB;  goto s1_0_0_0R0;
			:: msgs?msg0R;  goto s1_2_2_RRB;
			:: msgs?msg0R;  goto s1_2_2_0RB;
			:: msgs?msg0W;  goto s1_2_2_WRB;
			:: msgs?msg0W;  goto s1_2_2_0RB;
			:: msgs?msg0B;  goto s1_2_2_BRB;
			:: msgs?msg0B;  goto s1_2_2_0RB;
			:: msgs?msg1R;  goto s1_2_2_0RB;
			:: msgs?msg1W;  goto s1_2_2_0WB;
			:: msgs?msg1W;  goto s1_2_2_0RB;
			:: msgs?msg1B;  goto s1_2_2_0BB;
			:: msgs?msg1B;  goto s1_2_2_0RB;
			:: msgs?msg2R;  goto s1_2_2_0RR;
			:: msgs?msg2R;  goto s1_2_2_0RB;
			:: msgs?msg2W;  goto s1_2_2_0RW;
			:: msgs?msg2W;  goto s1_2_2_0RB;
			:: msgs?msg2B;  goto s1_2_2_0RB;
		fi;
	s1_2_2_0WR: if
			:: out!outR;  goto s1_0_0_0W0;
			:: msgs?msg0R;  goto s1_2_2_RWR;
			:: msgs?msg0R;  goto s1_2_2_0WR;
			:: msgs?msg0W;  goto s1_2_2_WWR;
			:: msgs?msg0W;  goto s1_2_2_0WR;
			:: msgs?msg0B;  goto s1_2_2_BWR;
			:: msgs?msg0B;  goto s1_2_2_0WR;
			:: msgs?msg1R;  goto s1_2_2_0RR;
			:: msgs?msg1R;  goto s1_2_2_0WR;
			:: msgs?msg1W;  goto s1_2_2_0WR;
			:: msgs?msg1B;  goto s1_2_2_0BR;
			:: msgs?msg1B;  goto s1_2_2_0WR;
			:: msgs?msg2R;  goto s1_2_2_0WR;
			:: msgs?msg2W;  goto s1_2_2_0WW;
			:: msgs?msg2W;  goto s1_2_2_0WR;
			:: msgs?msg2B;  goto s1_2_2_0WB;
			:: msgs?msg2B;  goto s1_2_2_0WR;
		fi;
	s1_2_2_0WW: if
			:: out!outW;  goto s1_0_0_0W0;
			:: msgs?msg0R;  goto s1_2_2_RWW;
			:: msgs?msg0R;  goto s1_2_2_0WW;
			:: msgs?msg0W;  goto s1_2_2_WWW;
			:: msgs?msg0W;  goto s1_2_2_0WW;
			:: msgs?msg0B;  goto s1_2_2_BWW;
			:: msgs?msg0B;  goto s1_2_2_0WW;
			:: msgs?msg1R;  goto s1_2_2_0RW;
			:: msgs?msg1R;  goto s1_2_2_0WW;
			:: msgs?msg1W;  goto s1_2_2_0WW;
			:: msgs?msg1B;  goto s1_2_2_0BW;
			:: msgs?msg1B;  goto s1_2_2_0WW;
			:: msgs?msg2R;  goto s1_2_2_0WR;
			:: msgs?msg2R;  goto s1_2_2_0WW;
			:: msgs?msg2W;  goto s1_2_2_0WW;
			:: msgs?msg2B;  goto s1_2_2_0WB;
			:: msgs?msg2B;  goto s1_2_2_0WW;
		fi;
	s1_2_2_0WB: if
			:: out!outB;  goto s1_0_0_0W0;
			:: msgs?msg0R;  goto s1_2_2_RWB;
			:: msgs?msg0R;  goto s1_2_2_0WB;
			:: msgs?msg0W;  goto s1_2_2_WWB;
			:: msgs?msg0W;  goto s1_2_2_0WB;
			:: msgs?msg0B;  goto s1_2_2_BWB;
			:: msgs?msg0B;  goto s1_2_2_0WB;
			:: msgs?msg1R;  goto s1_2_2_0RB;
			:: msgs?msg1R;  goto s1_2_2_0WB;
			:: msgs?msg1W;  goto s1_2_2_0WB;
			:: msgs?msg1B;  goto s1_2_2_0BB;
			:: msgs?msg1B;  goto s1_2_2_0WB;
			:: msgs?msg2R;  goto s1_2_2_0WR;
			:: msgs?msg2R;  goto s1_2_2_0WB;
			:: msgs?msg2W;  goto s1_2_2_0WW;
			:: msgs?msg2W;  goto s1_2_2_0WB;
			:: msgs?msg2B;  goto s1_2_2_0WB;
		fi;
	s1_2_2_0BR: if
			:: out!outR;  goto s1_0_0_0B0;
			:: msgs?msg0R;  goto s1_2_2_RBR;
			:: msgs?msg0R;  goto s1_2_2_0BR;
			:: msgs?msg0W;  goto s1_2_2_WBR;
			:: msgs?msg0W;  goto s1_2_2_0BR;
			:: msgs?msg0B;  goto s1_2_2_BBR;
			:: msgs?msg0B;  goto s1_2_2_0BR;
			:: msgs?msg1R;  goto s1_2_2_0RR;
			:: msgs?msg1R;  goto s1_2_2_0BR;
			:: msgs?msg1W;  goto s1_2_2_0WR;
			:: msgs?msg1W;  goto s1_2_2_0BR;
			:: msgs?msg1B;  goto s1_2_2_0BR;
			:: msgs?msg2R;  goto s1_2_2_0BR;
			:: msgs?msg2W;  goto s1_2_2_0BW;
			:: msgs?msg2W;  goto s1_2_2_0BR;
			:: msgs?msg2B;  goto s1_2_2_0BB;
			:: msgs?msg2B;  goto s1_2_2_0BR;
		fi;
	s1_2_2_0BW: if
			:: out!outW;  goto s1_0_0_0B0;
			:: msgs?msg0R;  goto s1_2_2_RBW;
			:: msgs?msg0R;  goto s1_2_2_0BW;
			:: msgs?msg0W;  goto s1_2_2_WBW;
			:: msgs?msg0W;  goto s1_2_2_0BW;
			:: msgs?msg0B;  goto s1_2_2_BBW;
			:: msgs?msg0B;  goto s1_2_2_0BW;
			:: msgs?msg1R;  goto s1_2_2_0RW;
			:: msgs?msg1R;  goto s1_2_2_0BW;
			:: msgs?msg1W;  goto s1_2_2_0WW;
			:: msgs?msg1W;  goto s1_2_2_0BW;
			:: msgs?msg1B;  goto s1_2_2_0BW;
			:: msgs?msg2R;  goto s1_2_2_0BR;
			:: msgs?msg2R;  goto s1_2_2_0BW;
			:: msgs?msg2W;  goto s1_2_2_0BW;
			:: msgs?msg2B;  goto s1_2_2_0BB;
			:: msgs?msg2B;  goto s1_2_2_0BW;
		fi;
	s1_2_2_0BB: if
			:: out!outB;  goto s1_0_0_0B0;
			:: msgs?msg0R;  goto s1_2_2_RBB;
			:: msgs?msg0R;  goto s1_2_2_0BB;
			:: msgs?msg0W;  goto s1_2_2_WBB;
			:: msgs?msg0W;  goto s1_2_2_0BB;
			:: msgs?msg0B;  goto s1_2_2_BBB;
			:: msgs?msg0B;  goto s1_2_2_0BB;
			:: msgs?msg1R;  goto s1_2_2_0RB;
			:: msgs?msg1R;  goto s1_2_2_0BB;
			:: msgs?msg1W;  goto s1_2_2_0WB;
			:: msgs?msg1W;  goto s1_2_2_0BB;
			:: msgs?msg1B;  goto s1_2_2_0BB;
			:: msgs?msg2R;  goto s1_2_2_0BR;
			:: msgs?msg2R;  goto s1_2_2_0BB;
			:: msgs?msg2W;  goto s1_2_2_0BW;
			:: msgs?msg2W;  goto s1_2_2_0BB;
			:: msgs?msg2B;  goto s1_2_2_0BB;
		fi;
	s1_0_0_000: if
			:: acks!ack2;  goto s1_0_0_000;
			:: msgs?msg0R;  goto s1_0_0_R00;
			:: msgs?msg0R;  goto s1_0_0_000;
			:: msgs?msg0W;  goto s1_0_0_W00;
			:: msgs?msg0W;  goto s1_0_0_000;
			:: msgs?msg0B;  goto s1_0_0_B00;
			:: msgs?msg0B;  goto s1_0_0_000;
			:: msgs?msg1R;  goto s1_0_0_0R0;
			:: msgs?msg1R;  goto s1_0_0_000;
			:: msgs?msg1W;  goto s1_0_0_0W0;
			:: msgs?msg1W;  goto s1_0_0_000;
			:: msgs?msg1B;  goto s1_0_0_0B0;
			:: msgs?msg1B;  goto s1_0_0_000;
			:: msgs?msg2R;  goto s1_0_0_00R;
			:: msgs?msg2R;  goto s1_0_0_000;
			:: msgs?msg2W;  goto s1_0_0_00W;
			:: msgs?msg2W;  goto s1_0_0_000;
			:: msgs?msg2B;  goto s1_0_0_00B;
			:: msgs?msg2B;  goto s1_0_0_000;
		fi;
	s1_2_2_RRR: if
			:: out!outR;  goto s1_0_0_RR0;
			:: msgs?msg0R;  goto s1_2_2_RRR;
			:: msgs?msg0W;  goto s1_2_2_WRR;
			:: msgs?msg0W;  goto s1_2_2_RRR;
			:: msgs?msg0B;  goto s1_2_2_BRR;
			:: msgs?msg0B;  goto s1_2_2_RRR;
			:: msgs?msg1R;  goto s1_2_2_RRR;
			:: msgs?msg1W;  goto s1_2_2_RWR;
			:: msgs?msg1W;  goto s1_2_2_RRR;
			:: msgs?msg1B;  goto s1_2_2_RBR;
			:: msgs?msg1B;  goto s1_2_2_RRR;
			:: msgs?msg2R;  goto s1_2_2_RRR;
			:: msgs?msg2W;  goto s1_2_2_RRW;
			:: msgs?msg2W;  goto s1_2_2_RRR;
			:: msgs?msg2B;  goto s1_2_2_RRB;
			:: msgs?msg2B;  goto s1_2_2_RRR;
		fi;
	s1_2_2_RRW: if
			:: out!outW;  goto s1_0_0_RR0;
			:: msgs?msg0R;  goto s1_2_2_RRW;
			:: msgs?msg0W;  goto s1_2_2_WRW;
			:: msgs?msg0W;  goto s1_2_2_RRW;
			:: msgs?msg0B;  goto s1_2_2_BRW;
			:: msgs?msg0B;  goto s1_2_2_RRW;
			:: msgs?msg1R;  goto s1_2_2_RRW;
			:: msgs?msg1W;  goto s1_2_2_RWW;
			:: msgs?msg1W;  goto s1_2_2_RRW;
			:: msgs?msg1B;  goto s1_2_2_RBW;
			:: msgs?msg1B;  goto s1_2_2_RRW;
			:: msgs?msg2R;  goto s1_2_2_RRR;
			:: msgs?msg2R;  goto s1_2_2_RRW;
			:: msgs?msg2W;  goto s1_2_2_RRW;
			:: msgs?msg2B;  goto s1_2_2_RRB;
			:: msgs?msg2B;  goto s1_2_2_RRW;
		fi;
	s1_2_2_RRB: if
			:: out!outB;  goto s1_0_0_RR0;
			:: msgs?msg0R;  goto s1_2_2_RRB;
			:: msgs?msg0W;  goto s1_2_2_WRB;
			:: msgs?msg0W;  goto s1_2_2_RRB;
			:: msgs?msg0B;  goto s1_2_2_BRB;
			:: msgs?msg0B;  goto s1_2_2_RRB;
			:: msgs?msg1R;  goto s1_2_2_RRB;
			:: msgs?msg1W;  goto s1_2_2_RWB;
			:: msgs?msg1W;  goto s1_2_2_RRB;
			:: msgs?msg1B;  goto s1_2_2_RBB;
			:: msgs?msg1B;  goto s1_2_2_RRB;
			:: msgs?msg2R;  goto s1_2_2_RRR;
			:: msgs?msg2R;  goto s1_2_2_RRB;
			:: msgs?msg2W;  goto s1_2_2_RRW;
			:: msgs?msg2W;  goto s1_2_2_RRB;
			:: msgs?msg2B;  goto s1_2_2_RRB;
		fi;
	s1_2_2_RWR: if
			:: out!outR;  goto s1_0_0_RW0;
			:: msgs?msg0R;  goto s1_2_2_RWR;
			:: msgs?msg0W;  goto s1_2_2_WWR;
			:: msgs?msg0W;  goto s1_2_2_RWR;
			:: msgs?msg0B;  goto s1_2_2_BWR;
			:: msgs?msg0B;  goto s1_2_2_RWR;
			:: msgs?msg1R;  goto s1_2_2_RRR;
			:: msgs?msg1R;  goto s1_2_2_RWR;
			:: msgs?msg1W;  goto s1_2_2_RWR;
			:: msgs?msg1B;  goto s1_2_2_RBR;
			:: msgs?msg1B;  goto s1_2_2_RWR;
			:: msgs?msg2R;  goto s1_2_2_RWR;
			:: msgs?msg2W;  goto s1_2_2_RWW;
			:: msgs?msg2W;  goto s1_2_2_RWR;
			:: msgs?msg2B;  goto s1_2_2_RWB;
			:: msgs?msg2B;  goto s1_2_2_RWR;
		fi;
	s1_2_2_RWW: if
			:: out!outW;  goto s1_0_0_RW0;
			:: msgs?msg0R;  goto s1_2_2_RWW;
			:: msgs?msg0W;  goto s1_2_2_WWW;
			:: msgs?msg0W;  goto s1_2_2_RWW;
			:: msgs?msg0B;  goto s1_2_2_BWW;
			:: msgs?msg0B;  goto s1_2_2_RWW;
			:: msgs?msg1R;  goto s1_2_2_RRW;
			:: msgs?msg1R;  goto s1_2_2_RWW;
			:: msgs?msg1W;  goto s1_2_2_RWW;
			:: msgs?msg1B;  goto s1_2_2_RBW;
			:: msgs?msg1B;  goto s1_2_2_RWW;
			:: msgs?msg2R;  goto s1_2_2_RWR;
			:: msgs?msg2R;  goto s1_2_2_RWW;
			:: msgs?msg2W;  goto s1_2_2_RWW;
			:: msgs?msg2B;  goto s1_2_2_RWB;
			:: msgs?msg2B;  goto s1_2_2_RWW;
		fi;
	s1_2_2_RWB: if
			:: out!outB;  goto s1_0_0_RW0;
			:: msgs?msg0R;  goto s1_2_2_RWB;
			:: msgs?msg0W;  goto s1_2_2_WWB;
			:: msgs?msg0W;  goto s1_2_2_RWB;
			:: msgs?msg0B;  goto s1_2_2_BWB;
			:: msgs?msg0B;  goto s1_2_2_RWB;
			:: msgs?msg1R;  goto s1_2_2_RRB;
			:: msgs?msg1R;  goto s1_2_2_RWB;
			:: msgs?msg1W;  goto s1_2_2_RWB;
			:: msgs?msg1B;  goto s1_2_2_RBB;
			:: msgs?msg1B;  goto s1_2_2_RWB;
			:: msgs?msg2R;  goto s1_2_2_RWR;
			:: msgs?msg2R;  goto s1_2_2_RWB;
			:: msgs?msg2W;  goto s1_2_2_RWW;
			:: msgs?msg2W;  goto s1_2_2_RWB;
			:: msgs?msg2B;  goto s1_2_2_RWB;
		fi;
	s1_2_2_RBR: if
			:: out!outR;  goto s1_0_0_RB0;
			:: msgs?msg0R;  goto s1_2_2_RBR;
			:: msgs?msg0W;  goto s1_2_2_WBR;
			:: msgs?msg0W;  goto s1_2_2_RBR;
			:: msgs?msg0B;  goto s1_2_2_BBR;
			:: msgs?msg0B;  goto s1_2_2_RBR;
			:: msgs?msg1R;  goto s1_2_2_RRR;
			:: msgs?msg1R;  goto s1_2_2_RBR;
			:: msgs?msg1W;  goto s1_2_2_RWR;
			:: msgs?msg1W;  goto s1_2_2_RBR;
			:: msgs?msg1B;  goto s1_2_2_RBR;
			:: msgs?msg2R;  goto s1_2_2_RBR;
			:: msgs?msg2W;  goto s1_2_2_RBW;
			:: msgs?msg2W;  goto s1_2_2_RBR;
			:: msgs?msg2B;  goto s1_2_2_RBB;
			:: msgs?msg2B;  goto s1_2_2_RBR;
		fi;
	s1_2_2_RBW: if
			:: out!outW;  goto s1_0_0_RB0;
			:: msgs?msg0R;  goto s1_2_2_RBW;
			:: msgs?msg0W;  goto s1_2_2_WBW;
			:: msgs?msg0W;  goto s1_2_2_RBW;
			:: msgs?msg0B;  goto s1_2_2_BBW;
			:: msgs?msg0B;  goto s1_2_2_RBW;
			:: msgs?msg1R;  goto s1_2_2_RRW;
			:: msgs?msg1R;  goto s1_2_2_RBW;
			:: msgs?msg1W;  goto s1_2_2_RWW;
			:: msgs?msg1W;  goto s1_2_2_RBW;
			:: msgs?msg1B;  goto s1_2_2_RBW;
			:: msgs?msg2R;  goto s1_2_2_RBR;
			:: msgs?msg2R;  goto s1_2_2_RBW;
			:: msgs?msg2W;  goto s1_2_2_RBW;
			:: msgs?msg2B;  goto s1_2_2_RBB;
			:: msgs?msg2B;  goto s1_2_2_RBW;
		fi;
	s1_2_2_RBB: if
			:: out!outB;  goto s1_0_0_RB0;
			:: msgs?msg0R;  goto s1_2_2_RBB;
			:: msgs?msg0W;  goto s1_2_2_WBB;
			:: msgs?msg0W;  goto s1_2_2_RBB;
			:: msgs?msg0B;  goto s1_2_2_BBB;
			:: msgs?msg0B;  goto s1_2_2_RBB;
			:: msgs?msg1R;  goto s1_2_2_RRB;
			:: msgs?msg1R;  goto s1_2_2_RBB;
			:: msgs?msg1W;  goto s1_2_2_RWB;
			:: msgs?msg1W;  goto s1_2_2_RBB;
			:: msgs?msg1B;  goto s1_2_2_RBB;
			:: msgs?msg2R;  goto s1_2_2_RBR;
			:: msgs?msg2R;  goto s1_2_2_RBB;
			:: msgs?msg2W;  goto s1_2_2_RBW;
			:: msgs?msg2W;  goto s1_2_2_RBB;
			:: msgs?msg2B;  goto s1_2_2_RBB;
		fi;
	s1_0_0_R00: if
			:: out!outR;  goto s1_1_1_000;
			:: msgs?msg0R;  goto s1_0_0_R00;
			:: msgs?msg0W;  goto s1_0_0_W00;
			:: msgs?msg0W;  goto s1_0_0_R00;
			:: msgs?msg0B;  goto s1_0_0_B00;
			:: msgs?msg0B;  goto s1_0_0_R00;
			:: msgs?msg1R;  goto s1_0_0_RR0;
			:: msgs?msg1R;  goto s1_0_0_R00;
			:: msgs?msg1W;  goto s1_0_0_RW0;
			:: msgs?msg1W;  goto s1_0_0_R00;
			:: msgs?msg1B;  goto s1_0_0_RB0;
			:: msgs?msg1B;  goto s1_0_0_R00;
			:: msgs?msg2R;  goto s1_0_0_R0R;
			:: msgs?msg2R;  goto s1_0_0_R00;
			:: msgs?msg2W;  goto s1_0_0_R0W;
			:: msgs?msg2W;  goto s1_0_0_R00;
			:: msgs?msg2B;  goto s1_0_0_R0B;
			:: msgs?msg2B;  goto s1_0_0_R00;
		fi;
	s1_2_2_WRR: if
			:: out!outR;  goto s1_0_0_WR0;
			:: msgs?msg0R;  goto s1_2_2_RRR;
			:: msgs?msg0R;  goto s1_2_2_WRR;
			:: msgs?msg0W;  goto s1_2_2_WRR;
			:: msgs?msg0B;  goto s1_2_2_BRR;
			:: msgs?msg0B;  goto s1_2_2_WRR;
			:: msgs?msg1R;  goto s1_2_2_WRR;
			:: msgs?msg1W;  goto s1_2_2_WWR;
			:: msgs?msg1W;  goto s1_2_2_WRR;
			:: msgs?msg1B;  goto s1_2_2_WBR;
			:: msgs?msg1B;  goto s1_2_2_WRR;
			:: msgs?msg2R;  goto s1_2_2_WRR;
			:: msgs?msg2W;  goto s1_2_2_WRW;
			:: msgs?msg2W;  goto s1_2_2_WRR;
			:: msgs?msg2B;  goto s1_2_2_WRB;
			:: msgs?msg2B;  goto s1_2_2_WRR;
		fi;
	s1_2_2_WRW: if
			:: out!outW;  goto s1_0_0_WR0;
			:: msgs?msg0R;  goto s1_2_2_RRW;
			:: msgs?msg0R;  goto s1_2_2_WRW;
			:: msgs?msg0W;  goto s1_2_2_WRW;
			:: msgs?msg0B;  goto s1_2_2_BRW;
			:: msgs?msg0B;  goto s1_2_2_WRW;
			:: msgs?msg1R;  goto s1_2_2_WRW;
			:: msgs?msg1W;  goto s1_2_2_WWW;
			:: msgs?msg1W;  goto s1_2_2_WRW;
			:: msgs?msg1B;  goto s1_2_2_WBW;
			:: msgs?msg1B;  goto s1_2_2_WRW;
			:: msgs?msg2R;  goto s1_2_2_WRR;
			:: msgs?msg2R;  goto s1_2_2_WRW;
			:: msgs?msg2W;  goto s1_2_2_WRW;
			:: msgs?msg2B;  goto s1_2_2_WRB;
			:: msgs?msg2B;  goto s1_2_2_WRW;
		fi;
	s1_2_2_WRB: if
			:: out!outB;  goto s1_0_0_WR0;
			:: msgs?msg0R;  goto s1_2_2_RRB;
			:: msgs?msg0R;  goto s1_2_2_WRB;
			:: msgs?msg0W;  goto s1_2_2_WRB;
			:: msgs?msg0B;  goto s1_2_2_BRB;
			:: msgs?msg0B;  goto s1_2_2_WRB;
			:: msgs?msg1R;  goto s1_2_2_WRB;
			:: msgs?msg1W;  goto s1_2_2_WWB;
			:: msgs?msg1W;  goto s1_2_2_WRB;
			:: msgs?msg1B;  goto s1_2_2_WBB;
			:: msgs?msg1B;  goto s1_2_2_WRB;
			:: msgs?msg2R;  goto s1_2_2_WRR;
			:: msgs?msg2R;  goto s1_2_2_WRB;
			:: msgs?msg2W;  goto s1_2_2_WRW;
			:: msgs?msg2W;  goto s1_2_2_WRB;
			:: msgs?msg2B;  goto s1_2_2_WRB;
		fi;
	s1_2_2_WWR: if
			:: out!outR;  goto s1_0_0_WW0;
			:: msgs?msg0R;  goto s1_2_2_RWR;
			:: msgs?msg0R;  goto s1_2_2_WWR;
			:: msgs?msg0W;  goto s1_2_2_WWR;
			:: msgs?msg0B;  goto s1_2_2_BWR;
			:: msgs?msg0B;  goto s1_2_2_WWR;
			:: msgs?msg1R;  goto s1_2_2_WRR;
			:: msgs?msg1R;  goto s1_2_2_WWR;
			:: msgs?msg1W;  goto s1_2_2_WWR;
			:: msgs?msg1B;  goto s1_2_2_WBR;
			:: msgs?msg1B;  goto s1_2_2_WWR;
			:: msgs?msg2R;  goto s1_2_2_WWR;
			:: msgs?msg2W;  goto s1_2_2_WWW;
			:: msgs?msg2W;  goto s1_2_2_WWR;
			:: msgs?msg2B;  goto s1_2_2_WWB;
			:: msgs?msg2B;  goto s1_2_2_WWR;
		fi;
	s1_2_2_WWW: if
			:: out!outW;  goto s1_0_0_WW0;
			:: msgs?msg0R;  goto s1_2_2_RWW;
			:: msgs?msg0R;  goto s1_2_2_WWW;
			:: msgs?msg0W;  goto s1_2_2_WWW;
			:: msgs?msg0B;  goto s1_2_2_BWW;
			:: msgs?msg0B;  goto s1_2_2_WWW;
			:: msgs?msg1R;  goto s1_2_2_WRW;
			:: msgs?msg1R;  goto s1_2_2_WWW;
			:: msgs?msg1W;  goto s1_2_2_WWW;
			:: msgs?msg1B;  goto s1_2_2_WBW;
			:: msgs?msg1B;  goto s1_2_2_WWW;
			:: msgs?msg2R;  goto s1_2_2_WWR;
			:: msgs?msg2R;  goto s1_2_2_WWW;
			:: msgs?msg2W;  goto s1_2_2_WWW;
			:: msgs?msg2B;  goto s1_2_2_WWB;
			:: msgs?msg2B;  goto s1_2_2_WWW;
		fi;
	s1_2_2_WWB: if
			:: out!outB;  goto s1_0_0_WW0;
			:: msgs?msg0R;  goto s1_2_2_RWB;
			:: msgs?msg0R;  goto s1_2_2_WWB;
			:: msgs?msg0W;  goto s1_2_2_WWB;
			:: msgs?msg0B;  goto s1_2_2_BWB;
			:: msgs?msg0B;  goto s1_2_2_WWB;
			:: msgs?msg1R;  goto s1_2_2_WRB;
			:: msgs?msg1R;  goto s1_2_2_WWB;
			:: msgs?msg1W;  goto s1_2_2_WWB;
			:: msgs?msg1B;  goto s1_2_2_WBB;
			:: msgs?msg1B;  goto s1_2_2_WWB;
			:: msgs?msg2R;  goto s1_2_2_WWR;
			:: msgs?msg2R;  goto s1_2_2_WWB;
			:: msgs?msg2W;  goto s1_2_2_WWW;
			:: msgs?msg2W;  goto s1_2_2_WWB;
			:: msgs?msg2B;  goto s1_2_2_WWB;
		fi;
	s1_2_2_WBR: if
			:: out!outR;  goto s1_0_0_WB0;
			:: msgs?msg0R;  goto s1_2_2_RBR;
			:: msgs?msg0R;  goto s1_2_2_WBR;
			:: msgs?msg0W;  goto s1_2_2_WBR;
			:: msgs?msg0B;  goto s1_2_2_BBR;
			:: msgs?msg0B;  goto s1_2_2_WBR;
			:: msgs?msg1R;  goto s1_2_2_WRR;
			:: msgs?msg1R;  goto s1_2_2_WBR;
			:: msgs?msg1W;  goto s1_2_2_WWR;
			:: msgs?msg1W;  goto s1_2_2_WBR;
			:: msgs?msg1B;  goto s1_2_2_WBR;
			:: msgs?msg2R;  goto s1_2_2_WBR;
			:: msgs?msg2W;  goto s1_2_2_WBW;
			:: msgs?msg2W;  goto s1_2_2_WBR;
			:: msgs?msg2B;  goto s1_2_2_WBB;
			:: msgs?msg2B;  goto s1_2_2_WBR;
		fi;
	s1_2_2_WBW: if
			:: out!outW;  goto s1_0_0_WB0;
			:: msgs?msg0R;  goto s1_2_2_RBW;
			:: msgs?msg0R;  goto s1_2_2_WBW;
			:: msgs?msg0W;  goto s1_2_2_WBW;
			:: msgs?msg0B;  goto s1_2_2_BBW;
			:: msgs?msg0B;  goto s1_2_2_WBW;
			:: msgs?msg1R;  goto s1_2_2_WRW;
			:: msgs?msg1R;  goto s1_2_2_WBW;
			:: msgs?msg1W;  goto s1_2_2_WWW;
			:: msgs?msg1W;  goto s1_2_2_WBW;
			:: msgs?msg1B;  goto s1_2_2_WBW;
			:: msgs?msg2R;  goto s1_2_2_WBR;
			:: msgs?msg2R;  goto s1_2_2_WBW;
			:: msgs?msg2W;  goto s1_2_2_WBW;
			:: msgs?msg2B;  goto s1_2_2_WBB;
			:: msgs?msg2B;  goto s1_2_2_WBW;
		fi;
	s1_2_2_WBB: if
			:: out!outB;  goto s1_0_0_WB0;
			:: msgs?msg0R;  goto s1_2_2_RBB;
			:: msgs?msg0R;  goto s1_2_2_WBB;
			:: msgs?msg0W;  goto s1_2_2_WBB;
			:: msgs?msg0B;  goto s1_2_2_BBB;
			:: msgs?msg0B;  goto s1_2_2_WBB;
			:: msgs?msg1R;  goto s1_2_2_WRB;
			:: msgs?msg1R;  goto s1_2_2_WBB;
			:: msgs?msg1W;  goto s1_2_2_WWB;
			:: msgs?msg1W;  goto s1_2_2_WBB;
			:: msgs?msg1B;  goto s1_2_2_WBB;
			:: msgs?msg2R;  goto s1_2_2_WBR;
			:: msgs?msg2R;  goto s1_2_2_WBB;
			:: msgs?msg2W;  goto s1_2_2_WBW;
			:: msgs?msg2W;  goto s1_2_2_WBB;
			:: msgs?msg2B;  goto s1_2_2_WBB;
		fi;
	s1_0_0_W00: if
			:: out!outW;  goto s1_1_1_000;
			:: msgs?msg0R;  goto s1_0_0_R00;
			:: msgs?msg0R;  goto s1_0_0_W00;
			:: msgs?msg0W;  goto s1_0_0_W00;
			:: msgs?msg0B;  goto s1_0_0_B00;
			:: msgs?msg0B;  goto s1_0_0_W00;
			:: msgs?msg1R;  goto s1_0_0_WR0;
			:: msgs?msg1R;  goto s1_0_0_W00;
			:: msgs?msg1W;  goto s1_0_0_WW0;
			:: msgs?msg1W;  goto s1_0_0_W00;
			:: msgs?msg1B;  goto s1_0_0_WB0;
			:: msgs?msg1B;  goto s1_0_0_W00;
			:: msgs?msg2R;  goto s1_0_0_W0R;
			:: msgs?msg2R;  goto s1_0_0_W00;
			:: msgs?msg2W;  goto s1_0_0_W0W;
			:: msgs?msg2W;  goto s1_0_0_W00;
			:: msgs?msg2B;  goto s1_0_0_W0B;
			:: msgs?msg2B;  goto s1_0_0_W00;
		fi;
	s1_2_2_BRR: if
			:: out!outR;  goto s1_0_0_BR0;
			:: msgs?msg0R;  goto s1_2_2_RRR;
			:: msgs?msg0R;  goto s1_2_2_BRR;
			:: msgs?msg0W;  goto s1_2_2_WRR;
			:: msgs?msg0W;  goto s1_2_2_BRR;
			:: msgs?msg0B;  goto s1_2_2_BRR;
			:: msgs?msg1R;  goto s1_2_2_BRR;
			:: msgs?msg1W;  goto s1_2_2_BWR;
			:: msgs?msg1W;  goto s1_2_2_BRR;
			:: msgs?msg1B;  goto s1_2_2_BBR;
			:: msgs?msg1B;  goto s1_2_2_BRR;
			:: msgs?msg2R;  goto s1_2_2_BRR;
			:: msgs?msg2W;  goto s1_2_2_BRW;
			:: msgs?msg2W;  goto s1_2_2_BRR;
			:: msgs?msg2B;  goto s1_2_2_BRB;
			:: msgs?msg2B;  goto s1_2_2_BRR;
		fi;
	s1_2_2_BRW: if
			:: out!outW;  goto s1_0_0_BR0;
			:: msgs?msg0R;  goto s1_2_2_RRW;
			:: msgs?msg0R;  goto s1_2_2_BRW;
			:: msgs?msg0W;  goto s1_2_2_WRW;
			:: msgs?msg0W;  goto s1_2_2_BRW;
			:: msgs?msg0B;  goto s1_2_2_BRW;
			:: msgs?msg1R;  goto s1_2_2_BRW;
			:: msgs?msg1W;  goto s1_2_2_BWW;
			:: msgs?msg1W;  goto s1_2_2_BRW;
			:: msgs?msg1B;  goto s1_2_2_BBW;
			:: msgs?msg1B;  goto s1_2_2_BRW;
			:: msgs?msg2R;  goto s1_2_2_BRR;
			:: msgs?msg2R;  goto s1_2_2_BRW;
			:: msgs?msg2W;  goto s1_2_2_BRW;
			:: msgs?msg2B;  goto s1_2_2_BRB;
			:: msgs?msg2B;  goto s1_2_2_BRW;
		fi;
	s1_2_2_BRB: if
			:: out!outB;  goto s1_0_0_BR0;
			:: msgs?msg0R;  goto s1_2_2_RRB;
			:: msgs?msg0R;  goto s1_2_2_BRB;
			:: msgs?msg0W;  goto s1_2_2_WRB;
			:: msgs?msg0W;  goto s1_2_2_BRB;
			:: msgs?msg0B;  goto s1_2_2_BRB;
			:: msgs?msg1R;  goto s1_2_2_BRB;
			:: msgs?msg1W;  goto s1_2_2_BWB;
			:: msgs?msg1W;  goto s1_2_2_BRB;
			:: msgs?msg1B;  goto s1_2_2_BBB;
			:: msgs?msg1B;  goto s1_2_2_BRB;
			:: msgs?msg2R;  goto s1_2_2_BRR;
			:: msgs?msg2R;  goto s1_2_2_BRB;
			:: msgs?msg2W;  goto s1_2_2_BRW;
			:: msgs?msg2W;  goto s1_2_2_BRB;
			:: msgs?msg2B;  goto s1_2_2_BRB;
		fi;
	s1_2_2_BWR: if
			:: out!outR;  goto s1_0_0_BW0;
			:: msgs?msg0R;  goto s1_2_2_RWR;
			:: msgs?msg0R;  goto s1_2_2_BWR;
			:: msgs?msg0W;  goto s1_2_2_WWR;
			:: msgs?msg0W;  goto s1_2_2_BWR;
			:: msgs?msg0B;  goto s1_2_2_BWR;
			:: msgs?msg1R;  goto s1_2_2_BRR;
			:: msgs?msg1R;  goto s1_2_2_BWR;
			:: msgs?msg1W;  goto s1_2_2_BWR;
			:: msgs?msg1B;  goto s1_2_2_BBR;
			:: msgs?msg1B;  goto s1_2_2_BWR;
			:: msgs?msg2R;  goto s1_2_2_BWR;
			:: msgs?msg2W;  goto s1_2_2_BWW;
			:: msgs?msg2W;  goto s1_2_2_BWR;
			:: msgs?msg2B;  goto s1_2_2_BWB;
			:: msgs?msg2B;  goto s1_2_2_BWR;
		fi;
	s1_2_2_BWW: if
			:: out!outW;  goto s1_0_0_BW0;
			:: msgs?msg0R;  goto s1_2_2_RWW;
			:: msgs?msg0R;  goto s1_2_2_BWW;
			:: msgs?msg0W;  goto s1_2_2_WWW;
			:: msgs?msg0W;  goto s1_2_2_BWW;
			:: msgs?msg0B;  goto s1_2_2_BWW;
			:: msgs?msg1R;  goto s1_2_2_BRW;
			:: msgs?msg1R;  goto s1_2_2_BWW;
			:: msgs?msg1W;  goto s1_2_2_BWW;
			:: msgs?msg1B;  goto s1_2_2_BBW;
			:: msgs?msg1B;  goto s1_2_2_BWW;
			:: msgs?msg2R;  goto s1_2_2_BWR;
			:: msgs?msg2R;  goto s1_2_2_BWW;
			:: msgs?msg2W;  goto s1_2_2_BWW;
			:: msgs?msg2B;  goto s1_2_2_BWB;
			:: msgs?msg2B;  goto s1_2_2_BWW;
		fi;
	s1_2_2_BWB: if
			:: out!outB;  goto s1_0_0_BW0;
			:: msgs?msg0R;  goto s1_2_2_RWB;
			:: msgs?msg0R;  goto s1_2_2_BWB;
			:: msgs?msg0W;  goto s1_2_2_WWB;
			:: msgs?msg0W;  goto s1_2_2_BWB;
			:: msgs?msg0B;  goto s1_2_2_BWB;
			:: msgs?msg1R;  goto s1_2_2_BRB;
			:: msgs?msg1R;  goto s1_2_2_BWB;
			:: msgs?msg1W;  goto s1_2_2_BWB;
			:: msgs?msg1B;  goto s1_2_2_BBB;
			:: msgs?msg1B;  goto s1_2_2_BWB;
			:: msgs?msg2R;  goto s1_2_2_BWR;
			:: msgs?msg2R;  goto s1_2_2_BWB;
			:: msgs?msg2W;  goto s1_2_2_BWW;
			:: msgs?msg2W;  goto s1_2_2_BWB;
			:: msgs?msg2B;  goto s1_2_2_BWB;
		fi;
	s1_2_2_BBR: if
			:: out!outR;  goto s1_0_0_BB0;
			:: msgs?msg0R;  goto s1_2_2_RBR;
			:: msgs?msg0R;  goto s1_2_2_BBR;
			:: msgs?msg0W;  goto s1_2_2_WBR;
			:: msgs?msg0W;  goto s1_2_2_BBR;
			:: msgs?msg0B;  goto s1_2_2_BBR;
			:: msgs?msg1R;  goto s1_2_2_BRR;
			:: msgs?msg1R;  goto s1_2_2_BBR;
			:: msgs?msg1W;  goto s1_2_2_BWR;
			:: msgs?msg1W;  goto s1_2_2_BBR;
			:: msgs?msg1B;  goto s1_2_2_BBR;
			:: msgs?msg2R;  goto s1_2_2_BBR;
			:: msgs?msg2W;  goto s1_2_2_BBW;
			:: msgs?msg2W;  goto s1_2_2_BBR;
			:: msgs?msg2B;  goto s1_2_2_BBB;
			:: msgs?msg2B;  goto s1_2_2_BBR;
		fi;
	s1_2_2_BBW: if
			:: out!outW;  goto s1_0_0_BB0;
			:: msgs?msg0R;  goto s1_2_2_RBW;
			:: msgs?msg0R;  goto s1_2_2_BBW;
			:: msgs?msg0W;  goto s1_2_2_WBW;
			:: msgs?msg0W;  goto s1_2_2_BBW;
			:: msgs?msg0B;  goto s1_2_2_BBW;
			:: msgs?msg1R;  goto s1_2_2_BRW;
			:: msgs?msg1R;  goto s1_2_2_BBW;
			:: msgs?msg1W;  goto s1_2_2_BWW;
			:: msgs?msg1W;  goto s1_2_2_BBW;
			:: msgs?msg1B;  goto s1_2_2_BBW;
			:: msgs?msg2R;  goto s1_2_2_BBR;
			:: msgs?msg2R;  goto s1_2_2_BBW;
			:: msgs?msg2W;  goto s1_2_2_BBW;
			:: msgs?msg2B;  goto s1_2_2_BBB;
			:: msgs?msg2B;  goto s1_2_2_BBW;
		fi;
	s1_2_2_BBB: if
			:: out!outB;  goto s1_0_0_BB0;
			:: msgs?msg0R;  goto s1_2_2_RBB;
			:: msgs?msg0R;  goto s1_2_2_BBB;
			:: msgs?msg0W;  goto s1_2_2_WBB;
			:: msgs?msg0W;  goto s1_2_2_BBB;
			:: msgs?msg0B;  goto s1_2_2_BBB;
			:: msgs?msg1R;  goto s1_2_2_BRB;
			:: msgs?msg1R;  goto s1_2_2_BBB;
			:: msgs?msg1W;  goto s1_2_2_BWB;
			:: msgs?msg1W;  goto s1_2_2_BBB;
			:: msgs?msg1B;  goto s1_2_2_BBB;
			:: msgs?msg2R;  goto s1_2_2_BBR;
			:: msgs?msg2R;  goto s1_2_2_BBB;
			:: msgs?msg2W;  goto s1_2_2_BBW;
			:: msgs?msg2W;  goto s1_2_2_BBB;
			:: msgs?msg2B;  goto s1_2_2_BBB;
		fi;
	s1_0_0_B00: if
			:: out!outB;  goto s1_1_1_000;
			:: msgs?msg0R;  goto s1_0_0_R00;
			:: msgs?msg0R;  goto s1_0_0_B00;
			:: msgs?msg0W;  goto s1_0_0_W00;
			:: msgs?msg0W;  goto s1_0_0_B00;
			:: msgs?msg0B;  goto s1_0_0_B00;
			:: msgs?msg1R;  goto s1_0_0_BR0;
			:: msgs?msg1R;  goto s1_0_0_B00;
			:: msgs?msg1W;  goto s1_0_0_BW0;
			:: msgs?msg1W;  goto s1_0_0_B00;
			:: msgs?msg1B;  goto s1_0_0_BB0;
			:: msgs?msg1B;  goto s1_0_0_B00;
			:: msgs?msg2R;  goto s1_0_0_B0R;
			:: msgs?msg2R;  goto s1_0_0_B00;
			:: msgs?msg2W;  goto s1_0_0_B0W;
			:: msgs?msg2W;  goto s1_0_0_B00;
			:: msgs?msg2B;  goto s1_0_0_B0B;
			:: msgs?msg2B;  goto s1_0_0_B00;
		fi;
	s1_0_0_0R0: if
			:: acks!ack2;  goto s1_0_0_0R0;
			:: msgs?msg0R;  goto s1_0_0_RR0;
			:: msgs?msg0R;  goto s1_0_0_0R0;
			:: msgs?msg0W;  goto s1_0_0_WR0;
			:: msgs?msg0W;  goto s1_0_0_0R0;
			:: msgs?msg0B;  goto s1_0_0_BR0;
			:: msgs?msg0B;  goto s1_0_0_0R0;
			:: msgs?msg1R;  goto s1_0_0_0R0;
			:: msgs?msg1W;  goto s1_0_0_0W0;
			:: msgs?msg1W;  goto s1_0_0_0R0;
			:: msgs?msg1B;  goto s1_0_0_0B0;
			:: msgs?msg1B;  goto s1_0_0_0R0;
			:: msgs?msg2R;  goto s1_0_0_0RR;
			:: msgs?msg2R;  goto s1_0_0_0R0;
			:: msgs?msg2W;  goto s1_0_0_0RW;
			:: msgs?msg2W;  goto s1_0_0_0R0;
			:: msgs?msg2B;  goto s1_0_0_0RB;
			:: msgs?msg2B;  goto s1_0_0_0R0;
		fi;
	s1_0_0_0W0: if
			:: acks!ack2;  goto s1_0_0_0W0;
			:: msgs?msg0R;  goto s1_0_0_RW0;
			:: msgs?msg0R;  goto s1_0_0_0W0;
			:: msgs?msg0W;  goto s1_0_0_WW0;
			:: msgs?msg0W;  goto s1_0_0_0W0;
			:: msgs?msg0B;  goto s1_0_0_BW0;
			:: msgs?msg0B;  goto s1_0_0_0W0;
			:: msgs?msg1R;  goto s1_0_0_0R0;
			:: msgs?msg1R;  goto s1_0_0_0W0;
			:: msgs?msg1W;  goto s1_0_0_0W0;
			:: msgs?msg1B;  goto s1_0_0_0B0;
			:: msgs?msg1B;  goto s1_0_0_0W0;
			:: msgs?msg2R;  goto s1_0_0_0WR;
			:: msgs?msg2R;  goto s1_0_0_0W0;
			:: msgs?msg2W;  goto s1_0_0_0WW;
			:: msgs?msg2W;  goto s1_0_0_0W0;
			:: msgs?msg2B;  goto s1_0_0_0WB;
			:: msgs?msg2B;  goto s1_0_0_0W0;
		fi;
	s1_0_0_0B0: if
			:: acks!ack2;  goto s1_0_0_0B0;
			:: msgs?msg0R;  goto s1_0_0_RB0;
			:: msgs?msg0R;  goto s1_0_0_0B0;
			:: msgs?msg0W;  goto s1_0_0_WB0;
			:: msgs?msg0W;  goto s1_0_0_0B0;
			:: msgs?msg0B;  goto s1_0_0_BB0;
			:: msgs?msg0B;  goto s1_0_0_0B0;
			:: msgs?msg1R;  goto s1_0_0_0R0;
			:: msgs?msg1R;  goto s1_0_0_0B0;
			:: msgs?msg1W;  goto s1_0_0_0W0;
			:: msgs?msg1W;  goto s1_0_0_0B0;
			:: msgs?msg1B;  goto s1_0_0_0B0;
			:: msgs?msg2R;  goto s1_0_0_0BR;
			:: msgs?msg2R;  goto s1_0_0_0B0;
			:: msgs?msg2W;  goto s1_0_0_0BW;
			:: msgs?msg2W;  goto s1_0_0_0B0;
			:: msgs?msg2B;  goto s1_0_0_0BB;
			:: msgs?msg2B;  goto s1_0_0_0B0;
		fi;
	s1_0_0_00R: if
			:: acks!ack2;  goto s1_0_0_00R;
			:: msgs?msg0R;  goto s1_0_0_R0R;
			:: msgs?msg0R;  goto s1_0_0_00R;
			:: msgs?msg0W;  goto s1_0_0_W0R;
			:: msgs?msg0W;  goto s1_0_0_00R;
			:: msgs?msg0B;  goto s1_0_0_B0R;
			:: msgs?msg0B;  goto s1_0_0_00R;
			:: msgs?msg1R;  goto s1_0_0_0RR;
			:: msgs?msg1R;  goto s1_0_0_00R;
			:: msgs?msg1W;  goto s1_0_0_0WR;
			:: msgs?msg1W;  goto s1_0_0_00R;
			:: msgs?msg1B;  goto s1_0_0_0BR;
			:: msgs?msg1B;  goto s1_0_0_00R;
			:: msgs?msg2R;  goto s1_0_0_00R;
			:: msgs?msg2W;  goto s1_0_0_00W;
			:: msgs?msg2W;  goto s1_0_0_00R;
			:: msgs?msg2B;  goto s1_0_0_00B;
			:: msgs?msg2B;  goto s1_0_0_00R;
		fi;
	s1_0_0_00W: if
			:: acks!ack2;  goto s1_0_0_00W;
			:: msgs?msg0R;  goto s1_0_0_R0W;
			:: msgs?msg0R;  goto s1_0_0_00W;
			:: msgs?msg0W;  goto s1_0_0_W0W;
			:: msgs?msg0W;  goto s1_0_0_00W;
			:: msgs?msg0B;  goto s1_0_0_B0W;
			:: msgs?msg0B;  goto s1_0_0_00W;
			:: msgs?msg1R;  goto s1_0_0_0RW;
			:: msgs?msg1R;  goto s1_0_0_00W;
			:: msgs?msg1W;  goto s1_0_0_0WW;
			:: msgs?msg1W;  goto s1_0_0_00W;
			:: msgs?msg1B;  goto s1_0_0_0BW;
			:: msgs?msg1B;  goto s1_0_0_00W;
			:: msgs?msg2R;  goto s1_0_0_00R;
			:: msgs?msg2R;  goto s1_0_0_00W;
			:: msgs?msg2W;  goto s1_0_0_00W;
			:: msgs?msg2B;  goto s1_0_0_00B;
			:: msgs?msg2B;  goto s1_0_0_00W;
		fi;
	s1_0_0_00B: if
			:: acks!ack2;  goto s1_0_0_00B;
			:: msgs?msg0R;  goto s1_0_0_R0B;
			:: msgs?msg0R;  goto s1_0_0_00B;
			:: msgs?msg0W;  goto s1_0_0_W0B;
			:: msgs?msg0W;  goto s1_0_0_00B;
			:: msgs?msg0B;  goto s1_0_0_B0B;
			:: msgs?msg0B;  goto s1_0_0_00B;
			:: msgs?msg1R;  goto s1_0_0_0RB;
			:: msgs?msg1R;  goto s1_0_0_00B;
			:: msgs?msg1W;  goto s1_0_0_0WB;
			:: msgs?msg1W;  goto s1_0_0_00B;
			:: msgs?msg1B;  goto s1_0_0_0BB;
			:: msgs?msg1B;  goto s1_0_0_00B;
			:: msgs?msg2R;  goto s1_0_0_00R;
			:: msgs?msg2R;  goto s1_0_0_00B;
			:: msgs?msg2W;  goto s1_0_0_00W;
			:: msgs?msg2W;  goto s1_0_0_00B;
			:: msgs?msg2B;  goto s1_0_0_00B;
		fi;
	s1_0_0_RR0: if
			:: out!outR;  goto s1_1_1_0R0;
			:: msgs?msg0R;  goto s1_0_0_RR0;
			:: msgs?msg0W;  goto s1_0_0_WR0;
			:: msgs?msg0W;  goto s1_0_0_RR0;
			:: msgs?msg0B;  goto s1_0_0_BR0;
			:: msgs?msg0B;  goto s1_0_0_RR0;
			:: msgs?msg1R;  goto s1_0_0_RR0;
			:: msgs?msg1W;  goto s1_0_0_RW0;
			:: msgs?msg1W;  goto s1_0_0_RR0;
			:: msgs?msg1B;  goto s1_0_0_RB0;
			:: msgs?msg1B;  goto s1_0_0_RR0;
			:: msgs?msg2R;  goto s1_0_0_RRR;
			:: msgs?msg2R;  goto s1_0_0_RR0;
			:: msgs?msg2W;  goto s1_0_0_RRW;
			:: msgs?msg2W;  goto s1_0_0_RR0;
			:: msgs?msg2B;  goto s1_0_0_RRB;
			:: msgs?msg2B;  goto s1_0_0_RR0;
		fi;
	s1_0_0_RW0: if
			:: out!outR;  goto s1_1_1_0W0;
			:: msgs?msg0R;  goto s1_0_0_RW0;
			:: msgs?msg0W;  goto s1_0_0_WW0;
			:: msgs?msg0W;  goto s1_0_0_RW0;
			:: msgs?msg0B;  goto s1_0_0_BW0;
			:: msgs?msg0B;  goto s1_0_0_RW0;
			:: msgs?msg1R;  goto s1_0_0_RR0;
			:: msgs?msg1R;  goto s1_0_0_RW0;
			:: msgs?msg1W;  goto s1_0_0_RW0;
			:: msgs?msg1B;  goto s1_0_0_RB0;
			:: msgs?msg1B;  goto s1_0_0_RW0;
			:: msgs?msg2R;  goto s1_0_0_RWR;
			:: msgs?msg2R;  goto s1_0_0_RW0;
			:: msgs?msg2W;  goto s1_0_0_RWW;
			:: msgs?msg2W;  goto s1_0_0_RW0;
			:: msgs?msg2B;  goto s1_0_0_RWB;
			:: msgs?msg2B;  goto s1_0_0_RW0;
		fi;
	s1_0_0_RB0: if
			:: out!outR;  goto s1_1_1_0B0;
			:: msgs?msg0R;  goto s1_0_0_RB0;
			:: msgs?msg0W;  goto s1_0_0_WB0;
			:: msgs?msg0W;  goto s1_0_0_RB0;
			:: msgs?msg0B;  goto s1_0_0_BB0;
			:: msgs?msg0B;  goto s1_0_0_RB0;
			:: msgs?msg1R;  goto s1_0_0_RR0;
			:: msgs?msg1R;  goto s1_0_0_RB0;
			:: msgs?msg1W;  goto s1_0_0_RW0;
			:: msgs?msg1W;  goto s1_0_0_RB0;
			:: msgs?msg1B;  goto s1_0_0_RB0;
			:: msgs?msg2R;  goto s1_0_0_RBR;
			:: msgs?msg2R;  goto s1_0_0_RB0;
			:: msgs?msg2W;  goto s1_0_0_RBW;
			:: msgs?msg2W;  goto s1_0_0_RB0;
			:: msgs?msg2B;  goto s1_0_0_RBB;
			:: msgs?msg2B;  goto s1_0_0_RB0;
		fi;
	s1_0_0_R0R: if
			:: out!outR;  goto s1_1_1_00R;
			:: msgs?msg0R;  goto s1_0_0_R0R;
			:: msgs?msg0W;  goto s1_0_0_W0R;
			:: msgs?msg0W;  goto s1_0_0_R0R;
			:: msgs?msg0B;  goto s1_0_0_B0R;
			:: msgs?msg0B;  goto s1_0_0_R0R;
			:: msgs?msg1R;  goto s1_0_0_RRR;
			:: msgs?msg1R;  goto s1_0_0_R0R;
			:: msgs?msg1W;  goto s1_0_0_RWR;
			:: msgs?msg1W;  goto s1_0_0_R0R;
			:: msgs?msg1B;  goto s1_0_0_RBR;
			:: msgs?msg1B;  goto s1_0_0_R0R;
			:: msgs?msg2R;  goto s1_0_0_R0R;
			:: msgs?msg2W;  goto s1_0_0_R0W;
			:: msgs?msg2W;  goto s1_0_0_R0R;
			:: msgs?msg2B;  goto s1_0_0_R0B;
			:: msgs?msg2B;  goto s1_0_0_R0R;
		fi;
	s1_0_0_R0W: if
			:: out!outR;  goto s1_1_1_00W;
			:: msgs?msg0R;  goto s1_0_0_R0W;
			:: msgs?msg0W;  goto s1_0_0_W0W;
			:: msgs?msg0W;  goto s1_0_0_R0W;
			:: msgs?msg0B;  goto s1_0_0_B0W;
			:: msgs?msg0B;  goto s1_0_0_R0W;
			:: msgs?msg1R;  goto s1_0_0_RRW;
			:: msgs?msg1R;  goto s1_0_0_R0W;
			:: msgs?msg1W;  goto s1_0_0_RWW;
			:: msgs?msg1W;  goto s1_0_0_R0W;
			:: msgs?msg1B;  goto s1_0_0_RBW;
			:: msgs?msg1B;  goto s1_0_0_R0W;
			:: msgs?msg2R;  goto s1_0_0_R0R;
			:: msgs?msg2R;  goto s1_0_0_R0W;
			:: msgs?msg2W;  goto s1_0_0_R0W;
			:: msgs?msg2B;  goto s1_0_0_R0B;
			:: msgs?msg2B;  goto s1_0_0_R0W;
		fi;
	s1_0_0_R0B: if
			:: out!outR;  goto s1_1_1_00B;
			:: msgs?msg0R;  goto s1_0_0_R0B;
			:: msgs?msg0W;  goto s1_0_0_W0B;
			:: msgs?msg0W;  goto s1_0_0_R0B;
			:: msgs?msg0B;  goto s1_0_0_B0B;
			:: msgs?msg0B;  goto s1_0_0_R0B;
			:: msgs?msg1R;  goto s1_0_0_RRB;
			:: msgs?msg1R;  goto s1_0_0_R0B;
			:: msgs?msg1W;  goto s1_0_0_RWB;
			:: msgs?msg1W;  goto s1_0_0_R0B;
			:: msgs?msg1B;  goto s1_0_0_RBB;
			:: msgs?msg1B;  goto s1_0_0_R0B;
			:: msgs?msg2R;  goto s1_0_0_R0R;
			:: msgs?msg2R;  goto s1_0_0_R0B;
			:: msgs?msg2W;  goto s1_0_0_R0W;
			:: msgs?msg2W;  goto s1_0_0_R0B;
			:: msgs?msg2B;  goto s1_0_0_R0B;
		fi;
	s1_0_0_WR0: if
			:: out!outW;  goto s1_1_1_0R0;
			:: msgs?msg0R;  goto s1_0_0_RR0;
			:: msgs?msg0R;  goto s1_0_0_WR0;
			:: msgs?msg0W;  goto s1_0_0_WR0;
			:: msgs?msg0B;  goto s1_0_0_BR0;
			:: msgs?msg0B;  goto s1_0_0_WR0;
			:: msgs?msg1R;  goto s1_0_0_WR0;
			:: msgs?msg1W;  goto s1_0_0_WW0;
			:: msgs?msg1W;  goto s1_0_0_WR0;
			:: msgs?msg1B;  goto s1_0_0_WB0;
			:: msgs?msg1B;  goto s1_0_0_WR0;
			:: msgs?msg2R;  goto s1_0_0_WRR;
			:: msgs?msg2R;  goto s1_0_0_WR0;
			:: msgs?msg2W;  goto s1_0_0_WRW;
			:: msgs?msg2W;  goto s1_0_0_WR0;
			:: msgs?msg2B;  goto s1_0_0_WRB;
			:: msgs?msg2B;  goto s1_0_0_WR0;
		fi;
	s1_0_0_WW0: if
			:: out!outW;  goto s1_1_1_0W0;
			:: msgs?msg0R;  goto s1_0_0_RW0;
			:: msgs?msg0R;  goto s1_0_0_WW0;
			:: msgs?msg0W;  goto s1_0_0_WW0;
			:: msgs?msg0B;  goto s1_0_0_BW0;
			:: msgs?msg0B;  goto s1_0_0_WW0;
			:: msgs?msg1R;  goto s1_0_0_WR0;
			:: msgs?msg1R;  goto s1_0_0_WW0;
			:: msgs?msg1W;  goto s1_0_0_WW0;
			:: msgs?msg1B;  goto s1_0_0_WB0;
			:: msgs?msg1B;  goto s1_0_0_WW0;
			:: msgs?msg2R;  goto s1_0_0_WWR;
			:: msgs?msg2R;  goto s1_0_0_WW0;
			:: msgs?msg2W;  goto s1_0_0_WWW;
			:: msgs?msg2W;  goto s1_0_0_WW0;
			:: msgs?msg2B;  goto s1_0_0_WWB;
			:: msgs?msg2B;  goto s1_0_0_WW0;
		fi;
	s1_0_0_WB0: if
			:: out!outW;  goto s1_1_1_0B0;
			:: msgs?msg0R;  goto s1_0_0_RB0;
			:: msgs?msg0R;  goto s1_0_0_WB0;
			:: msgs?msg0W;  goto s1_0_0_WB0;
			:: msgs?msg0B;  goto s1_0_0_BB0;
			:: msgs?msg0B;  goto s1_0_0_WB0;
			:: msgs?msg1R;  goto s1_0_0_WR0;
			:: msgs?msg1R;  goto s1_0_0_WB0;
			:: msgs?msg1W;  goto s1_0_0_WW0;
			:: msgs?msg1W;  goto s1_0_0_WB0;
			:: msgs?msg1B;  goto s1_0_0_WB0;
			:: msgs?msg2R;  goto s1_0_0_WBR;
			:: msgs?msg2R;  goto s1_0_0_WB0;
			:: msgs?msg2W;  goto s1_0_0_WBW;
			:: msgs?msg2W;  goto s1_0_0_WB0;
			:: msgs?msg2B;  goto s1_0_0_WBB;
			:: msgs?msg2B;  goto s1_0_0_WB0;
		fi;
	s1_0_0_W0R: if
			:: out!outW;  goto s1_1_1_00R;
			:: msgs?msg0R;  goto s1_0_0_R0R;
			:: msgs?msg0R;  goto s1_0_0_W0R;
			:: msgs?msg0W;  goto s1_0_0_W0R;
			:: msgs?msg0B;  goto s1_0_0_B0R;
			:: msgs?msg0B;  goto s1_0_0_W0R;
			:: msgs?msg1R;  goto s1_0_0_WRR;
			:: msgs?msg1R;  goto s1_0_0_W0R;
			:: msgs?msg1W;  goto s1_0_0_WWR;
			:: msgs?msg1W;  goto s1_0_0_W0R;
			:: msgs?msg1B;  goto s1_0_0_WBR;
			:: msgs?msg1B;  goto s1_0_0_W0R;
			:: msgs?msg2R;  goto s1_0_0_W0R;
			:: msgs?msg2W;  goto s1_0_0_W0W;
			:: msgs?msg2W;  goto s1_0_0_W0R;
			:: msgs?msg2B;  goto s1_0_0_W0B;
			:: msgs?msg2B;  goto s1_0_0_W0R;
		fi;
	s1_0_0_W0W: if
			:: out!outW;  goto s1_1_1_00W;
			:: msgs?msg0R;  goto s1_0_0_R0W;
			:: msgs?msg0R;  goto s1_0_0_W0W;
			:: msgs?msg0W;  goto s1_0_0_W0W;
			:: msgs?msg0B;  goto s1_0_0_B0W;
			:: msgs?msg0B;  goto s1_0_0_W0W;
			:: msgs?msg1R;  goto s1_0_0_WRW;
			:: msgs?msg1R;  goto s1_0_0_W0W;
			:: msgs?msg1W;  goto s1_0_0_WWW;
			:: msgs?msg1W;  goto s1_0_0_W0W;
			:: msgs?msg1B;  goto s1_0_0_WBW;
			:: msgs?msg1B;  goto s1_0_0_W0W;
			:: msgs?msg2R;  goto s1_0_0_W0R;
			:: msgs?msg2R;  goto s1_0_0_W0W;
			:: msgs?msg2W;  goto s1_0_0_W0W;
			:: msgs?msg2B;  goto s1_0_0_W0B;
			:: msgs?msg2B;  goto s1_0_0_W0W;
		fi;
	s1_0_0_W0B: if
			:: out!outW;  goto s1_1_1_00B;
			:: msgs?msg0R;  goto s1_0_0_R0B;
			:: msgs?msg0R;  goto s1_0_0_W0B;
			:: msgs?msg0W;  goto s1_0_0_W0B;
			:: msgs?msg0B;  goto s1_0_0_B0B;
			:: msgs?msg0B;  goto s1_0_0_W0B;
			:: msgs?msg1R;  goto s1_0_0_WRB;
			:: msgs?msg1R;  goto s1_0_0_W0B;
			:: msgs?msg1W;  goto s1_0_0_WWB;
			:: msgs?msg1W;  goto s1_0_0_W0B;
			:: msgs?msg1B;  goto s1_0_0_WBB;
			:: msgs?msg1B;  goto s1_0_0_W0B;
			:: msgs?msg2R;  goto s1_0_0_W0R;
			:: msgs?msg2R;  goto s1_0_0_W0B;
			:: msgs?msg2W;  goto s1_0_0_W0W;
			:: msgs?msg2W;  goto s1_0_0_W0B;
			:: msgs?msg2B;  goto s1_0_0_W0B;
		fi;
	s1_0_0_BR0: if
			:: out!outB;  goto s1_1_1_0R0;
			:: msgs?msg0R;  goto s1_0_0_RR0;
			:: msgs?msg0R;  goto s1_0_0_BR0;
			:: msgs?msg0W;  goto s1_0_0_WR0;
			:: msgs?msg0W;  goto s1_0_0_BR0;
			:: msgs?msg0B;  goto s1_0_0_BR0;
			:: msgs?msg1R;  goto s1_0_0_BR0;
			:: msgs?msg1W;  goto s1_0_0_BW0;
			:: msgs?msg1W;  goto s1_0_0_BR0;
			:: msgs?msg1B;  goto s1_0_0_BB0;
			:: msgs?msg1B;  goto s1_0_0_BR0;
			:: msgs?msg2R;  goto s1_0_0_BRR;
			:: msgs?msg2R;  goto s1_0_0_BR0;
			:: msgs?msg2W;  goto s1_0_0_BRW;
			:: msgs?msg2W;  goto s1_0_0_BR0;
			:: msgs?msg2B;  goto s1_0_0_BRB;
			:: msgs?msg2B;  goto s1_0_0_BR0;
		fi;
	s1_0_0_BW0: if
			:: out!outB;  goto s1_1_1_0W0;
			:: msgs?msg0R;  goto s1_0_0_RW0;
			:: msgs?msg0R;  goto s1_0_0_BW0;
			:: msgs?msg0W;  goto s1_0_0_WW0;
			:: msgs?msg0W;  goto s1_0_0_BW0;
			:: msgs?msg0B;  goto s1_0_0_BW0;
			:: msgs?msg1R;  goto s1_0_0_BR0;
			:: msgs?msg1R;  goto s1_0_0_BW0;
			:: msgs?msg1W;  goto s1_0_0_BW0;
			:: msgs?msg1B;  goto s1_0_0_BB0;
			:: msgs?msg1B;  goto s1_0_0_BW0;
			:: msgs?msg2R;  goto s1_0_0_BWR;
			:: msgs?msg2R;  goto s1_0_0_BW0;
			:: msgs?msg2W;  goto s1_0_0_BWW;
			:: msgs?msg2W;  goto s1_0_0_BW0;
			:: msgs?msg2B;  goto s1_0_0_BWB;
			:: msgs?msg2B;  goto s1_0_0_BW0;
		fi;
	s1_0_0_BB0: if
			:: out!outB;  goto s1_1_1_0B0;
			:: msgs?msg0R;  goto s1_0_0_RB0;
			:: msgs?msg0R;  goto s1_0_0_BB0;
			:: msgs?msg0W;  goto s1_0_0_WB0;
			:: msgs?msg0W;  goto s1_0_0_BB0;
			:: msgs?msg0B;  goto s1_0_0_BB0;
			:: msgs?msg1R;  goto s1_0_0_BR0;
			:: msgs?msg1R;  goto s1_0_0_BB0;
			:: msgs?msg1W;  goto s1_0_0_BW0;
			:: msgs?msg1W;  goto s1_0_0_BB0;
			:: msgs?msg1B;  goto s1_0_0_BB0;
			:: msgs?msg2R;  goto s1_0_0_BBR;
			:: msgs?msg2R;  goto s1_0_0_BB0;
			:: msgs?msg2W;  goto s1_0_0_BBW;
			:: msgs?msg2W;  goto s1_0_0_BB0;
			:: msgs?msg2B;  goto s1_0_0_BBB;
			:: msgs?msg2B;  goto s1_0_0_BB0;
		fi;
	s1_0_0_B0R: if
			:: out!outB;  goto s1_1_1_00R;
			:: msgs?msg0R;  goto s1_0_0_R0R;
			:: msgs?msg0R;  goto s1_0_0_B0R;
			:: msgs?msg0W;  goto s1_0_0_W0R;
			:: msgs?msg0W;  goto s1_0_0_B0R;
			:: msgs?msg0B;  goto s1_0_0_B0R;
			:: msgs?msg1R;  goto s1_0_0_BRR;
			:: msgs?msg1R;  goto s1_0_0_B0R;
			:: msgs?msg1W;  goto s1_0_0_BWR;
			:: msgs?msg1W;  goto s1_0_0_B0R;
			:: msgs?msg1B;  goto s1_0_0_BBR;
			:: msgs?msg1B;  goto s1_0_0_B0R;
			:: msgs?msg2R;  goto s1_0_0_B0R;
			:: msgs?msg2W;  goto s1_0_0_B0W;
			:: msgs?msg2W;  goto s1_0_0_B0R;
			:: msgs?msg2B;  goto s1_0_0_B0B;
			:: msgs?msg2B;  goto s1_0_0_B0R;
		fi;
	s1_0_0_B0W: if
			:: out!outB;  goto s1_1_1_00W;
			:: msgs?msg0R;  goto s1_0_0_R0W;
			:: msgs?msg0R;  goto s1_0_0_B0W;
			:: msgs?msg0W;  goto s1_0_0_W0W;
			:: msgs?msg0W;  goto s1_0_0_B0W;
			:: msgs?msg0B;  goto s1_0_0_B0W;
			:: msgs?msg1R;  goto s1_0_0_BRW;
			:: msgs?msg1R;  goto s1_0_0_B0W;
			:: msgs?msg1W;  goto s1_0_0_BWW;
			:: msgs?msg1W;  goto s1_0_0_B0W;
			:: msgs?msg1B;  goto s1_0_0_BBW;
			:: msgs?msg1B;  goto s1_0_0_B0W;
			:: msgs?msg2R;  goto s1_0_0_B0R;
			:: msgs?msg2R;  goto s1_0_0_B0W;
			:: msgs?msg2W;  goto s1_0_0_B0W;
			:: msgs?msg2B;  goto s1_0_0_B0B;
			:: msgs?msg2B;  goto s1_0_0_B0W;
		fi;
	s1_0_0_B0B: if
			:: out!outB;  goto s1_1_1_00B;
			:: msgs?msg0R;  goto s1_0_0_R0B;
			:: msgs?msg0R;  goto s1_0_0_B0B;
			:: msgs?msg0W;  goto s1_0_0_W0B;
			:: msgs?msg0W;  goto s1_0_0_B0B;
			:: msgs?msg0B;  goto s1_0_0_B0B;
			:: msgs?msg1R;  goto s1_0_0_BRB;
			:: msgs?msg1R;  goto s1_0_0_B0B;
			:: msgs?msg1W;  goto s1_0_0_BWB;
			:: msgs?msg1W;  goto s1_0_0_B0B;
			:: msgs?msg1B;  goto s1_0_0_BBB;
			:: msgs?msg1B;  goto s1_0_0_B0B;
			:: msgs?msg2R;  goto s1_0_0_B0R;
			:: msgs?msg2R;  goto s1_0_0_B0B;
			:: msgs?msg2W;  goto s1_0_0_B0W;
			:: msgs?msg2W;  goto s1_0_0_B0B;
			:: msgs?msg2B;  goto s1_0_0_B0B;
		fi;
	s1_0_0_0RR: if
			:: acks!ack2;  goto s1_0_0_0RR;
			:: msgs?msg0R;  goto s1_0_0_RRR;
			:: msgs?msg0R;  goto s1_0_0_0RR;
			:: msgs?msg0W;  goto s1_0_0_WRR;
			:: msgs?msg0W;  goto s1_0_0_0RR;
			:: msgs?msg0B;  goto s1_0_0_BRR;
			:: msgs?msg0B;  goto s1_0_0_0RR;
			:: msgs?msg1R;  goto s1_0_0_0RR;
			:: msgs?msg1W;  goto s1_0_0_0WR;
			:: msgs?msg1W;  goto s1_0_0_0RR;
			:: msgs?msg1B;  goto s1_0_0_0BR;
			:: msgs?msg1B;  goto s1_0_0_0RR;
			:: msgs?msg2R;  goto s1_0_0_0RR;
			:: msgs?msg2W;  goto s1_0_0_0RW;
			:: msgs?msg2W;  goto s1_0_0_0RR;
			:: msgs?msg2B;  goto s1_0_0_0RB;
			:: msgs?msg2B;  goto s1_0_0_0RR;
		fi;
	s1_0_0_0RW: if
			:: acks!ack2;  goto s1_0_0_0RW;
			:: msgs?msg0R;  goto s1_0_0_RRW;
			:: msgs?msg0R;  goto s1_0_0_0RW;
			:: msgs?msg0W;  goto s1_0_0_WRW;
			:: msgs?msg0W;  goto s1_0_0_0RW;
			:: msgs?msg0B;  goto s1_0_0_BRW;
			:: msgs?msg0B;  goto s1_0_0_0RW;
			:: msgs?msg1R;  goto s1_0_0_0RW;
			:: msgs?msg1W;  goto s1_0_0_0WW;
			:: msgs?msg1W;  goto s1_0_0_0RW;
			:: msgs?msg1B;  goto s1_0_0_0BW;
			:: msgs?msg1B;  goto s1_0_0_0RW;
			:: msgs?msg2R;  goto s1_0_0_0RR;
			:: msgs?msg2R;  goto s1_0_0_0RW;
			:: msgs?msg2W;  goto s1_0_0_0RW;
			:: msgs?msg2B;  goto s1_0_0_0RB;
			:: msgs?msg2B;  goto s1_0_0_0RW;
		fi;
	s1_0_0_0RB: if
			:: acks!ack2;  goto s1_0_0_0RB;
			:: msgs?msg0R;  goto s1_0_0_RRB;
			:: msgs?msg0R;  goto s1_0_0_0RB;
			:: msgs?msg0W;  goto s1_0_0_WRB;
			:: msgs?msg0W;  goto s1_0_0_0RB;
			:: msgs?msg0B;  goto s1_0_0_BRB;
			:: msgs?msg0B;  goto s1_0_0_0RB;
			:: msgs?msg1R;  goto s1_0_0_0RB;
			:: msgs?msg1W;  goto s1_0_0_0WB;
			:: msgs?msg1W;  goto s1_0_0_0RB;
			:: msgs?msg1B;  goto s1_0_0_0BB;
			:: msgs?msg1B;  goto s1_0_0_0RB;
			:: msgs?msg2R;  goto s1_0_0_0RR;
			:: msgs?msg2R;  goto s1_0_0_0RB;
			:: msgs?msg2W;  goto s1_0_0_0RW;
			:: msgs?msg2W;  goto s1_0_0_0RB;
			:: msgs?msg2B;  goto s1_0_0_0RB;
		fi;
	s1_0_0_0WR: if
			:: acks!ack2;  goto s1_0_0_0WR;
			:: msgs?msg0R;  goto s1_0_0_RWR;
			:: msgs?msg0R;  goto s1_0_0_0WR;
			:: msgs?msg0W;  goto s1_0_0_WWR;
			:: msgs?msg0W;  goto s1_0_0_0WR;
			:: msgs?msg0B;  goto s1_0_0_BWR;
			:: msgs?msg0B;  goto s1_0_0_0WR;
			:: msgs?msg1R;  goto s1_0_0_0RR;
			:: msgs?msg1R;  goto s1_0_0_0WR;
			:: msgs?msg1W;  goto s1_0_0_0WR;
			:: msgs?msg1B;  goto s1_0_0_0BR;
			:: msgs?msg1B;  goto s1_0_0_0WR;
			:: msgs?msg2R;  goto s1_0_0_0WR;
			:: msgs?msg2W;  goto s1_0_0_0WW;
			:: msgs?msg2W;  goto s1_0_0_0WR;
			:: msgs?msg2B;  goto s1_0_0_0WB;
			:: msgs?msg2B;  goto s1_0_0_0WR;
		fi;
	s1_0_0_0WW: if
			:: acks!ack2;  goto s1_0_0_0WW;
			:: msgs?msg0R;  goto s1_0_0_RWW;
			:: msgs?msg0R;  goto s1_0_0_0WW;
			:: msgs?msg0W;  goto s1_0_0_WWW;
			:: msgs?msg0W;  goto s1_0_0_0WW;
			:: msgs?msg0B;  goto s1_0_0_BWW;
			:: msgs?msg0B;  goto s1_0_0_0WW;
			:: msgs?msg1R;  goto s1_0_0_0RW;
			:: msgs?msg1R;  goto s1_0_0_0WW;
			:: msgs?msg1W;  goto s1_0_0_0WW;
			:: msgs?msg1B;  goto s1_0_0_0BW;
			:: msgs?msg1B;  goto s1_0_0_0WW;
			:: msgs?msg2R;  goto s1_0_0_0WR;
			:: msgs?msg2R;  goto s1_0_0_0WW;
			:: msgs?msg2W;  goto s1_0_0_0WW;
			:: msgs?msg2B;  goto s1_0_0_0WB;
			:: msgs?msg2B;  goto s1_0_0_0WW;
		fi;
	s1_0_0_0WB: if
			:: acks!ack2;  goto s1_0_0_0WB;
			:: msgs?msg0R;  goto s1_0_0_RWB;
			:: msgs?msg0R;  goto s1_0_0_0WB;
			:: msgs?msg0W;  goto s1_0_0_WWB;
			:: msgs?msg0W;  goto s1_0_0_0WB;
			:: msgs?msg0B;  goto s1_0_0_BWB;
			:: msgs?msg0B;  goto s1_0_0_0WB;
			:: msgs?msg1R;  goto s1_0_0_0RB;
			:: msgs?msg1R;  goto s1_0_0_0WB;
			:: msgs?msg1W;  goto s1_0_0_0WB;
			:: msgs?msg1B;  goto s1_0_0_0BB;
			:: msgs?msg1B;  goto s1_0_0_0WB;
			:: msgs?msg2R;  goto s1_0_0_0WR;
			:: msgs?msg2R;  goto s1_0_0_0WB;
			:: msgs?msg2W;  goto s1_0_0_0WW;
			:: msgs?msg2W;  goto s1_0_0_0WB;
			:: msgs?msg2B;  goto s1_0_0_0WB;
		fi;
	s1_0_0_0BR: if
			:: acks!ack2;  goto s1_0_0_0BR;
			:: msgs?msg0R;  goto s1_0_0_RBR;
			:: msgs?msg0R;  goto s1_0_0_0BR;
			:: msgs?msg0W;  goto s1_0_0_WBR;
			:: msgs?msg0W;  goto s1_0_0_0BR;
			:: msgs?msg0B;  goto s1_0_0_BBR;
			:: msgs?msg0B;  goto s1_0_0_0BR;
			:: msgs?msg1R;  goto s1_0_0_0RR;
			:: msgs?msg1R;  goto s1_0_0_0BR;
			:: msgs?msg1W;  goto s1_0_0_0WR;
			:: msgs?msg1W;  goto s1_0_0_0BR;
			:: msgs?msg1B;  goto s1_0_0_0BR;
			:: msgs?msg2R;  goto s1_0_0_0BR;
			:: msgs?msg2W;  goto s1_0_0_0BW;
			:: msgs?msg2W;  goto s1_0_0_0BR;
			:: msgs?msg2B;  goto s1_0_0_0BB;
			:: msgs?msg2B;  goto s1_0_0_0BR;
		fi;
	s1_0_0_0BW: if
			:: acks!ack2;  goto s1_0_0_0BW;
			:: msgs?msg0R;  goto s1_0_0_RBW;
			:: msgs?msg0R;  goto s1_0_0_0BW;
			:: msgs?msg0W;  goto s1_0_0_WBW;
			:: msgs?msg0W;  goto s1_0_0_0BW;
			:: msgs?msg0B;  goto s1_0_0_BBW;
			:: msgs?msg0B;  goto s1_0_0_0BW;
			:: msgs?msg1R;  goto s1_0_0_0RW;
			:: msgs?msg1R;  goto s1_0_0_0BW;
			:: msgs?msg1W;  goto s1_0_0_0WW;
			:: msgs?msg1W;  goto s1_0_0_0BW;
			:: msgs?msg1B;  goto s1_0_0_0BW;
			:: msgs?msg2R;  goto s1_0_0_0BR;
			:: msgs?msg2R;  goto s1_0_0_0BW;
			:: msgs?msg2W;  goto s1_0_0_0BW;
			:: msgs?msg2B;  goto s1_0_0_0BB;
			:: msgs?msg2B;  goto s1_0_0_0BW;
		fi;
	s1_0_0_0BB: if
			:: acks!ack2;  goto s1_0_0_0BB;
			:: msgs?msg0R;  goto s1_0_0_RBB;
			:: msgs?msg0R;  goto s1_0_0_0BB;
			:: msgs?msg0W;  goto s1_0_0_WBB;
			:: msgs?msg0W;  goto s1_0_0_0BB;
			:: msgs?msg0B;  goto s1_0_0_BBB;
			:: msgs?msg0B;  goto s1_0_0_0BB;
			:: msgs?msg1R;  goto s1_0_0_0RB;
			:: msgs?msg1R;  goto s1_0_0_0BB;
			:: msgs?msg1W;  goto s1_0_0_0WB;
			:: msgs?msg1W;  goto s1_0_0_0BB;
			:: msgs?msg1B;  goto s1_0_0_0BB;
			:: msgs?msg2R;  goto s1_0_0_0BR;
			:: msgs?msg2R;  goto s1_0_0_0BB;
			:: msgs?msg2W;  goto s1_0_0_0BW;
			:: msgs?msg2W;  goto s1_0_0_0BB;
			:: msgs?msg2B;  goto s1_0_0_0BB;
		fi;
	s1_0_0_RRR: if
			:: out!outR;  goto s1_1_1_0RR;
			:: msgs?msg0R;  goto s1_0_0_RRR;
			:: msgs?msg0W;  goto s1_0_0_WRR;
			:: msgs?msg0W;  goto s1_0_0_RRR;
			:: msgs?msg0B;  goto s1_0_0_BRR;
			:: msgs?msg0B;  goto s1_0_0_RRR;
			:: msgs?msg1R;  goto s1_0_0_RRR;
			:: msgs?msg1W;  goto s1_0_0_RWR;
			:: msgs?msg1W;  goto s1_0_0_RRR;
			:: msgs?msg1B;  goto s1_0_0_RBR;
			:: msgs?msg1B;  goto s1_0_0_RRR;
			:: msgs?msg2R;  goto s1_0_0_RRR;
			:: msgs?msg2W;  goto s1_0_0_RRW;
			:: msgs?msg2W;  goto s1_0_0_RRR;
			:: msgs?msg2B;  goto s1_0_0_RRB;
			:: msgs?msg2B;  goto s1_0_0_RRR;
		fi;
	s1_0_0_RRW: if
			:: out!outR;  goto s1_1_1_0RW;
			:: msgs?msg0R;  goto s1_0_0_RRW;
			:: msgs?msg0W;  goto s1_0_0_WRW;
			:: msgs?msg0W;  goto s1_0_0_RRW;
			:: msgs?msg0B;  goto s1_0_0_BRW;
			:: msgs?msg0B;  goto s1_0_0_RRW;
			:: msgs?msg1R;  goto s1_0_0_RRW;
			:: msgs?msg1W;  goto s1_0_0_RWW;
			:: msgs?msg1W;  goto s1_0_0_RRW;
			:: msgs?msg1B;  goto s1_0_0_RBW;
			:: msgs?msg1B;  goto s1_0_0_RRW;
			:: msgs?msg2R;  goto s1_0_0_RRR;
			:: msgs?msg2R;  goto s1_0_0_RRW;
			:: msgs?msg2W;  goto s1_0_0_RRW;
			:: msgs?msg2B;  goto s1_0_0_RRB;
			:: msgs?msg2B;  goto s1_0_0_RRW;
		fi;
	s1_0_0_RRB: if
			:: out!outR;  goto s1_1_1_0RB;
			:: msgs?msg0R;  goto s1_0_0_RRB;
			:: msgs?msg0W;  goto s1_0_0_WRB;
			:: msgs?msg0W;  goto s1_0_0_RRB;
			:: msgs?msg0B;  goto s1_0_0_BRB;
			:: msgs?msg0B;  goto s1_0_0_RRB;
			:: msgs?msg1R;  goto s1_0_0_RRB;
			:: msgs?msg1W;  goto s1_0_0_RWB;
			:: msgs?msg1W;  goto s1_0_0_RRB;
			:: msgs?msg1B;  goto s1_0_0_RBB;
			:: msgs?msg1B;  goto s1_0_0_RRB;
			:: msgs?msg2R;  goto s1_0_0_RRR;
			:: msgs?msg2R;  goto s1_0_0_RRB;
			:: msgs?msg2W;  goto s1_0_0_RRW;
			:: msgs?msg2W;  goto s1_0_0_RRB;
			:: msgs?msg2B;  goto s1_0_0_RRB;
		fi;
	s1_0_0_RWR: if
			:: out!outR;  goto s1_1_1_0WR;
			:: msgs?msg0R;  goto s1_0_0_RWR;
			:: msgs?msg0W;  goto s1_0_0_WWR;
			:: msgs?msg0W;  goto s1_0_0_RWR;
			:: msgs?msg0B;  goto s1_0_0_BWR;
			:: msgs?msg0B;  goto s1_0_0_RWR;
			:: msgs?msg1R;  goto s1_0_0_RRR;
			:: msgs?msg1R;  goto s1_0_0_RWR;
			:: msgs?msg1W;  goto s1_0_0_RWR;
			:: msgs?msg1B;  goto s1_0_0_RBR;
			:: msgs?msg1B;  goto s1_0_0_RWR;
			:: msgs?msg2R;  goto s1_0_0_RWR;
			:: msgs?msg2W;  goto s1_0_0_RWW;
			:: msgs?msg2W;  goto s1_0_0_RWR;
			:: msgs?msg2B;  goto s1_0_0_RWB;
			:: msgs?msg2B;  goto s1_0_0_RWR;
		fi;
	s1_0_0_RWW: if
			:: out!outR;  goto s1_1_1_0WW;
			:: msgs?msg0R;  goto s1_0_0_RWW;
			:: msgs?msg0W;  goto s1_0_0_WWW;
			:: msgs?msg0W;  goto s1_0_0_RWW;
			:: msgs?msg0B;  goto s1_0_0_BWW;
			:: msgs?msg0B;  goto s1_0_0_RWW;
			:: msgs?msg1R;  goto s1_0_0_RRW;
			:: msgs?msg1R;  goto s1_0_0_RWW;
			:: msgs?msg1W;  goto s1_0_0_RWW;
			:: msgs?msg1B;  goto s1_0_0_RBW;
			:: msgs?msg1B;  goto s1_0_0_RWW;
			:: msgs?msg2R;  goto s1_0_0_RWR;
			:: msgs?msg2R;  goto s1_0_0_RWW;
			:: msgs?msg2W;  goto s1_0_0_RWW;
			:: msgs?msg2B;  goto s1_0_0_RWB;
			:: msgs?msg2B;  goto s1_0_0_RWW;
		fi;
	s1_0_0_RWB: if
			:: out!outR;  goto s1_1_1_0WB;
			:: msgs?msg0R;  goto s1_0_0_RWB;
			:: msgs?msg0W;  goto s1_0_0_WWB;
			:: msgs?msg0W;  goto s1_0_0_RWB;
			:: msgs?msg0B;  goto s1_0_0_BWB;
			:: msgs?msg0B;  goto s1_0_0_RWB;
			:: msgs?msg1R;  goto s1_0_0_RRB;
			:: msgs?msg1R;  goto s1_0_0_RWB;
			:: msgs?msg1W;  goto s1_0_0_RWB;
			:: msgs?msg1B;  goto s1_0_0_RBB;
			:: msgs?msg1B;  goto s1_0_0_RWB;
			:: msgs?msg2R;  goto s1_0_0_RWR;
			:: msgs?msg2R;  goto s1_0_0_RWB;
			:: msgs?msg2W;  goto s1_0_0_RWW;
			:: msgs?msg2W;  goto s1_0_0_RWB;
			:: msgs?msg2B;  goto s1_0_0_RWB;
		fi;
	s1_0_0_RBR: if
			:: out!outR;  goto s1_1_1_0BR;
			:: msgs?msg0R;  goto s1_0_0_RBR;
			:: msgs?msg0W;  goto s1_0_0_WBR;
			:: msgs?msg0W;  goto s1_0_0_RBR;
			:: msgs?msg0B;  goto s1_0_0_BBR;
			:: msgs?msg0B;  goto s1_0_0_RBR;
			:: msgs?msg1R;  goto s1_0_0_RRR;
			:: msgs?msg1R;  goto s1_0_0_RBR;
			:: msgs?msg1W;  goto s1_0_0_RWR;
			:: msgs?msg1W;  goto s1_0_0_RBR;
			:: msgs?msg1B;  goto s1_0_0_RBR;
			:: msgs?msg2R;  goto s1_0_0_RBR;
			:: msgs?msg2W;  goto s1_0_0_RBW;
			:: msgs?msg2W;  goto s1_0_0_RBR;
			:: msgs?msg2B;  goto s1_0_0_RBB;
			:: msgs?msg2B;  goto s1_0_0_RBR;
		fi;
	s1_0_0_RBW: if
			:: out!outR;  goto s1_1_1_0BW;
			:: msgs?msg0R;  goto s1_0_0_RBW;
			:: msgs?msg0W;  goto s1_0_0_WBW;
			:: msgs?msg0W;  goto s1_0_0_RBW;
			:: msgs?msg0B;  goto s1_0_0_BBW;
			:: msgs?msg0B;  goto s1_0_0_RBW;
			:: msgs?msg1R;  goto s1_0_0_RRW;
			:: msgs?msg1R;  goto s1_0_0_RBW;
			:: msgs?msg1W;  goto s1_0_0_RWW;
			:: msgs?msg1W;  goto s1_0_0_RBW;
			:: msgs?msg1B;  goto s1_0_0_RBW;
			:: msgs?msg2R;  goto s1_0_0_RBR;
			:: msgs?msg2R;  goto s1_0_0_RBW;
			:: msgs?msg2W;  goto s1_0_0_RBW;
			:: msgs?msg2B;  goto s1_0_0_RBB;
			:: msgs?msg2B;  goto s1_0_0_RBW;
		fi;
	s1_0_0_RBB: if
			:: out!outR;  goto s1_1_1_0BB;
			:: msgs?msg0R;  goto s1_0_0_RBB;
			:: msgs?msg0W;  goto s1_0_0_WBB;
			:: msgs?msg0W;  goto s1_0_0_RBB;
			:: msgs?msg0B;  goto s1_0_0_BBB;
			:: msgs?msg0B;  goto s1_0_0_RBB;
			:: msgs?msg1R;  goto s1_0_0_RRB;
			:: msgs?msg1R;  goto s1_0_0_RBB;
			:: msgs?msg1W;  goto s1_0_0_RWB;
			:: msgs?msg1W;  goto s1_0_0_RBB;
			:: msgs?msg1B;  goto s1_0_0_RBB;
			:: msgs?msg2R;  goto s1_0_0_RBR;
			:: msgs?msg2R;  goto s1_0_0_RBB;
			:: msgs?msg2W;  goto s1_0_0_RBW;
			:: msgs?msg2W;  goto s1_0_0_RBB;
			:: msgs?msg2B;  goto s1_0_0_RBB;
		fi;
	s1_0_0_WRR: if
			:: out!outW;  goto s1_1_1_0RR;
			:: msgs?msg0R;  goto s1_0_0_RRR;
			:: msgs?msg0R;  goto s1_0_0_WRR;
			:: msgs?msg0W;  goto s1_0_0_WRR;
			:: msgs?msg0B;  goto s1_0_0_BRR;
			:: msgs?msg0B;  goto s1_0_0_WRR;
			:: msgs?msg1R;  goto s1_0_0_WRR;
			:: msgs?msg1W;  goto s1_0_0_WWR;
			:: msgs?msg1W;  goto s1_0_0_WRR;
			:: msgs?msg1B;  goto s1_0_0_WBR;
			:: msgs?msg1B;  goto s1_0_0_WRR;
			:: msgs?msg2R;  goto s1_0_0_WRR;
			:: msgs?msg2W;  goto s1_0_0_WRW;
			:: msgs?msg2W;  goto s1_0_0_WRR;
			:: msgs?msg2B;  goto s1_0_0_WRB;
			:: msgs?msg2B;  goto s1_0_0_WRR;
		fi;
	s1_0_0_WRW: if
			:: out!outW;  goto s1_1_1_0RW;
			:: msgs?msg0R;  goto s1_0_0_RRW;
			:: msgs?msg0R;  goto s1_0_0_WRW;
			:: msgs?msg0W;  goto s1_0_0_WRW;
			:: msgs?msg0B;  goto s1_0_0_BRW;
			:: msgs?msg0B;  goto s1_0_0_WRW;
			:: msgs?msg1R;  goto s1_0_0_WRW;
			:: msgs?msg1W;  goto s1_0_0_WWW;
			:: msgs?msg1W;  goto s1_0_0_WRW;
			:: msgs?msg1B;  goto s1_0_0_WBW;
			:: msgs?msg1B;  goto s1_0_0_WRW;
			:: msgs?msg2R;  goto s1_0_0_WRR;
			:: msgs?msg2R;  goto s1_0_0_WRW;
			:: msgs?msg2W;  goto s1_0_0_WRW;
			:: msgs?msg2B;  goto s1_0_0_WRB;
			:: msgs?msg2B;  goto s1_0_0_WRW;
		fi;
	s1_0_0_WRB: if
			:: out!outW;  goto s1_1_1_0RB;
			:: msgs?msg0R;  goto s1_0_0_RRB;
			:: msgs?msg0R;  goto s1_0_0_WRB;
			:: msgs?msg0W;  goto s1_0_0_WRB;
			:: msgs?msg0B;  goto s1_0_0_BRB;
			:: msgs?msg0B;  goto s1_0_0_WRB;
			:: msgs?msg1R;  goto s1_0_0_WRB;
			:: msgs?msg1W;  goto s1_0_0_WWB;
			:: msgs?msg1W;  goto s1_0_0_WRB;
			:: msgs?msg1B;  goto s1_0_0_WBB;
			:: msgs?msg1B;  goto s1_0_0_WRB;
			:: msgs?msg2R;  goto s1_0_0_WRR;
			:: msgs?msg2R;  goto s1_0_0_WRB;
			:: msgs?msg2W;  goto s1_0_0_WRW;
			:: msgs?msg2W;  goto s1_0_0_WRB;
			:: msgs?msg2B;  goto s1_0_0_WRB;
		fi;
	s1_0_0_WWR: if
			:: out!outW;  goto s1_1_1_0WR;
			:: msgs?msg0R;  goto s1_0_0_RWR;
			:: msgs?msg0R;  goto s1_0_0_WWR;
			:: msgs?msg0W;  goto s1_0_0_WWR;
			:: msgs?msg0B;  goto s1_0_0_BWR;
			:: msgs?msg0B;  goto s1_0_0_WWR;
			:: msgs?msg1R;  goto s1_0_0_WRR;
			:: msgs?msg1R;  goto s1_0_0_WWR;
			:: msgs?msg1W;  goto s1_0_0_WWR;
			:: msgs?msg1B;  goto s1_0_0_WBR;
			:: msgs?msg1B;  goto s1_0_0_WWR;
			:: msgs?msg2R;  goto s1_0_0_WWR;
			:: msgs?msg2W;  goto s1_0_0_WWW;
			:: msgs?msg2W;  goto s1_0_0_WWR;
			:: msgs?msg2B;  goto s1_0_0_WWB;
			:: msgs?msg2B;  goto s1_0_0_WWR;
		fi;
	s1_0_0_WWW: if
			:: out!outW;  goto s1_1_1_0WW;
			:: msgs?msg0R;  goto s1_0_0_RWW;
			:: msgs?msg0R;  goto s1_0_0_WWW;
			:: msgs?msg0W;  goto s1_0_0_WWW;
			:: msgs?msg0B;  goto s1_0_0_BWW;
			:: msgs?msg0B;  goto s1_0_0_WWW;
			:: msgs?msg1R;  goto s1_0_0_WRW;
			:: msgs?msg1R;  goto s1_0_0_WWW;
			:: msgs?msg1W;  goto s1_0_0_WWW;
			:: msgs?msg1B;  goto s1_0_0_WBW;
			:: msgs?msg1B;  goto s1_0_0_WWW;
			:: msgs?msg2R;  goto s1_0_0_WWR;
			:: msgs?msg2R;  goto s1_0_0_WWW;
			:: msgs?msg2W;  goto s1_0_0_WWW;
			:: msgs?msg2B;  goto s1_0_0_WWB;
			:: msgs?msg2B;  goto s1_0_0_WWW;
		fi;
	s1_0_0_WWB: if
			:: out!outW;  goto s1_1_1_0WB;
			:: msgs?msg0R;  goto s1_0_0_RWB;
			:: msgs?msg0R;  goto s1_0_0_WWB;
			:: msgs?msg0W;  goto s1_0_0_WWB;
			:: msgs?msg0B;  goto s1_0_0_BWB;
			:: msgs?msg0B;  goto s1_0_0_WWB;
			:: msgs?msg1R;  goto s1_0_0_WRB;
			:: msgs?msg1R;  goto s1_0_0_WWB;
			:: msgs?msg1W;  goto s1_0_0_WWB;
			:: msgs?msg1B;  goto s1_0_0_WBB;
			:: msgs?msg1B;  goto s1_0_0_WWB;
			:: msgs?msg2R;  goto s1_0_0_WWR;
			:: msgs?msg2R;  goto s1_0_0_WWB;
			:: msgs?msg2W;  goto s1_0_0_WWW;
			:: msgs?msg2W;  goto s1_0_0_WWB;
			:: msgs?msg2B;  goto s1_0_0_WWB;
		fi;
	s1_0_0_WBR: if
			:: out!outW;  goto s1_1_1_0BR;
			:: msgs?msg0R;  goto s1_0_0_RBR;
			:: msgs?msg0R;  goto s1_0_0_WBR;
			:: msgs?msg0W;  goto s1_0_0_WBR;
			:: msgs?msg0B;  goto s1_0_0_BBR;
			:: msgs?msg0B;  goto s1_0_0_WBR;
			:: msgs?msg1R;  goto s1_0_0_WRR;
			:: msgs?msg1R;  goto s1_0_0_WBR;
			:: msgs?msg1W;  goto s1_0_0_WWR;
			:: msgs?msg1W;  goto s1_0_0_WBR;
			:: msgs?msg1B;  goto s1_0_0_WBR;
			:: msgs?msg2R;  goto s1_0_0_WBR;
			:: msgs?msg2W;  goto s1_0_0_WBW;
			:: msgs?msg2W;  goto s1_0_0_WBR;
			:: msgs?msg2B;  goto s1_0_0_WBB;
			:: msgs?msg2B;  goto s1_0_0_WBR;
		fi;
	s1_0_0_WBW: if
			:: out!outW;  goto s1_1_1_0BW;
			:: msgs?msg0R;  goto s1_0_0_RBW;
			:: msgs?msg0R;  goto s1_0_0_WBW;
			:: msgs?msg0W;  goto s1_0_0_WBW;
			:: msgs?msg0B;  goto s1_0_0_BBW;
			:: msgs?msg0B;  goto s1_0_0_WBW;
			:: msgs?msg1R;  goto s1_0_0_WRW;
			:: msgs?msg1R;  goto s1_0_0_WBW;
			:: msgs?msg1W;  goto s1_0_0_WWW;
			:: msgs?msg1W;  goto s1_0_0_WBW;
			:: msgs?msg1B;  goto s1_0_0_WBW;
			:: msgs?msg2R;  goto s1_0_0_WBR;
			:: msgs?msg2R;  goto s1_0_0_WBW;
			:: msgs?msg2W;  goto s1_0_0_WBW;
			:: msgs?msg2B;  goto s1_0_0_WBB;
			:: msgs?msg2B;  goto s1_0_0_WBW;
		fi;
	s1_0_0_WBB: if
			:: out!outW;  goto s1_1_1_0BB;
			:: msgs?msg0R;  goto s1_0_0_RBB;
			:: msgs?msg0R;  goto s1_0_0_WBB;
			:: msgs?msg0W;  goto s1_0_0_WBB;
			:: msgs?msg0B;  goto s1_0_0_BBB;
			:: msgs?msg0B;  goto s1_0_0_WBB;
			:: msgs?msg1R;  goto s1_0_0_WRB;
			:: msgs?msg1R;  goto s1_0_0_WBB;
			:: msgs?msg1W;  goto s1_0_0_WWB;
			:: msgs?msg1W;  goto s1_0_0_WBB;
			:: msgs?msg1B;  goto s1_0_0_WBB;
			:: msgs?msg2R;  goto s1_0_0_WBR;
			:: msgs?msg2R;  goto s1_0_0_WBB;
			:: msgs?msg2W;  goto s1_0_0_WBW;
			:: msgs?msg2W;  goto s1_0_0_WBB;
			:: msgs?msg2B;  goto s1_0_0_WBB;
		fi;
	s1_0_0_BRR: if
			:: out!outB;  goto s1_1_1_0RR;
			:: msgs?msg0R;  goto s1_0_0_RRR;
			:: msgs?msg0R;  goto s1_0_0_BRR;
			:: msgs?msg0W;  goto s1_0_0_WRR;
			:: msgs?msg0W;  goto s1_0_0_BRR;
			:: msgs?msg0B;  goto s1_0_0_BRR;
			:: msgs?msg1R;  goto s1_0_0_BRR;
			:: msgs?msg1W;  goto s1_0_0_BWR;
			:: msgs?msg1W;  goto s1_0_0_BRR;
			:: msgs?msg1B;  goto s1_0_0_BBR;
			:: msgs?msg1B;  goto s1_0_0_BRR;
			:: msgs?msg2R;  goto s1_0_0_BRR;
			:: msgs?msg2W;  goto s1_0_0_BRW;
			:: msgs?msg2W;  goto s1_0_0_BRR;
			:: msgs?msg2B;  goto s1_0_0_BRB;
			:: msgs?msg2B;  goto s1_0_0_BRR;
		fi;
	s1_0_0_BRW: if
			:: out!outB;  goto s1_1_1_0RW;
			:: msgs?msg0R;  goto s1_0_0_RRW;
			:: msgs?msg0R;  goto s1_0_0_BRW;
			:: msgs?msg0W;  goto s1_0_0_WRW;
			:: msgs?msg0W;  goto s1_0_0_BRW;
			:: msgs?msg0B;  goto s1_0_0_BRW;
			:: msgs?msg1R;  goto s1_0_0_BRW;
			:: msgs?msg1W;  goto s1_0_0_BWW;
			:: msgs?msg1W;  goto s1_0_0_BRW;
			:: msgs?msg1B;  goto s1_0_0_BBW;
			:: msgs?msg1B;  goto s1_0_0_BRW;
			:: msgs?msg2R;  goto s1_0_0_BRR;
			:: msgs?msg2R;  goto s1_0_0_BRW;
			:: msgs?msg2W;  goto s1_0_0_BRW;
			:: msgs?msg2B;  goto s1_0_0_BRB;
			:: msgs?msg2B;  goto s1_0_0_BRW;
		fi;
	s1_0_0_BRB: if
			:: out!outB;  goto s1_1_1_0RB;
			:: msgs?msg0R;  goto s1_0_0_RRB;
			:: msgs?msg0R;  goto s1_0_0_BRB;
			:: msgs?msg0W;  goto s1_0_0_WRB;
			:: msgs?msg0W;  goto s1_0_0_BRB;
			:: msgs?msg0B;  goto s1_0_0_BRB;
			:: msgs?msg1R;  goto s1_0_0_BRB;
			:: msgs?msg1W;  goto s1_0_0_BWB;
			:: msgs?msg1W;  goto s1_0_0_BRB;
			:: msgs?msg1B;  goto s1_0_0_BBB;
			:: msgs?msg1B;  goto s1_0_0_BRB;
			:: msgs?msg2R;  goto s1_0_0_BRR;
			:: msgs?msg2R;  goto s1_0_0_BRB;
			:: msgs?msg2W;  goto s1_0_0_BRW;
			:: msgs?msg2W;  goto s1_0_0_BRB;
			:: msgs?msg2B;  goto s1_0_0_BRB;
		fi;
	s1_0_0_BWR: if
			:: out!outB;  goto s1_1_1_0WR;
			:: msgs?msg0R;  goto s1_0_0_RWR;
			:: msgs?msg0R;  goto s1_0_0_BWR;
			:: msgs?msg0W;  goto s1_0_0_WWR;
			:: msgs?msg0W;  goto s1_0_0_BWR;
			:: msgs?msg0B;  goto s1_0_0_BWR;
			:: msgs?msg1R;  goto s1_0_0_BRR;
			:: msgs?msg1R;  goto s1_0_0_BWR;
			:: msgs?msg1W;  goto s1_0_0_BWR;
			:: msgs?msg1B;  goto s1_0_0_BBR;
			:: msgs?msg1B;  goto s1_0_0_BWR;
			:: msgs?msg2R;  goto s1_0_0_BWR;
			:: msgs?msg2W;  goto s1_0_0_BWW;
			:: msgs?msg2W;  goto s1_0_0_BWR;
			:: msgs?msg2B;  goto s1_0_0_BWB;
			:: msgs?msg2B;  goto s1_0_0_BWR;
		fi;
	s1_0_0_BWW: if
			:: out!outB;  goto s1_1_1_0WW;
			:: msgs?msg0R;  goto s1_0_0_RWW;
			:: msgs?msg0R;  goto s1_0_0_BWW;
			:: msgs?msg0W;  goto s1_0_0_WWW;
			:: msgs?msg0W;  goto s1_0_0_BWW;
			:: msgs?msg0B;  goto s1_0_0_BWW;
			:: msgs?msg1R;  goto s1_0_0_BRW;
			:: msgs?msg1R;  goto s1_0_0_BWW;
			:: msgs?msg1W;  goto s1_0_0_BWW;
			:: msgs?msg1B;  goto s1_0_0_BBW;
			:: msgs?msg1B;  goto s1_0_0_BWW;
			:: msgs?msg2R;  goto s1_0_0_BWR;
			:: msgs?msg2R;  goto s1_0_0_BWW;
			:: msgs?msg2W;  goto s1_0_0_BWW;
			:: msgs?msg2B;  goto s1_0_0_BWB;
			:: msgs?msg2B;  goto s1_0_0_BWW;
		fi;
	s1_0_0_BWB: if
			:: out!outB;  goto s1_1_1_0WB;
			:: msgs?msg0R;  goto s1_0_0_RWB;
			:: msgs?msg0R;  goto s1_0_0_BWB;
			:: msgs?msg0W;  goto s1_0_0_WWB;
			:: msgs?msg0W;  goto s1_0_0_BWB;
			:: msgs?msg0B;  goto s1_0_0_BWB;
			:: msgs?msg1R;  goto s1_0_0_BRB;
			:: msgs?msg1R;  goto s1_0_0_BWB;
			:: msgs?msg1W;  goto s1_0_0_BWB;
			:: msgs?msg1B;  goto s1_0_0_BBB;
			:: msgs?msg1B;  goto s1_0_0_BWB;
			:: msgs?msg2R;  goto s1_0_0_BWR;
			:: msgs?msg2R;  goto s1_0_0_BWB;
			:: msgs?msg2W;  goto s1_0_0_BWW;
			:: msgs?msg2W;  goto s1_0_0_BWB;
			:: msgs?msg2B;  goto s1_0_0_BWB;
		fi;
	s1_0_0_BBR: if
			:: out!outB;  goto s1_1_1_0BR;
			:: msgs?msg0R;  goto s1_0_0_RBR;
			:: msgs?msg0R;  goto s1_0_0_BBR;
			:: msgs?msg0W;  goto s1_0_0_WBR;
			:: msgs?msg0W;  goto s1_0_0_BBR;
			:: msgs?msg0B;  goto s1_0_0_BBR;
			:: msgs?msg1R;  goto s1_0_0_BRR;
			:: msgs?msg1R;  goto s1_0_0_BBR;
			:: msgs?msg1W;  goto s1_0_0_BWR;
			:: msgs?msg1W;  goto s1_0_0_BBR;
			:: msgs?msg1B;  goto s1_0_0_BBR;
			:: msgs?msg2R;  goto s1_0_0_BBR;
			:: msgs?msg2W;  goto s1_0_0_BBW;
			:: msgs?msg2W;  goto s1_0_0_BBR;
			:: msgs?msg2B;  goto s1_0_0_BBB;
			:: msgs?msg2B;  goto s1_0_0_BBR;
		fi;
	s1_0_0_BBW: if
			:: out!outB;  goto s1_1_1_0BW;
			:: msgs?msg0R;  goto s1_0_0_RBW;
			:: msgs?msg0R;  goto s1_0_0_BBW;
			:: msgs?msg0W;  goto s1_0_0_WBW;
			:: msgs?msg0W;  goto s1_0_0_BBW;
			:: msgs?msg0B;  goto s1_0_0_BBW;
			:: msgs?msg1R;  goto s1_0_0_BRW;
			:: msgs?msg1R;  goto s1_0_0_BBW;
			:: msgs?msg1W;  goto s1_0_0_BWW;
			:: msgs?msg1W;  goto s1_0_0_BBW;
			:: msgs?msg1B;  goto s1_0_0_BBW;
			:: msgs?msg2R;  goto s1_0_0_BBR;
			:: msgs?msg2R;  goto s1_0_0_BBW;
			:: msgs?msg2W;  goto s1_0_0_BBW;
			:: msgs?msg2B;  goto s1_0_0_BBB;
			:: msgs?msg2B;  goto s1_0_0_BBW;
		fi;
	s1_0_0_BBB: if
			:: out!outB;  goto s1_1_1_0BB;
			:: msgs?msg0R;  goto s1_0_0_RBB;
			:: msgs?msg0R;  goto s1_0_0_BBB;
			:: msgs?msg0W;  goto s1_0_0_WBB;
			:: msgs?msg0W;  goto s1_0_0_BBB;
			:: msgs?msg0B;  goto s1_0_0_BBB;
			:: msgs?msg1R;  goto s1_0_0_BRB;
			:: msgs?msg1R;  goto s1_0_0_BBB;
			:: msgs?msg1W;  goto s1_0_0_BWB;
			:: msgs?msg1W;  goto s1_0_0_BBB;
			:: msgs?msg1B;  goto s1_0_0_BBB;
			:: msgs?msg2R;  goto s1_0_0_BBR;
			:: msgs?msg2R;  goto s1_0_0_BBB;
			:: msgs?msg2W;  goto s1_0_0_BBW;
			:: msgs?msg2W;  goto s1_0_0_BBB;
			:: msgs?msg2B;  goto s1_0_0_BBB;
		fi;
}

active proctype env()
{
	s0: if
			:: in!inR;  goto s0;
			:: in!inW;  goto s0;
			:: in!inB;  goto s0;
			:: out?outR;  goto s0;
			:: out?outW;  goto s0;
			:: out?outB;  goto s0;
		fi;
}

trace
{
	s0: if
			:: msgs?msg0W;  goto s1;
			:: msgs?msg1W;  goto s1;
			:: msgs?msg2W;  goto s1;
			:: msgs?msg0R;  goto s0;
			:: msgs?msg0B;  goto s0;
			:: msgs?msg1R;  goto s0;
			:: msgs?msg1B;  goto s0;
			:: msgs?msg2R;  goto s0;
			:: msgs?msg2B;  goto s0;
			:: acks?ack0;  goto s0;
			:: acks?ack1;  goto s0;
			:: acks?ack2;  goto s0;
			:: in?inR;  goto s0;
			:: in?inW;  goto s0;
			:: in?inB;  goto s0;
			:: out?outR;  goto s0;
			:: out?outB;  goto s0;
		fi;
	s1: if
			:: msgs?msg0R;  goto s1;
			:: msgs?msg0W;  goto s1;
			:: msgs?msg0B;  goto s1;
			:: msgs?msg1R;  goto s1;
			:: msgs?msg1W;  goto s1;
			:: msgs?msg1B;  goto s1;
			:: msgs?msg2R;  goto s1;
			:: msgs?msg2W;  goto s1;
			:: msgs?msg2B;  goto s1;
			:: acks?ack0;  goto s1;
			:: acks?ack1;  goto s1;
			:: acks?ack2;  goto s1;
			:: in?inR;  goto s1;
			:: in?inW;  goto s1;
			:: in?inB;  goto s1;
			:: out?outR;  goto s1;
			:: out?outW;  goto s1;
			:: out?outB;  goto s1;
		fi;
}
